/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mitaka.h"
#include  "mtk_draw_struct.h"
#include  "mitaka.h"
#include  "mtk_switches.h"
#include  "mtk_camera.h"
#include  "mtk_camera_setting.h"
#include  "mtk_target.h"
#include  "mtk_planetarium.h"
#include  "mtk_planet_orientation.h"


//-----------
//  Externs
//-----------
extern char  tyMode;



void
mtk_draw_struct::set(const mtk_camera& _camera, const double& _JD, int _w, int _h, const float font_size)
{
	JD				= _JD;
	camera_base 	= _camera;
	camera			= camera_base;
	tgt				= get_current_target();
	target_pos		= get_current_target_pos();
	scale_factor	= camera.get_scale_factor();
	scale			= get_clst_R() / scale_factor;
	plnt_R			= get_plnt_R();
	plnt_angle		= get_plnt_angle();
	w				= _w;
	h				= _h;
	frs				= get_frustum_near(w, h);
	lang			= get_language();
	rad_per_pixel	= get_rad_per_pixel(w, h);
	ltf				= 1.2f * font_size;


	//--------------
	//  J̐ݒ
	//--------------
	vector3d  eF, eU, eR;
	quaterniond  qr;

	if (tyMode == MODE_HIPPARCOS) {
		if (tgt.cls == TGTCLS_PLANET && get_landing_mode()==LANDING_MODE_HORIZONTAL) {
			const double R = get_target_radius();
			const double Rc = 2*R;
			const double R1 = 1.002*R;
			const double L = norm(camera.get_pos() - get_target_center_pos());
			const double th_max = (90.0 + 5.0) * D2R;

			if (L < Rc) {
				const double fac = (L < R1)  ?  1  :  (asin(R1/L) - asin(R1/Rc)) / (asin(1.0) - asin(R1/Rc));
				double a;
				if (fac > 0.5) {
					a = (1 - fac)/0.5;
					a = 1 - 0.5*a*a;
				} else {
					a = fac/0.5;
					a = 0.5*a*a;
				}
				const double th = th_max * a;

				camera_base.get_axes(eF, eU, eR);
				qr = make_rotation_quaternion(th, eR);
				camera_base.set_ori( qr * camera.get_ori() );
			}
		}
	}


	camera = camera_base;
	camera.get_axes(eF, eU, eR);
	camera.set_ori( camera.get_ori() * get_local_camera_orientation() );

	if (tyMode == MODE_HIPPARCOS) {
		camera.set_pos( camera.get_pos() );
	} else {
	}



	//----------------------------
	//  W王_Wւ̕ϊ
	//----------------------------
	matrix3d  Moc, Mbc, Mlc, Mtot;
	Moc = quaternion_to_matrix3( camera_base.get_ori().inv() );				// ec to obj
	Moc *= scale_factor;
	Mbc = quaternion_to_matrix3( get_base_camera_ori().inv() );				// obj to base
	Mlc = quaternion_to_matrix3( get_local_camera_orientation().inv() );	// base to local
	M_view = Mlc * Mbc * Moc;

	// _Wnł̉Wň_W߂
	vector3d  ro;
	ro = -Moc * camera.get_pos();					// world -> object
	ro = Mbc * (ro);								// objct -> base
	ro = Mlc * (ro - get_local_camera_pos());		// base -> local
	r_view = ro;
}
