/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_fixed_object.h"
#include  "mtk_object.h"
#include  "mtk_calc_alpha.h"
#include  "mtk_switches.h"
#include  "../common/astro/astro_const.h"
#include  <vector>


struct fixed_object
{
	vector3d  pos;
	int  obj_type;
};

static  std::vector<fixed_object>	vFixedObjects;

int
add_fixed_object(const vector3d& pos, int obj_type)
{
	fixed_object  fo;
	fo.pos = pos;
	fo.obj_type = obj_type;


	vFixedObjects.push_back( fo );
	return  vFixedObjects.size() - 1;
}

vector3d
get_fixed_object_position(int idx)
{
	return  vFixedObjects[idx].pos;
}

int
get_fixed_object_type(int idx)
{
	return  vFixedObjects[idx].obj_type;
}

float
get_fixed_object_label_alpha(const mtk_draw_struct& ds, int idx)
{
	float alp = 1.0f;
	switch  ( vFixedObjects[idx].obj_type ) {
		case OBJ_TYPE_SMALL_OBJECT:
			alp =  calc_alpha_by_disapear_scale_inside( ds.scale, 2.3*_1AU_pc );
			break;
		default:
			break;
	}

	const vector3d& pos  = vFixedObjects[idx].pos;
	const vector3d  rpos = pos - ds.camera.get_pos();
	float  Rv = pos.norm();

	return  alp * calc_alpha_by_apparent_diameter( rpos, Rv, 10*D2R );
}


bool
is_fixed_object_label_visible(int idx)
{
	switch  ( vFixedObjects[idx].obj_type ) {
		case OBJ_TYPE_SMALL_OBJECT:
			return  (test_disp_switch(DISPSW_MINOR_PLANET, DISPM_DISP) && test_disp_switch(DISPSW_MINOR_PLANET, DISPM_NAME));
		default:	break;
	}

	return  true;
}
