/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  "mtk_label.h"
#include  <vector>
#include  <string>
#include  "mtk_gl_common.h"
#include  "mtk_draw_struct.h"
#include  "mtk_font.h"
#include  "mtk_colors.h"
#include  "mtk_object.h"
#include  "mtk_object_position.h"
#include  "mtk_planet_position.h"
#include  "mtk_planets.h"
#include  "mtk_minor_planets.h"
#include  "mtk_switches.h"
#include  "mtk_planetarium.h"


struct  mtk_label {
	mtk_object  obj;	// eIuWFNg
	int   color_no;
	float alp;			// x
	float size;			// TCY
	float R;			// V̂̃x̕\ʒu̔a
	float thc;			// tF[h̊ɂȂ鎋a(rad) 
	std::string	 name_E, name_J;
};
static  std::vector<mtk_label>  vLabels;

int
add_label(const char* name_J, const char* name_E, const mtk_object& obj, int color_no, float alpha, float size, float R,
		  float thc)
{
	mtk_label  lbl;
	lbl.obj			= obj;
	lbl.color_no	= color_no;
	lbl.alp			= alpha;
	lbl.size		= size;
	lbl.R			= R;	
	lbl.thc			= thc;
	lbl.name_E		= name_E;
	lbl.name_J		= name_J;
	vLabels.push_back( lbl );

	return  vLabels.size() - 1;
}

vector3d
get_label_position(int idx)
{
	const mtk_label&  lbl = vLabels[idx];
	return  get_object_positon( lbl.obj );
}

float
get_label_letter_size(int idx)
{
	return  vLabels[idx].size;
}

int
get_label_letter_count(int idx, bool bEnglish)
{
	if (bEnglish)	return  vLabels[idx].name_E.size();
	else			return  vLabels[idx].name_J.size();
}

const char*
get_label_text(int idx, bool bEnglish)
{
	if (bEnglish)	return  vLabels[idx].name_E.c_str();
	else			return  vLabels[idx].name_J.c_str();
}

//**********
void
draw_sun_label(const mtk_draw_struct& ds, float af)
{
	const bilingual bszSun			= { "Sun",			"{z|悤}" };
	const bilingual bszSolarSystem	= { "Solar System",	"{zn|悤}" };
	const float scale  =  ds.scale;

	//---  XP[ɂ\ς  ---
	const double scl1 = 20;
	const double scl2 = 80;
	const RGBf& col = get_color(MTK_COLOR_NAME_SPECIAL_OBJECT);
	if (scale < scl1) {
		// z
		glColor4f(col.r, col.g, col.b, af);
		draw_bilingual(bszSun);
	} else if (scale > scl2) {
		// zn
		glColor4f(col.r, col.g, col.b, af);
		draw_bilingual(bszSolarSystem);
	} else {
		// ؂ւ̏ꍇ
		const double logscl = log(scale);
		const double logscl1 = log(scl1);
		const double logscl2 = log(scl2);
		float t;
		float af1, af2;
		t = (logscl - logscl1) / (logscl2 - logscl1);
		af1 = (1-t) * af;
		af2 = t * af;
		// z
		glColor4f(col.r, col.g, col.b, af1);
		glPushMatrix();
		draw_bilingual(bszSun);
		glPopMatrix();
		// zn
		glColor4f(col.r, col.g, col.b, af2);
		glPushMatrix();
			glTranslatef(0,0,0.01);
			draw_bilingual(bszSolarSystem);
		glPopMatrix();
	}
}

void
draw_a_label(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl, float dz)
{
	const mtk_label& label = vLabels[idx];
	const mtk_object& obj = label.obj;
	if ( !is_object_label_visible(obj) )  return;

	//--  x̐ݒ
	float lv = get_label_alpha( ds, obj );
	if (lv < 0.05f)  return;
	int type = obj.get_type();
	float fac = 1.0f;
	if (tyMode == MODE_HIPPARCOS) {
		if (type == OBJ_TYPE_PLANET) {
			fac = get_zoom_rate().zmhPlanet;
		}
		if (type == OBJ_TYPE_SATELLITE && obj.get_index()==SAT_MOON) {
			fac = get_zoom_rate().zmhPlanet;
		}
		if (type == OBJ_TYPE_SUN) {
			fac = get_zoom_rate().zmhSun;
		}
	} else {
		if (type == OBJ_TYPE_PLANET) {
			fac = get_zoom_rate().zmpPlanet;
		}
		if (type == OBJ_TYPE_SATELLITE && obj.get_index()==SAT_MOON) {
			fac = get_zoom_rate().zmpSunMoon;
		}
		if (type == OBJ_TYPE_SUN) {
			fac = get_zoom_rate().zmpSunMoon;
		}

		fac *= get_plnt_R();	//***
	}

	//--  `
	glPushMatrix();
		glTranslatef(rpos.x, rpos.y, rpos.z);
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_LIGHTING);
		glEnable(GL_BLEND);
		prepare_3Dtext_1(scl*label.R*fac, 45, label.size*ds.ltf, ds.scale_factor, false);

		glTranslatef(0, 0, dz);

		if ( label.obj.get_type() == OBJ_TYPE_SUN) {
			draw_sun_label(ds, lv* label.alp);
		} else {
			const RGBf &col = get_color( label.color_no );
			glColor4f(col.r, col.g, col.b, lv * label.alp);
			if ( ds.lang == LANG_ENG )		draw_text( label.name_E.c_str() );
			else							draw_text( label.name_J.c_str() );
		}
	glPopMatrix();
}
