/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  <stdio.h>
#include  "../common/graphics/gl_common.h"
#include  "../common/graphics/gltext.h"
#include  "../common/math/vector3.h"
#include  "../common/astro/astro_const.h"
#include  "../common/graphics/topograph.h"
#include  "mtk_place_name_earth_mars.h"
#include  "../common/graphics/image.h"



//-------
//  n
//-------
struct place_name {
	const char *szNameE, *szNameJ;
	float	lon, lat;
	float	R1, R2;
	char	group;
	char	ty;
	char	align;
};


void
init_place_name(PlaceName& pn, const place_name vPn[], const int N)
{
	pn.clear();
	for (int i=0; i<N; i++) {
		const place_name& pni0 = vPn[i];

		PlaceNameItem  pni;
		pni.lon = pni0.lon;
		pni.lat = pni0.lat;
		bilingual  bszName;
		bszName.text_E = pni0.szNameE;
		bszName.text_J = pni0.szNameJ;
		pni.bszName = bszName;
		pni.R1 = pni0.R1;
		pni.R2 = pni0.R2;
		pni.group = pni0.group;
		pni.ty = pni0.ty;
		pni.align = pni0.align;
		pni.state = PNSTATE_ON;
		pni.alp = 1.0f;
		pni.label_alp = 1.0f;
		pni.bDispLabel = true;
		float size;
		

		switch (pni.ty) {
			case 0:	size = 1.0;	break;
			case 1:	size = 1.0;	break;
			case 2:	size = 0.8;	break;
			default:size = 1.0;	break;
		}
		
		pni.size = size;
		pn.add_place(pni);
	}
}





//------------
//  n̒n
//------------
const float _R1 = 0.1;
const float _R2 = 0.01;
const float _R1r = 0.3 * _R1;
const float _R2r = 0.3 * _R2;


const place_name  EarthPlace[] = {
	//-- 
	{ "North Pole",		"k",				0.0,  90.0,			_R1,  _R2,  0,0, 'R' },
	{ "South Pole",		"",				0.0, -90.0,			_R1,  _R2,  0,0, 'R' },
	//-- R
	{ "Mt. Everest",	"GxXgR",		 86.92f,  27.97f,	_R1r, _R2r, 0,2, 'R' },
	{ "Mt. Blanc",		"uR",		   6.7f,   45.8f,	_R1r, _R2r, 0,2, 'R' },
	{ "Kilimanjaro Mt.","L}WR",	  37.1f,   -3.1f,	_R1r, _R2r, 0,2, 'R' },
	{ "Mt. McKinley",	"}bL[R",		-151.0f,  63.04f,	_R1r, _R2r, 0,2, 'R' },
	{ "Cerro Aconcagua","ARJOAR",		-70.01f, -32.39f,	_R1r, _R2r, 0,2, 'R' },
	//-- C
	{ "Black Sea",		"C",				  34.0f,   43.0f,	_R1r, _R2r, 0,2, 'R' },
	//-- 
	{ "Caspian Sea",	"JXsC",			  50.0f,   42.0f,	_R1r, _R2r, 0,2, 'R' },
	{ "L. Victoria",	"rNgA",		  33.0f,   -1.0f,	_R1r, _R2r, 0,2, 'R' },
	//-- 
	{ "Hawai`i I.",		"nC",			-155.9f,   18.9f,	_R1,  _R2,  0,0, 'l' },

	//-- 
	{ "Japan",			"{",				 137.8f,   37.5f,	_R1,  _R2,  0,0, 'R' },

	//-- V䓙
	{ "NAOJ",			"V",			 139.55f,  35.67f,	_R1r, _R2r, 0,1, 'R' },
	{ "SUBARU",			"΂]",		-155.48f, 19.83f,		0.5*_R1r, _R2r, 0,1, 'L' },
	{ "ALMA",			"ALMAϑ",	 -67.75f, -23.02f,			_R1r, _R2r, 0,2, 'R' },
	{ "Hilo",			"q",			-155.089f, 19.703f,			0.5*_R1r, _R2r, 0,1, 'R' },
};


const int Earth_placeN = sizeof(EarthPlace)/sizeof(EarthPlace[0]);



void
init_Earth_place_name(PlaceName& pn)
{
	init_place_name(pn, EarthPlace, Earth_placeN);
}








//------------
//  ΐ̒n
//------------
const int Mars_placeN = 29;
const place_name  MarsPlace[Mars_placeN] =
{
	//-- Pole
	{ "North Polar Cap",	"kɊ",			  0.0,  90.0,  _R1, _R2,	0,0, 'R' },
	{ "South Polar Cap",	"Ɋ",			  0.0, -90.0,  _R1, _R2,	0,0, 'R' },
	//-- Mons
	{ "Olympus Mons.",		"I|XR",		360-134.0,  18.6,  _R1, _R2,	0,0, 'R' },
	{ "Tharsis Montes.",	"^VXOR",		360-112.5,   1.2,  _R1, _R2,	0,0, 'R' },
	{ "Elysium Mons.",		"GVER",		360-213.1,  25.0,  _R1, _R2,	0,0, 'R' },
	//-- Vallis
	{ "Valles Marineris",	"}lXJ",		 360-59.2, -13.9,  _R1, _R2,	0,0, 'R' },
	//-- Planum
	{ "Syrtis Major",		"V`X",			360-290.5,   8.5,  _R1, _R2,	0,0, 'R' },
	{ "Meridiani Planum",	"fBAj",	  360-2.5,   0.2,  _R1, _R2,	0,0, 'R' },
	//-- Planitia
	{ "Hellas",				"wX", 			360-290.0, -43.0,  _R1, _R2,	0,0, 'R' },
	{ "Elysium Planitia",	"GVE",		360-205.0,   2.0,  _R1, _R2,	0,0, 'R' },
	{ "Argyre Planitia",	"AM",		 360-44.0, -50.0,  _R1, _R2,	0,0, 'R' },
	{ "Acidalia Planitia",	"AL_A",		 360-22.0,  47.0,  _R1, _R2,	0,0, 'R' },
	{ "Isidis Planitia",	"CVfBX",		360-273.0,  13.0,  _R1, _R2,	0,0, 'R' },
	{ "Chryse Planitia",	"NZ",		 360-40.0,  27.0,  _R1, _R2,	0,0, 'R' },
	{ "Arcadia Planitia",	"AJfBA",	360-168.0,  47.0,  _R1, _R2,	0,0, 'R' },
	{ "Utopia Planitia",	"[gsA",		360-242.0,  50.0,  _R1, _R2,	0,0, 'R' },
	{ "Amazonis Planitia",	"A}]jX",		360-164.0,  25.0,  _R1, _R2,	0,0, 'R' },
	//-- Crater
	{ "Gusev Crater",		"OZtN[^",		360-184.6, -14.7,  _R1, _R2,	0,0, 'R' },
	{ "Huygens Crater",		"zCwXN[^",	360-304.6, -14.3,  _R1, _R2,	0,0, 'R' },
	//-- Patera
	{ "Alba Patera",		"AoEpeΎR",	360-109.6,  40.8,  _R1, _R2,	0,0, 'R' },
	//-- Tholus
	{ "Tharsis Tholus",		"^VXEg[X",	 360-90.8,  13.5,  _R1, _R2,	0,0, 'R' },
	//-- Mensae
	{ "Cydonia Mensae",		"VhjAn",		 360-9.6,  40.8,  _R1, _R2,		0,0, 'R' },
	//-- Labyrinthus
	{ "Noctis Labyrinthus",	"mNeBXErgDX",	102.2,  -7.0,  _R1, _R2, 0,0, 'R' },
	//
	{ "Cerberus",			"PxX",			360-205.0,  15.0,  _R1, _R2,	0,0, 'R' },

	//-- Rover
	{ "Spirit",				"Xsbg",			360-185.0, -14.64,  _R1r, _R2r,	0,1, 'R' },
	{ "Opportunity",		"I|`jeB",		  360-6.0, - 2.06,  _R1r, _R2r,	0,1, 'R' },
	{ "Mars Pathfinder",	"}[YEpXt@C_",	360-33.55,  19.33,  _R1r, _R2r, 1, 'R' },
	{ "Viking1",			"oCLOP",		 360-48.0,  22.00,  _R1r, _R2r,	0,1, 'R' },
	{ "Viking2",			"oCLOQ",		360-226.0,  48.00,  _R1r, _R2r,	0,1, 'R' }
};


void
init_Mars_place_name(PlaceName& pn)
{
	init_place_name(pn, MarsPlace, Mars_placeN);
}
