/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mitaka.h"
#include  "mtk_planet_position.h"
#include  "mtk_planets.h"
#include  "../common/astro/astro_const.h"
#include  "../common/astro/astrometry.h"
#include  "../common/astro/cele_mech.h"
#include  "../common/astro/cf96.h"
#include  "mtk_orbital_element.h"
#include  "mtk_planet_orientation.h"
#include  "mtk_lunar_pos.h"
#include  "mtk_switches.h"


//----------
//  Tables
//----------

//---  f̋Ovf  ---//
struct planet_orbital_elements {
    double epoch;	// (JD)
	double a;		// Oa(AU)
	double e;		// OS
	double T;		// ]iNj...gp
	double i;		// OXpixj
	double node;	// _oixj
	double omg_bar;	// ߓ_oixj
	double L;		// ωoixj
};

const double JD0 = 2452640.5;	//  = 2003/1/1.0
const planet_orbital_elements  plnt_oe[] = {
	{ JD0,  0.38710, 0.20563,   0.240852,  7.0050,  48.3665,  77.5028,  55.4500 },			// 
	{ JD0,  0.72333, 0.00677,   0.615207,  3.3947,  76.7069, 131.6058, 137.1556 },			// 
	{ JD0,  1.00000, 0.01671,   1.000040,  0.0000,   0.0000, 102.9889, 100.2431 },			// n
	{ JD0,  1.52368, 0.09340,   1.880866,  1.8497,  49.5812, 336.1155, 209.5529 },			// ΐ
	{ JD0,  5.20260, 0.04850,  11.86155,   1.3031, 100.4950,  14.3796, 125.4198 },			// ؐ
	{ JD0,  9.55491, 0.05554,  29.53216,   2.4888, 113.6918,  93.1161,  86.7744 },			// y
	{ JD0, 19.21845, 0.04638,  84.25300,   0.7732,  74.0216, 173.0499, 326.9480 },			// V
	{ JD0, 30.11039, 0.00946, 165.2269,    1.7697, 131.8171,  48.1631, 310.9437 },			// C
	{ JD0, 39.54044, 0.24901, 248.6449,   17.1449, 110.3587, 224.1833, 242.8665 },			// 
};


//---  q̋Ovf  Ref[3]  ---//
struct satellite_orbital_elements {
	char	planet_ID;	// planet ID
	double	epoch;		// epoch
	double	a;			// semi-major axisiOaj
	double	e;			// eccentricityiSj
	double	omg;		// argument of periapsisiߓ_j
	double	M0;			// mean anomalyiϋߓ_pj
	double	i;			// inclinationireference plane ɑ΂OXΊpj
	double	node;		// longitude of the ascending nodei_:reference planeICRF equator node 瑪pxj
	double	n;			// mean daily motioniϓX^j
	double	P;			// sidereal periodiiPNjj
	double	Pw;			// argument of periapsis precession period
	double	Pnode;		// longitude of the ascending node precession period
	char	ref_plane;	// type of reference plane
	double	RA;			// right ascension
	double	DEC;		// declination of the Laplace plane pole with respect to the ICRF
};


const satellite_orbital_elements sat_oe[] = {
//== Mars (2) ==
		//--  Phobos
	{ PLNT_MARS, 2433282.5, 9380.0, 0.0151, 150.247,  92.474, 1.075, 207.207, 1128.8444155,  0.319,   1.131,  2.262,  'L', 317.724, 52.924 },
		//--  Dimos
	{ PLNT_MARS, 2433282.5, 23460.0, 0.0002, 290.496, 296.230, 1.793,  22.9,   285.1618919,  1.262,   26.892, 54.536,  'L', 316.700, 53.564 },
//== Jupiter (16) ==
		//--  Io
	{ PLNT_JUPITER, 2450464.5, 421800.0, 0.0041,  83.898, 342.021, 0.036,  44.208,  203.4889583,  1.769,   1.624,  7.431,  'L', 268.057, 64.496 },
		//--  Europa
	{ PLNT_JUPITER, 2450464.5, 671100.0, 0.0094,  88.684, 171.016, 0.469, 219.383,  101.3747242,  3.551,   1.394, 30.230,  'L', 268.094, 64.509 },
		//--  Ganymede
	{ PLNT_JUPITER, 2450464.5, 1070400.0, 0.0011, 203.214, 306.589, 0.170,  63.692,   50.3176071,  7.155,  59.435, 131.32,  'L', 268.183, 64.546 },
		//--  Callisto
	{ PLNT_JUPITER, 2450464.5,  1882700.0, 0.0074,  57.714, 180.997, 0.187, 294.195,   21.5710729, 16.69,  190.36,  301.97,  'L', 268.632, 64.741 },
		//--  Amalthea
	{ PLNT_JUPITER, 2450464.5, 181400.0, 0.0031, 147.025, 190.516, 0.388, 112.472,  722.6317141,  0.498,   0.196,   0.394, 'L', 268.057, 64.494 },
		//--  Thebe
	{ PLNT_JUPITER, 2450464.5, 221900.0, 0.0177, 233.544, 136.441, 1.070, 235.925,  533.7002513,  0.675,   0.398,   0.797, 'L', 268.057, 64.494 },
		//--  Adrastea
	{ PLNT_JUPITER, 2450464.5, 129000.0, 0.0018, 328.047, 135.673, 0.054, 228.378, 1206.9988064,  0.298,   0.058,   0.116, 'L', 268.057, 64.496 },
		//--  Metis
	{ PLNT_JUPITER, 2450464.5, 128000.0, 0.0012, 297.177, 276.047, 0.019, 146.912, 1221.2545982,  0.295,   0.057,   0.115, 'L', 268.057, 64.496 },
		//--  Himalia
	{ PLNT_JUPITER, 2451544.5, 11461000.0, 0.1623, 331.995,  68.721, 27.496, 57.245,    1.4367718, 250.56, 137.16,  282.90,  'L', 275.667, 67.429 }, 
		//--  Elara
	{ PLNT_JUPITER, 2451544.5, 11741000.0, 0.2174, 143.591, 332.962, 26.627, 109.373,   1.3865491, 259.64, 126.42,  252.49,  'L', 273.200, 68.246 },
		//--  Pasiphae
	{ PLNT_JUPITER, 2451544.5, 23624000.0, 0.4090, 170.450, 280.193, 151.431, 312.990,  0.4841107, 743.63,  80.83,   81.01,  'L', 273.440, 67.645 },
		//--  Sinope
	{ PLNT_JUPITER, 2451544.5, 23939000.0, 0.2495, 346.394, 168.397, 158.109, 303.081,  0.4743709, 758.90,  89.27,   87.54,  'L', 273.266, 66.880 },
		//--  Lysithea
	{ PLNT_JUPITER, 2451544.5, 11717000.0, 0.1124,  49.486, 329.121,  28.302,   5.528,  1.3888799, 259.20, 131.52,  299.88,  'L', 271.356, 67.115 },
		//--  Carme
	{ PLNT_JUPITER, 2451544.5, 23404000.0, 0.2533,  28.199, 234.027, 164.907, 113.738,  0.4903509, 734.17,  81.06,   88.53,  'L', 272.620, 66.689 },
		//--  Ananke
	{ PLNT_JUPITER, 2451544.5, 21276000.0, 0.2435, 100.619, 248.793, 148.889,   7.615,  0.5716368, 629.77, 140.85,  108.96,  'L', 279.087, 66.152 },
		//--  Leda
	{ PLNT_JUPITER, 2451544.5, 11165000.0, 0.1636, 272.349, 228.076,  27.457, 217.137,  1.4942498, 240.92, 142.57,  296.66,  'L', 271.668, 66.848 },
//== Saturn (18) ==
		//--  Mimas
	{ PLNT_SATURN, 2451179.5, 185600.0, 0.0206, 322.864, 100.173, 1.566, 177.457,  381.9945625,  0.942,   0.493,   0.987, 'L',  40.570, 83.535 },
		//--  Enceladus
	{ PLNT_SATURN, 2451179.5, 238100.0, 0.0001, 334.689, 162.044, 0.010, 137.077,  262.7319034,  1.370,   1.186,   2.373, 'L',  40.577, 83.540 },
		//--  Tethys
	{ PLNT_SATURN, 2451179.5, 294700.0, 0.0001, 149.166,  28.755, 0.168, 149.174,  190.6979050,  1.888,   2.489,   4.980, 'L',  40.874, 83.535 },
		//--  Dione
	{ PLNT_SATURN, 2451179.5, 377400.0, 0.0002, 173.999, 109.204, 0.002,  57.741,  131.5349292,  2.737,   5.850,  11.704, 'L',  40.540, 83.543 }, 
		//--  Rhea
	{ PLNT_SATURN, 2451179.5, 527100.0, 0.0009, 205.869, 238.732, 0.327,   1.095,   79.6900463,  4.518,  17.908,  35.820, 'L',  40.362, 83.556 },
		//--  Titan
	{ PLNT_SATURN, 2451179.5, 1221900.0, 0.0288, 172.749, 192.132, 1.634,  44.046,   22.5769747, 15.95,  581.68, 3485.64,  'L',  27.259, 84.963 },
		//--  Hyperion
	{ PLNT_SATURN, 2451179.5, 1464100.0, 0.0175, 262.058,  52.956, 0.568, 273.863,   16.9199684, 21.28,  118.82,  143.22,  'L',  36.643, 83.788 },
		//--  Iapetus
	{ PLNT_SATURN, 2451179.5, 3560800.0, 0.0284, 275.850, 350.306, 7.570,  75.583,    4.5379497, 79.33, 1681.60, 3153.68,  'L', 288.577, 78.826 },
		//--  Phoebe
	{ PLNT_SATURN, 2451179.5, 12944300.0, 0.1644, 337.537, 174.569, 174.751, 237.143,  0.6566799, 548.21, 489.73,  788.95,  'L', 275.631, 68.031 },
		//--  Janus
	{ PLNT_SATURN, 2444786.5, 151500.0, 0.0073,  27.852, 236.455,   0.165, 303.797, 518.2917182,  0.695,  0.240,   0.482, 'L',  40.580, 83.540 },
		//--  Epimetheus
	{ PLNT_SATURN, 2444786.5, 151400.0, 0.0205, 100.866,  55.972,   0.335, 335.006, 518.5457476,  0.694,  0.240,   0.482, 'L',  40.580, 83.540 },
		//--  Helene
	{ PLNT_SATURN, 2444786.5, 377400.0, 0.0001,  80.357,  10.033,   0.212,  10.214, 131.5349299,  2.737,  2.564,  11.736, 'L',  40.564, 83.543 },
		//--  Telesto
	{ PLNT_SATURN, 2444786.5, 294700.0, 0.0010,  80.729,   7.907,   1.158, 126.124, 190.6979092,  1.888,  2.486,   4.982, 'L',  40.575, 83.541 },
		//--  Calypso
	{ PLNT_SATURN, 2444786.5, 294700.0, 0.0005,  43.640, 201.815,   1.473, 209.184, 190.6979081,  1.888,  2.486,   4.982, 'L',  40.569, 83.541 },
		//--  Atlas
	{ PLNT_SATURN, 2444786.5, 137700.0, 0.0000,   0.000, 186.541,   0.000,   0.000, 598.3066574,  0.602,  0.171,   0.344, 'L',  40.589, 83.525 },
		//--  Prometheus
	{ PLNT_SATURN, 2444786.5, 139400.0, 0.0023, 212.854, 335.684,   0.000,   0.000, 587.2891702,  0.613,  0.179,   0.359, 'L',  40.589, 83.525 },
		//--  Pandora
	{ PLNT_SATURN, 2444786.5, 141700.0, 0.0044,  68.229,   13.918,   0.000,   0.000, 572.7889099,  0.629,  0.190,   0.381, 'L',  40.589, 83.525 },
		//--  Pan
	{ PLNT_SATURN, 2444786.5, 133600.0, 0.0000,   0.000,  122.072,   0.000,   0.000, 626.0440000,  0.575,  0.000,   0.000, 'L',  40.589, 83.525 },
//== Uranus (5) ==
		//--  Ariel
	{ PLNT_URANUS, 2444239.5, 190900.0, 0.0012, 115.349,   39.481,   0.041,  22.394, 142.8356579,  2.520, 28.788,  57.248, 'Q', 0,0 },
		//--  Umbriel
	{ PLNT_URANUS, 2444239.5, 266000.0, 0.0039,  84.709,   12.469,   0.128,  33.485,  86.8688879,  4.144, 63.146, 126.951, 'Q', 0,0 },
		//--  Titania
	{ PLNT_URANUS, 2444239.5, 436300.0, 0.0011, 284.400,   24.614,   0.079,  99.771,  41.3514246,  8.706, 161.525, 195.369, 'Q', 0,0 },
		//--  Oberon
	{ PLNT_URANUS, 2444239.5, 583500.0, 0.0014, 104.400,  283.088,   0.068, 279.771,  26.7394888, 13.46, 161.52,  195.37,  'Q', 0,0 },
		//--  Miranda
	{ PLNT_URANUS, 2444239.5, 129900.0, 0.0013,  68.312,  311.330,   4.338, 326.438, 254.6906576,  1.413,  8.913,  17.727, 'Q', 0,0 }, 
//== Neptune (2) ==
		//--  Triton
	{ PLNT_NEPTUNE, 2447763.5, 354800.0, 0.0000, 344.046, 264.775, 156.834, 172.431, 61.2601284, 5.877,  397.516, 688.126, 'L', 299.358, 43.455 },
		//--  Nereid
	{ PLNT_NEPTUNE, 2447763.5, 5513400.0, 0.7512, 280.830, 359.341,   7.232, 334.762,  0.9996241, 360.14, 7787.26, 9191.62, 'L', 270.113, 69.155 }, 
//== Pluto (1) ==
		//--  Charon
	{ PLNT_PLUTO, 2446600.5, 19410.0, 0.0002, 209.793, 259.960,  99.089, 223.015, 56.3623195,   6.387, 0.000,   0.000, 'I', 0,0 }
};


//-------------
//  Constants
//-------------
const int PlanetNum = 9;
const int SatellitesNum = 1 + sizeof(sat_oe)/sizeof(sat_oe[0]);	// +1 ͌̕

//---------
//  Array
//---------
static vector3d  vPlanetPos[PlanetNum];
static vector3d  vSatellitePos[SatellitesNum];
static matrix3d  vSatelliteOrbitMatrix[SatellitesNum];	

//-------
//  Sun
//-------
vector3d
get_sun_position()
{
	return  vector3d(0,0,0);
}

//--------------------------
//  Planets and Satellites
//--------------------------
void	update_planets_position(const double& t);
void	update_satellites_position(const double& t);


void
update_planets_and_satellites_position(const double& t, bool force)
{
	const double DT_MIN = 0.01/(24.0*60.0*60.0);
	static bool first = true;
	static double t_last;

	if (first)	{ first = false; }
	else if (!force) { if (fabs(t - t_last) < DT_MIN)  return; }

	update_planets_position(t);
	update_satellites_position(t);

	//--  Earth and Moon
	const double R_EM = 81.30057;
	const vector3d dr_EM   = (vPlanetPos[PLNT_EARTH] - vSatellitePos[SAT_MOON]) / (R_EM + 1.0);
	vPlanetPos[PLNT_EARTH]  += dr_EM;
	vSatellitePos[SAT_MOON] += dr_EM;

	//--  Pluto and Charon
	const double R_PC = 1.0/0.08;
	const vector3d dr_PC   = (vPlanetPos[PLNT_PLUTO] - vSatellitePos[SAT_CHARON]) / (R_PC + 1.0);
	vPlanetPos[PLNT_PLUTO]    += dr_PC;
	vSatellitePos[SAT_CHARON] += dr_PC;

	t_last = t;
}

//-----------
//  Planets
//-----------
static CF96_planets  cf96;					// cf96, planetary series
static orbital_elements  vPlanetsOrbitalElements[PlanetNum];


//--- CF96 ̓ǂݍ
bool
load_CF96(const char* filename)
{
	return  cf96.load( filename );
}


//--- Ovf̏
void
init_planets_orbital_elements()
{
	for (int i=0; i<PlanetNum; i++) {
		const planet_orbital_elements& oe0 = plnt_oe[i];
		const double n = 0.985607669/pow(oe0.a, 3.0/2.0);
		vPlanetsOrbitalElements[i].set_parameters(oe0.epoch, oe0.a, oe0.e, oe0.L - oe0.omg_bar, n,
												  oe0.node, oe0.i, oe0.omg_bar - oe0.node);
	}
}

void
update_planets_position(const double& t)
{
	static bool first = true;
	static matrix3d  MT_CF96;

	if (first) {
		first = false;
		MT_CF96 = double(_1AU_pc) * Rx3deg(-epsJ2000);
	}

	if (cf96.isInRange(t)) {
		// CF96 ǂݍ܂ĂāALȎ̏ꍇ́Ag
		// (ԓWnAWnɂȂ)
		for (int i=0; i<PlanetNum; i++) {
			vPlanetPos[i] = MT_CF96 * cf96.eval_pos(i, t);
		}
	} else {
		// ȊÓAϋOvfɂvZ
		for (int i=0; i<PlanetNum; i++) {
			vPlanetsOrbitalElements[i].calc_pos(t);
			vPlanetPos[i] = double(_1AU_pc) * vPlanetsOrbitalElements[i].get_pos();
		}
	}
}

vector3d
get_planet_position(int idx)
{
	return  vPlanetPos[idx];
}

vector3d
calc_planet_orbit_pos(int idx, float phi)
{
	return  double(_1AU_pc) * vPlanetsOrbitalElements[idx].calc_orbit_pos(phi);
}

//--- OS ---
double
get_planet_a(int idx)
{
	return plnt_oe[idx].a;
}


//==============
//  Satellites
//==============
int
get_satellites_num()
{
	return SatellitesNum;
}

//--------------------------------------
//  qW物Wւ̕ϊs߂
//--------------------------------------
//******** ̕ϊs͖  ***************
matrix3d
calc_satellite_orbit_matrix(int idx, const double& t)
{
	if  (idx == SAT_MOON) {
		return  matrix3d(1,0,0, 0,1,0, 0,0,1);
	}

	const satellite_orbital_elements &soe = sat_oe[idx-1];

	double domg, dOmg;
	double dt, omg, node;
	domg = (soe.Pw != 0.0)     ?  360.0 / soe.Pw / 365.25     :  0.0;
	dOmg = (soe.Pnode != 0.0)  ?  360.0 / soe.Pnode / 365.25  :  0.0;
	dt = t - soe.epoch;
	omg  = soe.omg  + domg*dt;
	node = soe.node + dOmg*dt;

	switch(soe.ref_plane) {
		case 'L':	// vXʂ
			return  M_R2E * Rzxz3deg(90+soe.RA, 90-soe.DEC, 0.0) * Rzxz3deg(node, soe.i, omg);
		case 'I':	// ICRF
			return  M_R2E * Rzxz3deg(node, soe.i, omg);
		case 'Q':	// fԓʂ
			return  get_planet_pl_to_ec_matrix0(soe.planet_ID) * Rzxz3deg(node, soe.i, omg);
		case 'E':	// ʂ
		default:
			return  Rzxz3deg(node, soe.i, omg);
	}
}


//---------------------------------
//  q̈ʒu߂(SW)
//  x t_Axy-ʂ
//---------------------------------
vector3d
calc_satellites_position(int idx, const double& t)
{
	//--  Moon  --
	if (idx == SAT_MOON) {
		const double fac_M = get_zoom_rate().zmhMoonOrb;
		return  get_planet_position(PLNT_EARTH) + fac_M * double(_1km_pc) * calc_lunar_pos(t);
	}

	//--  Other satellites  --
	const satellite_orbital_elements &soe = sat_oe[idx-1];
	vector3d  ro, rL, rICRF, rE;

	// omg, node  precession
	double domg, dOmg, n;
	domg = (soe.Pw != 0.0)     ?  360.0 / soe.Pw / 365.25     :  0.0;
	dOmg = (soe.Pnode != 0.0)  ?  360.0 / soe.Pnode / 365.25  :  0.0;
	n    = soe.n - domg - dOmg;

	// Oʏ̈ʒu
	ro = calc_orbital_pos(soe.a*_1km_AU, soe.e, soe.M0, n, soe.epoch, t);
	rE = vSatelliteOrbitMatrix[idx] * ro;
	return  get_planet_position(soe.planet_ID) + double(_1AU_pc) * rE;
}

void
update_satellites_position(const double& t)
{
	for (int i=0; i<SatellitesNum; i++) {
		vSatelliteOrbitMatrix[i] = calc_satellite_orbit_matrix(i, t);
		vSatellitePos[i] = calc_satellites_position(i, t);
	}
}

matrix3d
get_satellite_orbit_matrix(int idx)
{
	return  vSatelliteOrbitMatrix[idx];
}

vector3d
get_satellite_position(int idx)
{
	return  vSatellitePos[idx];
}

int
get_satellite_planet_ID(int idx)
{
	if (idx == SAT_MOON)  return  PLNT_EARTH;
	return  sat_oe[idx-1].planet_ID;
}

vector3d
get_satellite_position_relative_to_planet(int idx)
{
	return  vSatellitePos[idx] - get_planet_position( get_satellite_planet_ID(idx) );
}


//--- OS ---
double
get_satellite_a(int idx)
{
	if (idx == SAT_MOON) {
		const double fac_M = (tyMode==MODE_PLANETARIUM)  ?  1.0  :  get_zoom_rate().zmhMoonOrb;
		return  60.11122 * 6378.140 * _1km_pc * fac_M;
	}

	return  sat_oe[idx-1].a * _1km_pc;
}

vector3d
calc_satellite_orbit_pos(int idx, const double& t, float phi)
{
	//---  Moon  ---
	if (idx == SAT_MOON)  {
		const double fac_M = get_zoom_rate().zmhMoonOrb;
		return  (fac_M * double(_1km_pc)) * calc_lunar_pos(t - 27.3*((phi-pi)/(2*pi)) )  + get_planet_position(PLNT_EARTH);
	}

	//---  Other satellites  ---
	const satellite_orbital_elements &soe = sat_oe[idx-1];
	return  get_satellite_orbit_matrix(idx) * calc_orbital_position(soe.a, soe.e, phi) * _1km_pc + get_planet_position( soe.planet_ID );
}
