/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
//---------------------------------------------------
// Mitaka   (Hipparcos 3D Planetarium)
//  written by Tsunehiko N. Kato   2003/2/18
//  2003/2/19, 2/27, 3/7, 3/14, 3/19, 3/31, 4/1, 4/20
//      4/28, 5/4, 5/9, 5/23, 5/31, 6/5, 6/7, 6/8
//      6/25, 7/23, 7/25, 7/28-8/1, 8/3, 9/9, 9/18-19
//      9/22,24-25, 10/6-7, -10/26, 11/27
//   beta1: 05/2/1
//   beta2: 05/2/16
//   beta3: 05/2/22
//          05/6/24
//   beta4: 05/10/13
//   beta5: 06/7/20
//   beta6: 06/11/25
//   version 1.0: 07/05/11
//   version 1.1.0: 07/10/08
//---------------------------------------------------
#include  <windows.h>
#include  <commdlg.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <tchar.h>
#include  <process.h>
#include  <string>
#include  "../common/win_file.h"
#include  "../common/astro/constellation.h"
#include  "../common/math/quaternion.h"
#include  "../common/math/spline.h"
#include  "../common/graphics/gl_common.h"
#include  "../common/graphics/gl_win.h"
#include  "../common/graphics/gl_Model3d.h"
#include  "../common/graphics/3ds_loader.h"
#include  "../common/graphics/gl_triangle_mesh.h"
#include  "../common/graphics/gl_image.h"
#include  "../common/graphics/color.h"
#include  "../common/win_dlg.h"
#include  "../common/win_ctrl.h"
#include  "../common/interface/trackball.h"
#include  "../common/graphics/dib.h"
#include  "../common/graphics/wgl_font.h"
#include  "../common/graphics/avi.h"
#include  "../common/graphics/gltext.h"
#include  "../common/bilingual.h"
#include  "Mitaka.h"
#include  "mtk_OpenGL.h"
#include  "mtk_tcp.h"
#include  "mtk_movie.h"
#include  "mtk_joystick.h"
#include  "mtk_menu.h"
#include  "mtk_movement.h"
#include  "mtk_switches.h"
#include  "mtk_ini_file.h"
#include  "mtk_colors.h"
#include  "mtk_command.h"
#include  "mtk_menu_bar.h"
#include  "mtk_dialog_box.h"
#include  "mtk_target.h"
#include  "mtk_camera.h"
#include  "mtk_camera_setting.h"
#include  "mtk_screen.h"
#include  "mtk_draw_struct.h"
#include  "mtk_cpu_info.h"
#include  "mtk_window_mode.h"
#include  "mtk_network_mode.h"
#include  "mtk_screen_button.h"
#include  "mtk_title_page.h"
#include  "mtk_end_roll.h"
#include  "mtk_image.h"
#include  "mtk_on_screen.h"
#include  "mtk_time.h"
#include  "mtk_gl_common.h"
#include  "mtk_scale_line.h"
#include  "mtk_planetarium.h"
#include  "../common/JulianDate.h"
#include  "mtk_stars.h"
#include  "mtk_constellation.h"
#include  "mtk_object.h"
#include  "mtk_object_position.h"
#include  "mtk_planets.h"
#include  "mtk_planet_position.h"
#include  "mtk_planet_orientation.h"
#include  "mtk_planet_phys_params.h"
#include  "mtk_minor_planets.h"
#include  "mtk_oort_cloud.h"
#include  "mtk_spacecraft.h"
#include  "mtk_space_curve.h"
#include  "mtk_globular_clusters.h"
#include  "mtk_galaxies.h"
#include  "mtk_our_galaxy_rt.h"
#include  "mtk_elliptical_galaxy.h"
#include  "mtk_gc_model.h"
#include  "mtk_atmosphere.h"
#include  "mtk_make_movie.h"
#include  "mtk_font.h"
#include  "mtk_text.h"
#include  "mtk_place_name_earth_mars.h"
#include  "../common/frame_rate.h"
#include  "mtk_anaglyph.h"
#include  "mtk_pbuffer.h"
#include  "mtk_save_image.h"
#include  "mtk_cubic_image.h"
#include  "mtk_directory.h"
#include  "resource.h"
using namespace std;




//-----------
//  Externs
//-----------
//-- window mode
extern bool bFullScreen;
extern mtk_screen_button_minus sbTimeMinus, sbZoomMinus;
extern mtk_screen_button_plus  sbTimePlus,  sbZoomPlus;
//-- network mode
extern bool	bNetwork;
extern bool	bControler;
extern bool bDrawing;






//--- Version ---
char szAppName[] = TEXT("Mitaka");
const char szVersion[] = TEXT("1.1.0");

char szTitle[256];



//--- Window ---
HINSTANCE	g_hInst;
HWND		g_hWnd = NULL;
HCURSOR		hCursorArrow = NULL;


int disp_w, disp_h;	// XN[̃TCY

int win_x0, win_y0;
int win_x1, win_y1, win_x2, win_y2;
int win_w, win_h, win_w0, win_h0;
int win_mgn_w1, win_mgn_h1;
int win_mgn_w2, win_mgn_h2;


int  gl_x0, gl_y0, gl_w, gl_h;
bool	bActive;


//--- Wnidow size ---
int _win_x1, _win_y1, _win_w, _win_h, _mgn_w, _mgn_h;





//--- OpenGL ---
COpenGL		ogl;


//--- Frame Rate ---
fps_counter  FrmCounter(10);




//-------
//  
//-------
mtk_camera	g_camera;	// ݂̃J̏




//-------
//  
//-------
//--  Draw
bool bMotion			= false;
bool bPrevMotion		= false;
bool bDrawLowRes		= false;
//--  Movie
bool  bMovieMode		= false;	// [r[JĂ邩
bool  bMoviePlaying		= false;	// [r[̍Đ
//--  Menu
bool  bMenuVisible		= true;		// j[\邩ǂ


//-- Setting mode
enum {
	SETTING_MODE_NONE,
	SETTING_MODE_DATE,
	SETTING_MODE_EYE_DISTANCE
};
char chSettingModeDisp = SETTING_MODE_NONE;


//--  Movie
bool  bWindowlessVMR = false;




//--------------
//  `p\
//--------------
static mtk_draw_struct g_latest_draw_struct;
void set_latest_draw_struct(const mtk_draw_struct& ds) { g_latest_draw_struct = ds; }

mtk_draw_struct
get_latest_draw_struct()
{
	return  g_latest_draw_struct;
}



//---------
//  Color
//---------
const char* szMenuTextColorDef		= "#A59FA5";
const char* szMenuSelectColorDef	= "#DEDED3";
const char* szMenuTitleColorDef		= "#EBBE47";
const char* szMenuBgColor1Def		= "#464E64";
const char* szMenuBgColor2Def		= "#000000";
const char* szMenuBdColorDef		= "#3E4557";
const char* szMenuHlColor1Def		= "#599AE5";
const char* szMenuHlColor2Def		= "#2764D2";

const char* szMenuCornerRDef		= "0.5";
const char* szMenuBgAlphaDef		= "0.95";
const char* szMenuBehindAlphaDef	= "0.4";
const char* szMenuFadingRateDef		= "3.0";

RGBf colMenuText, colMenuSelect, colMenuTitle;
RGBf colMenuBgColor1, colMenuBgColor2, colMenuBdColor;
RGBf colMenuHlColor1, colMenuHlColor2;
float MenuCornerR, MenuBgAlpha, MenuBehindAlpha, MenuFadingRate;


const char* szDateSizeDef		= "0.9";
float DateAlpha, gDateSize;


//--------
//  Menu
//--------
const char* szMenuTextSizeDef = "0.7";
const char* szMenuBdWidthDef  = "1.0";

float MenuTextSize;
float MenuBdWidth;
float MenuTriangleDy;


//--------
//  Font
//--------
const char* szFontSizeDef  = "1.4";
float FontSize;

float vFontSize[5] = {
	3.0, 2.0, 1.4, 1.0, 0.6
};


//------------
//  ^[Qbg
//------------
extern vector3d fixed_target_pos[6];



//-------
//  
//-------
vector<gltext>  vSubtitles;
int subtitles_idx = 0;











//------------------------------------
//  n_iݒ͍V̈ʒuj
//------------------------------------
char szLandingPosNameJ[256];
char szLandingPosNameE[256];
float  landing_lon0, landing_lat0;
float  landing_lon, landing_lat;



//------------
//  TimeZone
//------------
float DT;



//--------------
//  ͌nf
//--------------
vector3f  GC;


bool bData;								// f[^ɓǂݍ܂ꂽ






//------------
//  vZbg
//------------
enum {
	PRESET_SOLARSYSTEM_COMPLETE_VIEW,
	PRESET_MARS_2003,
	PRESET_SPACECRAFT_PATH
};



//------------
//  Textures
//------------
GLuint   texMilkyWay;




//-----------------
//  Display lists
//-----------------
GLuint	dlSquare;
GLuint  dlClstSphere, dlClstDigit;






//---------------------
//  Modes / Sub Modes
//---------------------
char  tyMode = MODE_PLANETARIUM;
char tySubMode = SUBMODE_NORMAL;





//-----------
//  Program
//-----------
char  tyProgram = 0;

// vOptO
bool	bFlg3;



//-------------
//  time step
//-------------
char  tyTimeStep			= TIMESTEP_10MIN;	// ^CXebv



char  tyMilkyWay			= MILKYWAY_VISIBLE;		// V̐̎



bool  bTest					= false;		// eXgp




//-----------------
//  ̃}[N[h
//-----------------
char tyStarMark = STARMARK_NONE;




//-------------
//  3D`[g
//-------------
enum {
	_3DCHART_PLANETS,
	_3DCHART_DWARF_PLANETS,
	_3DCHART_STAR_COLOR
};
char  no_3DChart = 0;





//----------------
//  Aj[V
//----------------
int animation_counter0 = 0;
int animation_counter  = 0;
int animation_interval = 1;
int animation_type = 0;



//---------
//  Movie
//---------
MediaFiles MVF;
movie  dsmv;

//-- Audio
MediaFiles AUDF;


//---------
//  Image
//---------
MediaFiles IMGF;
mtk_image	ImageStill;
bool	bMilkyWayImageLoaded = false;





//
char	current_image_index = 0;





//---------
//  Popup
//---------
enum popup_type {
	POPUP_TEXT,
	POPUP_IMAGE
};

struct popup_info {
	bool	bFlg;		// `悵 false
	double  scale;		// NXP[
	char	type;		// |bvAbṽ^Cv
	char	idx;		// CfbNX
};

const int popup_num = 2;
popup_info
PopUp[popup_num] = {
	{ true,  10*_1AU_pc, POPUP_IMAGE, 0  },
	{ true,  3,         POPUP_IMAGE, 1  }
};



//--------
//  Date
//--------
float g_date_pos_y = 0.0;


//--------------
//  Prototypes
//--------------
void	Input();
float	get_animation_frac();	// ݂̃Aj[V̐is̊Ԃ
void	init_popup(const char nProgram);




//-----------
//  Pointer
//-----------
float pointer_angle_x = 0.0;
float pointer_angle_y = 0.0;
float pointer_z = screen_z;

//--------
//  Menu
//--------
const float menu_angle_max =  50.0f;
const float menu_angle_min = -50.0f;
float menu_angle = 0.0;

///
enum menu_command_ID {
	MENU_COMMAND_CLOSE,
	MENU_COMMAND_EXIT_ALL,
	MENU_COMMAND_STAR_BRIGHTEN,
	MENU_COMMAND_STAR_DARKEN,
	MENU_COMMAND_STAR_DEFAULT_BRIGHTNESS,
	MENU_COMMAND_LANDING_INIT,
	MENU_COMMAND_TARGET_MOVE,
	MENU_COMMAND_PRESENT_TIME,
	MENU_COMMAND_RESET_VIEWANGLE,
	MENU_COMMAND_MOVIE_OPEN,
	MENU_COMMAND_IMAGE_OPEN,
	MENU_COMMAND_AUDIO_OPEN,
	MENU_COMMAND_3DCHART,
	MENU_COMMAND_PRESET,
	MENU_COMMAND_PLAY_PATH,
	MENU_COMMAND_SAVE_PATH,
	MENU_COMMAND_LOAD_PATH,
	MENU_COMMAND_CLEAR_PATH,
	MENU_COMMAND_GOTO,
	MENU_COMMAND_DRAW_MILKYWAY,
	MENU_COMMAND_DRAW_MILKYWAY2
};

enum menu_check_ID {
	MENU_CHECK_CNST_NAME,
    MENU_CHECK_CNST_LINE,
    MENU_CHECK_CNST_ILLUST,
	MENU_CHECK_CNST_BND,
	MENU_CHECK_STAR,
	MENU_CHECK_STAR_NAME,
	MENU_CHECK_STAR_NAME_SELECT,
	MENU_CHECK_STAR_BAYER,
	MENU_CHECK_STAR_FRAMSTEED,
	MENU_CHECK_STAR_HIP,
	MENU_CHECK_STAR_MARK,

	MENU_CHECK_PLANETS,
	MENU_CHECK_PLANET_NAME,
	MENU_CHECK_PLANET_ORBIT,
	MENU_CHECK_PLANET_AXIS,
	MENU_CHECK_PLANET_ATMOSPHERE,
	MENU_CHECK_PLANET_CLOUD,
	MENU_CHECK_PLANET_CITY_LIGHTS,
	MENU_CHECK_PLANET_ZOOM,
	MENU_CHECK_TOPO_ZOOM,
	MENU_CHECK_LANDING_MODE,

	MENU_CHECK_SATELLITE_DISP,
	MENU_CHECK_SATELLITE_NAME,
	MENU_CHECK_SATELLITE_ORBIT,
	MENU_CHECK_SATELLITE_SELECT,

	MENU_CHECK_MINOR_PLANET_DISP,
	MENU_CHECK_MINOR_PLANET_NAME,
	MENU_CHECK_MINOR_PLANET_ORBIT,
	MENU_CHECK_MINOR_PLANET_SELECT,

	MENU_CHECK_TNO_DISP,
	MENU_CHECK_TNO_NAME,
	MENU_CHECK_TNO_ORBIT,
	MENU_CHECK_TNO_SELECT,
	MENU_CHECK_TNO_OORT_CLOUD,
	

	MENU_CHECK_ECLIPSE_DISP,
	MENU_CHECK_ECLIPSE_BORDER,
	MENU_CHECK_SPACECRAFT_PATH,
	MENU_CHECK_MILKYWAY_NONE,
	MENU_CHECK_MILKYWAY,
	MENU_CHECK_MILKYWAY2,
	MENU_CHECK_MILKYWAY_IR,
	MENU_CHECK_OUR_GALAXY,
	MENU_CHECK_GLOBULAR_CLUSTER,
	MENU_CHECK_GALAXY_NEAR,
	MENU_CHECK_GALAXY_SDSS,
	MENU_CHECK_GALAXY_QSO,
	MENU_CHECK_GALAXY_VIRGO,
	MENU_CHECK_CLST_GRD,
	MENU_CHECK_ECLIPTIC,
	MENU_CHECK_HORIZON_COORD,
	MENU_CHECK_GLX_GRD,
	MENU_CHECK_DIST_SCALE,
	MENU_CHECK_SCALE_SQUARE,
	MENU_CHECK_NGC,
	MENU_CHECK_DATE,
	MENU_CHECK_TIME,
	MENU_CHECK_REALTIME_MODE,
	MENU_CHECK_TARGET,
	MENU_CHECK_LANG,
	MENU_CHECK_TEST,
	MENU_CHECK_PROGRAM,
	MENU_CHECK_FONT_SIZE,
	MENU_CHECK_TITLE,
	MENU_CHECK_ABOUT,
	MENU_CHECK_DEBUG,
	MENU_CHECK_VIEW_INFO,
	MENU_CHECK_SINGLE_EYE,
	MENU_CHECK_PATH_INFO,
	MENU_CHECK_ZAKU,
	MENU_CHECK_SUBTITLES,
	MENU_CHECK_SIDE_LIGHT,
	MENU_CHECK_SURFACE_POINTER,
	MENU_CHECK_FULLSCREEN
};





struct menu_color {
	RGBAf  txt_color, select_color, title_color;
	RGBAf  bg_color, bd_color;
};


menu			menu_root;
menu			menu_disp, menu_target, menu_time, menu_system, menu_path, menu_preset;
menu			menu_movie, menu_image, menu_audio, menu_3Dchart;
menu_option		menu_target_solarsystem, menu_target_spacecraft, menu_target_galactic, menu_target_extragalactic;
menu			menu_planet, menu_satellite, menu_minor_planet, menu_TNO;
menu			menu_cnst, menu_star, menu_eclipse, menu_spacecraft, menu_galaxy, /*menu_sky,*/ menu_grid;
menu_option		menu_program, menu_clst_sphere, menu_lang, menu_timestep, menu_star_mark;
menu_option		menu_atmosphere, menu_zoom_mode, menu_topo_zoom, menu_font_size, menu_landing_mode;

menu_selection	mnuSelect;
menu_color		mnu_col, mnu_col_bk;






struct menu_item_def {
	const char* nameJ;
	const char* nameE;
	int	idx;
};





void
init_option_menu(menu_option& mn, int num, int MENU_ID, const char* titleJ, const char* titleE, const menu_item_def* mndf, int ini_check_no)
{
	mn.set_title(titleJ, titleE);
	for (int i=0; i<num; ++i) {
		bool bChk = (i==ini_check_no);
		mn.add_check(MENU_ID, mndf[i].nameJ, mndf[i].nameE, mndf[i].idx, bChk);
	}
}




int virgo_menu_idx;


//-- [gj[̐ݒ
void
init_root_menu()
{
    menu_root.set_title("Cj[", "Main Menu");

	menu_root.clear();
	if (MVF.size() > 0)		menu_root.add_child_menu( &menu_movie,	"[r[",	"Movies" );
	if (IMGF.size() > 0)	menu_root.add_child_menu( &menu_image,	"摜",		"Images" );
	if (AUDF.size() > 0)	menu_root.add_child_menu( &menu_audio,	"",		"Audio" );
	menu_root.add_child_menu( &menu_3Dchart,				"Rc`[g",		"3D Chart" );


	//--- \ݒ
	menu_root.add_child_menu( &menu_disp,				"\ݒ", "Display Settings" );
	if (tyProgram==2) {
		menu_root.add_command(MENU_COMMAND_DRAW_MILKYWAY2, 0,	"邢V̐\", "Bright Milky Way");
		menu_root.add_command(MENU_COMMAND_DRAW_MILKYWAY,  0,	"V̐\", "Milky Way");
	}
	if (tyProgram==2 || tyProgram==4) {
		menu_root.add_child_menu( &menu_star_mark, "̃}[N", "Mark Stars" );
	}
	if (tyProgram==5) {
		menu_root.add_check(MENU_CHECK_GALAXY_VIRGO, "Ƃߍ͒c}[N", "Mark Virgo Cluster", 0, false);
		virgo_menu_idx = menu_root.size() - 1;
	}


	//--- ^[Qbg
	menu_root.add_child_menu( &menu_target,				"^[Qbg", "Target" );
	menu_root.add_command( MENU_COMMAND_TARGET_MOVE, 0, "^[Qbgt߂Ɉړ", "Move to the target" );
	if (tyProgram==3) {
        menu_root.add_child_menu( &menu_target_solarsystem,		"zn̓V", "Solar System");
	}

	menu_root.add_command(MENU_COMMAND_GOTO, 0,	"n", "Go to Earth");

	if (tyProgram>=0 && tyProgram<=4) {
		menu_root.add_command(MENU_COMMAND_PRESET, PRESET_SOLARSYSTEM_COMPLETE_VIEW,	"znSi", "Complete View of Solar System");
	}

	if (tyProgram==0 || tyProgram==1 || tyProgram==2) {
		menu_root.add_command(MENU_COMMAND_GOTO, 2,	"΂", "Go to Pleiades");
	}
	if (tyProgram==2 || tyProgram==4) {
		menu_root.add_command(MENU_COMMAND_GOTO, 3,	"M13", "Go to M13");
	}
	if (tyProgram==2) {
		menu_root.add_command(MENU_COMMAND_GOTO, 4,	"͌nS", "Go to Galactic Center");
	}
	if (tyProgram==3) {
			menu_root.add_command(MENU_COMMAND_GOTO, 1, "JbV[j", "Go to Cassini");
	}
	if (tyProgram==4) {
		menu_root.add_child_menu( &menu_target_spacecraft, "T@", "Go to Spacecraft" );
	}
	if (tyProgram==4) {
		menu_root.add_command(MENU_COMMAND_PRESET, PRESET_SPACECRAFT_PATH, "T@̋O", "Display Trajectory of Spacecraft");
	}
	if (tyProgram==5) {
		menu_root.add_command(MENU_COMMAND_GOTO, 5,	"Ƃߍ͒c", "Go to Virgo Cluster");
	}


	char strJ[256], strE[256];
	sprintf(strJ, "%s֒", szLandingPosNameJ);
	sprintf(strE, "Landing on %s", szLandingPosNameE);
	menu_root.add_command(MENU_COMMAND_LANDING_INIT, 0,	strJ, strE);

	menu_root.add_child_menu( &menu_time,				"", "Time" );
	

	// [r[쐬j[
	if (bEnableMovieMake) {
		menu_root.add_child_menu( &menu_path,				"pXݒ", "Set Path" );
	}
	
	// VXej[
	if (bEnableSystemMenu) {
		menu_root.add_child_menu( &menu_system,				"VXe", "System" );
	}
}



//-- j[̏
void
init_menu()
{
	//-- [gj[
	init_root_menu();


	//-- \ݒ胁j[
	menu_disp.set_title("\ݒ", "Display Settings");
	menu_disp.add_child_menu( &menu_planet,				"f",			"Planets" );
	menu_disp.add_child_menu( &menu_satellite,			"q",			"Satellites" );
	menu_disp.add_child_menu( &menu_minor_planet,		"f",		"Minor Planets" );
	menu_disp.add_child_menu( &menu_TNO,				"znOV",	"Transneptunian Objects" );
	
	menu_disp.add_child_menu( &menu_star,				"P",			"Stars" );
	menu_disp.add_child_menu( &menu_cnst,				"",			"Constellations" );
	menu_disp.add_child_menu( &menu_spacecraft,			"T@̋O",	"Trajectory of Spacecraft" );
	menu_disp.add_child_menu( &menu_clst_sphere,		"V̐",		"Milky Way" );
	menu_disp.add_child_menu( &menu_galaxy,				"",			"Galaxies" );
	menu_disp.add_check( MENU_CHECK_NGC,				"NGCV",		"NGC Objects", 0, false );
	menu_disp.add_child_menu( &menu_grid,				"oܐ",		"Grid" );
	menu_disp.add_command( MENU_COMMAND_RESET_VIEWANGLE, 0, "pZbg", "Reset View Angle" );
	menu_disp.add_check( MENU_CHECK_SIDE_LIGHT,			"wbhCg",	"Headlight", 0, false );
	menu_disp.add_check( MENU_CHECK_SURFACE_POINTER,	"n\̃|C^",	"Surface Pointer", 0, false );
	menu_disp.add_check( MENU_CHECK_VIEW_INFO,			"_",		"View Info", 0,		true );

	//-- ^[QbgṼj[
	menu_target.set_title("^[Qbg", "Target" );
	menu_target.add_child_menu( &menu_target_solarsystem,	"zn",	"Solar System Objects" );
	menu_target.add_child_menu( &menu_target_spacecraft,	"T@",	"Spacecraft" );
	menu_target.add_child_menu( &menu_target_galactic,		"P",		"Stars" );
	menu_target.add_child_menu( &menu_target_extragalactic,	"͌nOV", "Extragalactic Objects" );
	menu_target.add_command( MENU_COMMAND_TARGET_MOVE, 0, "^[Qbgt߂Ɉړ", "Go to the Target" );


	//--- zn^[Qbg ---
	const menu_item_def  mdf_ss[] = {
		{ "z",	"Sun",		1 },
		{ "",	"Mercury",	2 },
		{ "",	"Venus",	3 },
		{ "n",	"Earth",	4 },
		{ "ΐ",	"Mars",		5 },
		{ "ؐ",	"Jupiter",	6 },
		{ "y",	"Saturn",	7 },
		{ "V",	"Uranus",	8 },
		{ "C",	"Neptune",	9 },
		{ "",	"Pluto",	10 },
		{ "GX",	"Eris",		11 },
		{ "Zhi",	"Sedna",	12 },
		{ "",		"Moon",		13 },
		{ "CI",	"Io",		14 },
	};
	init_option_menu( menu_target_solarsystem, 14, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_ss, 0);


	//--- T@^[Qbg ---
	const menu_item_def  mdf_spccrf[] = {
		{ "pCIjAPO",	"Pioneer10",	15 },
		{ "pCIjAPP",	"Pioneer11",	16 },
		{ "{CW[P",	"Voyager I",	17 },
		{ "{CW[Q",	"Voyager II",	18 },
		{ "JbV[j",		"Cassini",		19 },
	};
	init_option_menu( menu_target_spacecraft, 5, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_spccrf, 0);


	//--- ͌n^[Qbg ---
	const menu_item_def  mdf_galactic[] = {
		{ "At@EP^E",	"Alpha Centauri",	20 },
		{ "VEX",				"Sirius",			21 },
		{ "΂",				"Pleiades",			22 },
		{ "JXg",				"Castor",			23 }
	};
	init_option_menu( menu_target_galactic, 4, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_galactic, 0);



	//--- ͌nO^[Qbg ---
	const menu_item_def  mdf_extragalactic[] = {
		{ "M13",			"M13",							24 },
		{ "͌nS",		"Galactic Center",				25 },
		{ "͌nSi",		"Complete View of Our Galaxxy",	26 },
		{ "Ah_",	"Andromeda Galaxy",				27 },
		{ "Ƃߍ͒c",	"Virgo Cluster",				28 },
		{ "F̑K͍\",	"Large Scale Structure of the Universe", 29 }
	};
	init_option_menu( menu_target_extragalactic, 6, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_extragalactic, 0);


	//-- j[ --
	menu_time.set_title("", "Time");
	menu_time.add_check( MENU_CHECK_DATE,					"̕\",			"Display Date",		0, false );
	menu_time.add_command( MENU_COMMAND_PRESENT_TIME, 0,	"݂̎ɐݒ",	"Set to Present Time" );
	menu_time.add_child_menu( &menu_timestep,				"i߂鎞",			"Time Step" );
	menu_time.add_check( MENU_CHECK_REALTIME_MODE, 			"ԃ[h",		"Realtime Mode",	0, false );

	//-- Cxg
	menu_preset.set_title("vZbg", "Preset");
	menu_preset.add_command( MENU_COMMAND_PRESET, PRESET_MARS_2003,			"ΐڋ", "Mars 2003");
	menu_preset.add_command( MENU_COMMAND_PRESET, PRESET_SPACECRAFT_PATH,	"T@̋O", "Trajectory of Spacecraft");
    
	//-- VXej[
	menu_system.set_title("VXeݒ", "System");
	menu_system.add_child_menu( &menu_program,			"ԑg̑I",		"Select Program");
	menu_system.add_child_menu( &menu_lang,				"",			"Language" );
	menu_system.add_child_menu( &menu_font_size,		"TCY",		"Text Size" );
	menu_system.add_check( MENU_CHECK_FULLSCREEN,		"Sʃ[h",	"FullScreen Mode",0,	true );
	menu_system.add_check( MENU_CHECK_SUBTITLES,		"[h",		"Subtitle Mode",0,	true );
	menu_system.add_check( MENU_CHECK_TITLE,			"^Cg",		"Title",		0,	true );
	menu_system.add_check( MENU_CHECK_ABOUT,			"o[W",	"Version Info",	0,	true );
	menu_system.add_check( MENU_CHECK_DEBUG,			"fobO",	"Debug Info",	0,	true );
	menu_system.add_check( MENU_CHECK_SINGLE_EYE,		"Eڗpf̂",	"Only Right Eye Image", 0,	true );
	menu_system.add_command( MENU_COMMAND_EXIT_ALL,		0, "SI", "Exit All" );

	//-- ԑgI
	const int menu_program_num = ThemeNum;
	const menu_item_def  mdf_program[ThemeNum] = {
		{ "F̊Kw\i_CWFXgŁj",	"Hierarchical Structure of the Universe (Digest)",	0 },
		{ "F̊Kw\iWjAŁj",		"Hierarchical Structure of the Universe (Junior)",	1 },
		{ "V̐̔閧",						"Milky Way",										2 },
		{ "znIs",						"Solar System",										3 },
		{ "znz",					"Beyond the Solar System",							4 },
		{ "͂̐E",						"World of Galaxies",								5 },
		{ "Փ˂",						"Colliding Galaxies",								6 }
	};
	init_option_menu( menu_program, menu_program_num, MENU_CHECK_PROGRAM, "ԑgI", "Select Program", mdf_program, 0);

	//-- tHgTCYEj[
	const int menu_font_size_num = 5;
	const menu_item_def  mdf_font_size[] = {
		{ "ő",		"Largest",		0},
		{ "",			"Larger",		1 },
		{ "",			"Middle",		2 },
		{ "",			"Smaller",		3 },
		{ "ŏ",		"Smallest",		4 }
	};
	init_option_menu( menu_font_size, menu_font_size_num, MENU_CHECK_FONT_SIZE, "TCY", "Text Size", mdf_font_size, 0);


	//-- pXj[
	menu_path.set_title("pXݒ", "Pass Settings");
	menu_path.add_check( MENU_CHECK_PATH_INFO,			"pX",	"Path Info", 0, true );
	menu_path.add_command( MENU_COMMAND_PLAY_PATH,	0,	"pX̍Đ", "Play Path" );
	menu_path.add_command( MENU_COMMAND_SAVE_PATH,	0,	"pXۑ", "Save Path" );
	menu_path.add_command( MENU_COMMAND_LOAD_PATH,	0,	"pX̓Ǎ", "Load Path" );
	menu_path.add_command( MENU_COMMAND_CLEAR_PATH,	0,	"pX̃NA", "Clear Path" );

	//-- [r[
	menu_movie.set_title("[r[", "Movies");
	for (int i=0; i<MVF.size(); i++) {
		menu_movie.add_command(MENU_COMMAND_MOVIE_OPEN, i, MVF[i].menu_title, MVF[i].menu_title);
	}

	//-- 摜
	menu_image.set_title("摜", "Images");
	for (int i=0; i<IMGF.size(); i++) {
		menu_image.add_command(MENU_COMMAND_IMAGE_OPEN, i, IMGF[i].menu_title, IMGF[i].menu_title);
	}

	//-- 
	menu_audio.set_title("", "Audio");
	for (int i=0; i<AUDF.size(); i++) {
		menu_audio.add_command(MENU_COMMAND_AUDIO_OPEN, i, AUDF[i].menu_title, AUDF[i].menu_title);
	}


	//-- Rc`[g
	menu_3Dchart.set_title("Rc`[g", "3D Chart");
	menu_3Dchart.add_command( MENU_COMMAND_3DCHART, _3DCHART_PLANETS,			"zn̘f",	"Planets");
	menu_3Dchart.add_command( MENU_COMMAND_3DCHART, _3DCHART_DWARF_PLANETS,		"znOV",	"Large TNOs");
	menu_3Dchart.add_command( MENU_COMMAND_3DCHART, _3DCHART_STAR_COLOR,		"̐FƉx",	"Color and Temperature of Stars");

	//-- j[
	menu_cnst.set_title("", "Constellations");
	menu_cnst.add_check( MENU_CHECK_CNST_NAME,			"",	"Names",	0, false );
	menu_cnst.add_check( MENU_CHECK_CNST_LINE,			"",	"Lines",	0, false );
	menu_cnst.add_check( MENU_CHECK_CNST_ILLUST,		"G",	"Illustrations", 0, false );
	menu_cnst.add_check( MENU_CHECK_CNST_BND,			"E",	"Boundaries", 0, false );

	//-- Pj[
	menu_star.set_title("P", "Stars");
	menu_star.add_check( MENU_CHECK_STAR,				"̕\",	"Display Stars",	0,	false );
	menu_star.add_check( MENU_CHECK_STAR_NAME,			"ŗL",	"Proper Name",		0,	false );
	menu_star.add_check( MENU_CHECK_STAR_NAME_SELECT,	"IŗL̂", "Selected Proper Name", 0,	false );
	menu_star.add_check( MENU_CHECK_STAR_BAYER,			"oCG",	"Bayer Name",		0,			false );
	menu_star.add_check( MENU_CHECK_STAR_FRAMSTEED,		"tX`[hԍ", "Flamsteed Number", 0,	false );
	menu_star.add_check( MENU_CHECK_STAR_HIP,			"HIPԍ", "HIP Number",			0,			false );
	menu_star.add_command( MENU_COMMAND_STAR_BRIGHTEN,	0, "邭", "Brighten" );
	menu_star.add_command( MENU_COMMAND_STAR_DARKEN,	0, "Â",	"Darken" );
	menu_star.add_command( MENU_COMMAND_STAR_DEFAULT_BRIGHTNESS,	0, "W̖邳", "Default Brightness" );
	menu_star.add_child_menu( &menu_star_mark, "}[N", "Mark" );

	//-- ̃}[N
	const int menu_star_mark_num = 3;
	const menu_item_def  mdf_star_mark[] = {
		{ "Ȃ",	"None",						0 },
		{ "An",	"Binary Stars",				1 },
		{ "nOf",	"Stars with Exoplanets",	2 }
	};
	init_option_menu( menu_star_mark, menu_star_mark_num, MENU_CHECK_STAR_MARK, "}[N", "Mark",  mdf_star_mark, tyStarMark);


	//-- fj[
	menu_planet.set_title("f", "Planets");
	menu_planet.add_check( MENU_CHECK_PLANETS,				"f",		"Planets",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_NAME,			"O",		"Names",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_ORBIT,			"O",		"Orbits",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_AXIS,			"]",	"Axis of Rotation", 0,	false );
	menu_planet.add_child_menu( &menu_atmosphere,			"C",		"Atmosphere" );
	menu_planet.add_check( MENU_CHECK_PLANET_CLOUD,			"_",		"Cloud",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_CITY_LIGHTS,	"X",	"City Lights",	0,		false );
	menu_planet.add_child_menu( &menu_eclipse,				"̉e",	"Shadow of Moon");
	menu_planet.add_child_menu( &menu_zoom_mode,			"g嗦", "Zoom Rate" );
	menu_planet.add_child_menu( &menu_topo_zoom,			"n`̔{", "Amplification of Topography" );
	menu_planet.add_child_menu( &menu_landing_mode,			"[h", "Landing Mode");


	//-- qj[
	menu_satellite.set_title("q", "Satellites");
	menu_satellite.add_check( MENU_CHECK_SATELLITE_DISP,	"\",			"Display",					0,		false );
	menu_satellite.add_check( MENU_CHECK_SATELLITE_NAME,	"O",			"Names",					0,		false );
	menu_satellite.add_check( MENU_CHECK_SATELLITE_ORBIT,	"O",			"Orbits",					0,		false );
	menu_satellite.add_check( MENU_CHECK_SATELLITE_SELECT,	"ȉq̂",	"Selected Satellites Only",	0,		false );

	//-- fj[
	menu_minor_planet.set_title("f", "Minor Planets");
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_DISP,		"\",				"Display",				0,		false );
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_NAME,		"O",				"Names",				0,		false );
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_ORBIT,		"O",				"Orbits",				0,		false );
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_SELECT,	"If̂",	"Selected Objects Only",0,		false );

	//-- TNOj[
	menu_TNO.set_title("znOV", "Transneptunian Objects");
	menu_TNO.add_check( MENU_CHECK_TNO_DISP,		"\",				"Display",					0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_NAME,		"O",				"Names",					0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_ORBIT,		"O",				"Orbits",					0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_SELECT,		"IV̂̂",	"Selected Objects Only",	0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_OORT_CLOUD,	"I[g̉_",		"Oort Cloud",				0,		false );


	//--- [h ---
	const menu_item_def  mdf_landing_mode[] = {
		{ "n[h",		"Horizontal",		LANDING_MODE_HORIZONTAL },
		{ "n\ώ@[h",	"Surface View",		LANDING_MODE_SURFACE_VIEW }
	};
	init_option_menu( menu_landing_mode, 2, MENU_CHECK_LANDING_MODE, "[h", "Landing Mode", mdf_landing_mode, 0);



	//-- Cj[
	const int menu_atmosphere_num = 3;
	const menu_item_def  mdf_atmosphere[] = {
		{ "Ȃ",				"None",					ATMOSPHERE_NONE },
		{ "iPUj",		"Single Scattering",	ATMOSPHERE_SINGLE },
		{ "idUj",		"Multiple Scattering",	ATMOSPHERE_MULTIPLE }
	};
	init_option_menu( menu_atmosphere, menu_atmosphere_num, MENU_CHECK_PLANET_ATMOSPHERE, "C", "Atmosphere", mdf_atmosphere, AtmosphereMode );

	//-- ̉ej[
	menu_eclipse.set_title("̉e", "Shadow of Moon");
	menu_eclipse.add_check( MENU_CHECK_ECLIPSE_DISP,	"\",				"Display",						0,	false );
	menu_eclipse.add_check( MENU_CHECK_ECLIPSE_BORDER,	"{eEe̋E",	"Borders of Umbra/Penumbra",	0,	false );



	//-- g嗦j[
	const int menu_zoom_mode_num = 4;
	const menu_item_def  mdf_zoom[] = {
		{ "{",	"Real Scale",	0 },
		{ "gP",	"Zoom 1",		1 },
		{ "gQ",	"Zoom 2",		2 },
		{ "gR",	"Zoom 3",		3 }
	};
	init_option_menu( menu_zoom_mode, menu_zoom_mode_num, MENU_CHECK_PLANET_ZOOM, "g嗦", "Zoom Rate", mdf_zoom, get_zoom_mode());


	//-- n`{j[
	const int menu_topo_zoom_num = 5;
	const menu_item_def  mdf_topo_zoom[] = {
		{ "{",	"Real Scale",	0 },
		{ "Q{",	"x2",			1 },
		{ "T{",	"x5",			2 },
		{ "PO{",	"x10",			3 },
		{ "QO{",	"x20",			4 }
	};
	init_option_menu( menu_topo_zoom, menu_topo_zoom_num, MENU_CHECK_TOPO_ZOOM, "n`̔{", "Amplification of Topography", mdf_topo_zoom, get_topo_zoom_mode());

	//-- T@j[
	menu_spacecraft.set_title("O̕\", "Trajectory of Spacecraft");
	for (int i=0; i<5; i++) {
		const bilingual& name = get_spacecraft_name(i);
		menu_spacecraft.add_check( MENU_CHECK_SPACECRAFT_PATH,	name.text_J, name.text_E, i,		false );
	}



	//-- V̐상j[
	const int menu_clst_sphere_num = 4;// WMAP ͎bIɊO
	const menu_item_def  mdf_milkyway[] = {
		{ "Ȃ",				"None",					0 },
		{ "V̐",				"Milky Way",			1 },
		{ "邢V̐",			"Bright Milky Way",		2 },
		{ "ԊOŌV̐",	"Infrared Milky Way",	3 }
	};
	init_option_menu( menu_clst_sphere, menu_clst_sphere_num, MENU_CHECK_MILKYWAY, "V̐", "Milky Way", mdf_milkyway, tyMilkyWay);


	//-- ̓j[
	menu_galaxy.set_title("", "Galaxy");
	menu_galaxy.add_check( MENU_CHECK_OUR_GALAXY,		"͌n",	"Our Galaxy",			0,		false );
	menu_galaxy.add_check( MENU_CHECK_GLOBULAR_CLUSTER,	"󐯒c",	"Globular Clusters",	0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_NEAR,		"ߖT",	"Nearby Galaxies",		0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_SDSS,		"SDSS ", "SDSS Galaxies",		0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_QSO,		"NG[T[", "SDSS QSOs",			0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_VIRGO,		"Ƃߍ͒c}[N", "Mark Galaxies in Virgo Cluster", 0,	false );


	//-- KChj[
	menu_grid.set_title("oܐEXP[", "Grid/Scale");
	menu_grid.add_check( MENU_CHECK_CLST_GRD,				"ԌoEԈ",	"Equatorial Grid",			0,	false );
	menu_grid.add_check( MENU_CHECK_ECLIPTIC,				"",		"Ecliptic",					0,	false );
	menu_grid.add_check( MENU_CHECK_HORIZON_COORD,			"nW",	"Horizontal Coordinate",	0,	false );
	menu_grid.add_check( MENU_CHECK_GLX_GRD,				"oE",	"Galactic Coordinate",		0,	false );
	menu_grid.add_check( MENU_CHECK_DIST_SCALE,				"XP[i~j",   "Scale Circles",	0,	false );
	menu_grid.add_check( MENU_CHECK_SCALE_SQUARE,			"XP[ilpj", "Scale Squares",	0,	false );


	//-- ^CXebvj[ --
	const int menu_timestep_num = 9;
	const menu_item_def  mdf_timestep[] = {
		{ "POb",	"10 sec",	0 },
		{ "P",	"1 min",	1 },
		{ "PO",	"10 min",	2 },
		{ "P",	"1 hour",	3 },
		{ "P",	"1 day",	4 },
		{ "P",	"1 month",	5 },
		{ "PN",	"1 year",	6 },
		{ "PON",	"10 years",	7 },
		{ "POON",	"100 years",8 }
	};
	init_option_menu( menu_timestep, menu_timestep_num, MENU_CHECK_TIME, "i߂鎞", "Time Step", mdf_timestep, tyTimeStep);


	//-- ꃁj[
	const int menu_lang_num = 3;
	const menu_item_def  mdf_lang[] = {
		{ "{irj",	"Japanese with Kana Reading",	0 },
		{ "{irȂj",	"Japanese",						1 },
		{ "p",				"English",						2 }
	};
	init_option_menu( menu_lang, menu_lang_num, MENU_CHECK_LANG, "̑I", "Language", mdf_lang, get_language());



	//-- color
	const float f=1.3;
	const float alpha = 0.7;
	mnu_col.txt_color.set(0.647,0.623,0.647,1);
	mnu_col.select_color.set(0.87,0.87,0.827,1);
	mnu_col.bg_color.set(0.274,0.305,0.392,0.7);
	mnu_col.bd_color.set(0.36,0.4,0.52,1);
	mnu_col.title_color.set(0.8,0.8,0.6,1);


	const float a = 0.4;
	RGBf c = a * mnu_col.txt_color.rgb;
	mnu_col_bk.txt_color.set(c.x, c.y, c.z, 1);
	c = a * mnu_col.select_color.rgb;
	mnu_col_bk.select_color.set(c.x, c.y, c.z, 1);
	c = a * mnu_col.bg_color.rgb;
	mnu_col_bk.bg_color.set(c.x, c.y, c.z, 0.7);
	c = a * mnu_col.bd_color.rgb;
	mnu_col_bk.bd_color.set(c.x, c.y, c.z, 1);
	c = a * mnu_col.title_color.rgb;
	mnu_col_bk.title_color.set(c.x, c.y, c.z, 1);
}




//-------------
// Check Menu
//-------------
void
set_root_menu_checks()
{
	if (tyProgram==5) {
		menu_root.set_check(virgo_menu_idx, bVirgoCluster);
	}
}




void
set_menu_checks()
{
	//-- [g
	set_root_menu_checks();



	//-- ԑg
	menu_program.set_check(tyProgram);


	//-- ړE^[Qbg
	menu_target_solarsystem.reset_check();
	menu_target_spacecraft.reset_check();
	menu_target_galactic.reset_check();
	menu_target_extragalactic.reset_check();


	const mtk_target&  tgt = get_current_target();
	switch (tgt.cls) {
		case TGTCLS_SUN:
			menu_target_solarsystem.set_check(0);
			break;
		case TGTCLS_PLANET:
			menu_target_solarsystem.set_check(1 + tgt.id2);
			break;
		case TGTCLS_SMALL_OBJECT:
			menu_target_solarsystem.set_check(10 + tgt.id2);
			break;
		case TGTCLS_SATELLITE:
			menu_target_solarsystem.set_check(12 + tgt.id2);
			break;
		case TGTCLS_PROBE:
			menu_target_spacecraft.set_check(tgt.id1);
			break;
		case TGTCLS_STAR:
			menu_target_galactic.set_check(tgt.id2);
			break;
		case TGTCLS_FIXED:
			menu_target_extragalactic.set_check(tgt.id1);
			break;
		default:
			break;
	}


	//-- 
	menu_time.set_check(0, bDate);
	menu_time.set_check(3, GetRealtimeMode());
	
	//-- ^CXebv
	menu_timestep.set_check(tyTimeStep);

	//-- VXe
	menu_system.set_check(3, bFullScreen);
	menu_system.set_check(4, bSubtitles);
	menu_system.set_check(5, bAppTitle);
	menu_system.set_check(6, bAbout);
	menu_system.set_check(7, bDebug);
	menu_system.set_check(8, bSingleEye);

	//--TCY
	for (int i=0; i<5; i++) {
		if (FontSize == vFontSize[i]) {
			menu_font_size.set_check(i);
		}
	}

	//-- pX
	menu_path.set_check(0, bPathInfo);


	//-- \ݒ
	menu_disp.set_check( 9, bNGC);
	menu_disp.set_check(12, bSideLight);
	menu_disp.set_check(13, bSurfacePointer);
	menu_disp.set_check(14, bViewInfo);


	//-- 
	menu_cnst.set_check(0, swConstellation & CNST_NAME);
	menu_cnst.set_check(1, swConstellation & CNST_LINE);
	menu_cnst.set_check(2, swConstellation & CNST_ILLUST);
	menu_cnst.set_check(3, swConstellation & CNST_BND);
	//-- P
	menu_star.set_check(0,  swStar & STAR_DISP);
	menu_star.set_check(1,  swStar & STAR_NAME);
	menu_star.set_check(2,  swStar & STAR_NAME_SELECT);
	menu_star.set_check(3,  swStar & STAR_BAYER);
	menu_star.set_check(4,  swStar & STAR_FRAMSTEED);
	menu_star.set_check(5,  swStar & STAR_HIP);
	//-- ̃}[N
	menu_star_mark.set_check(tyStarMark);

	//--  f
	menu_planet.set_check(0,	test_disp_switch(DISPSW_PLANET,			DISPM_DISP));
	menu_planet.set_check(1,	test_disp_switch(DISPSW_PLANET,			DISPM_NAME));
	menu_planet.set_check(2,	test_disp_switch(DISPSW_PLANET,			DISPM_ORBIT));
	menu_planet.set_check(3,	test_disp_switch(DISPSW_PLANET,			DISPM_AXIS));
	menu_planet.set_check(5,	test_disp_switch(DISPSW_PLANET,			DISPM_CLOUD));
	menu_planet.set_check(6,	test_disp_switch(DISPSW_PLANET,			DISPM_CITY_LIGHTS));

	//--  q
	menu_satellite.set_check(0,	test_disp_switch(DISPSW_SATELLITE,		DISPM_DISP));
	menu_satellite.set_check(1,	test_disp_switch(DISPSW_SATELLITE,		DISPM_NAME));
	menu_satellite.set_check(2,	test_disp_switch(DISPSW_SATELLITE,		DISPM_ORBIT));
	menu_satellite.set_check(3,	test_disp_switch(DISPSW_SATELLITE,		DISPM_SELECT));

	//--  f
	menu_minor_planet.set_check(0,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_DISP));
	menu_minor_planet.set_check(1,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_NAME));
	menu_minor_planet.set_check(2,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_ORBIT));
	menu_minor_planet.set_check(3,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_SELECT));

	//--  TNO
	menu_TNO.set_check(0,	test_disp_switch(DISPSW_TNO,		DISPM_DISP));
	menu_TNO.set_check(1,	test_disp_switch(DISPSW_TNO,		DISPM_NAME));
	menu_TNO.set_check(2,	test_disp_switch(DISPSW_TNO,		DISPM_ORBIT));
	menu_TNO.set_check(3,	test_disp_switch(DISPSW_TNO,		DISPM_SELECT));
	menu_TNO.set_check(4,	bOortCloud);


	//-- C
	menu_atmosphere.set_check(AtmosphereMode);

	//--  ̉e
	menu_eclipse.set_check(0, swEclipse & ECLIPSE_DISP);
	menu_eclipse.set_check(1, swEclipse & ECLIPSE_BORDER);


	//-- g嗦
	menu_zoom_mode.set_check(get_zoom_mode());
	menu_topo_zoom.set_check(get_topo_zoom_mode());

	//-- [h
	menu_landing_mode.set_check(get_landing_mode());

	//-- T@
	for (int i=0; i<5; i++) {
		menu_spacecraft.set_check(i, get_spacecraft_path_mode(i) );
	}

	//-- 
	menu_galaxy.set_check(0, swGalaxy & GLXY_OUR_GALAXY);
	menu_galaxy.set_check(1, swGalaxy & GLXY_GLOB_CLSTR);
	menu_galaxy.set_check(2, swGalaxy & GLXY_NEARBY_GALAXY);
	menu_galaxy.set_check(3, swGalaxy & GLXY_DISTANT_GALAXY);
	menu_galaxy.set_check(4, swGalaxy & GLXY_QSO);
	menu_galaxy.set_check(5, bVirgoCluster);

	//-- V̐
	menu_clst_sphere.set_check(tyMilkyWay);

	//-- KCh
	menu_grid.set_check(0, bCelestialGrid);
	menu_grid.set_check(1, bEcliptic);
	menu_grid.set_check(2, bHorizonCoord);
	menu_grid.set_check(3, bGalacticGrid);
	menu_grid.set_check(4, swScaleLine & SCALE_CIRCLE);
	menu_grid.set_check(5, swScaleLine & SCALE_SQUARE);

	//-- 
	char lang = get_language();
	menu_lang.set_check(lang);
}






//---------
//  Color
//---------
const RGBAf    col_clst_grd(0.5,0.4,0.4,0.8);		// celestial grid
const RGBAf    col_glx_grd(0.0,0.7,0.6,0.9);		// galactic grid
const RGBAf    col_RA_DEC(0.6,0.4,0.4,0.8);			// RA, DEC





//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Init


bool
load_data()
{
	directory  dir = get_directory(DIR_DATA);


	//------------------
	//  init constants
	//------------------
	fixed_target_pos[1] = M_G2E * vector3f(8000, 0,0);



	FILE *fp;



	//-----------------------
	//  Load Hipparcos Data
	//-----------------------
	SetSplashText("Pf[^ǂݍݒ...", "Loading star data...");
	bData = false;
	if ((fp=dir.fopen("hip.dat", "rb")) == NULL)  return false;		// open the Hipparcos catalogue

	bool res;
	res = load_Hipparcos_data_2(fp);
	fclose(fp);

	bData = res;


	//-------------------
	//  Load star names
	//-------------------
	SetSplashText("P̖Of[^ǂݍݒ...", "Loading star name data...");
	load_star_common_names(dir);
	make_star_name_text_2(swStar, swConstellation);



	//------------------------
	//  Load Exoplanets List
	//------------------------
	SetSplashText("nOff[^ǂݍݒ...", "Loading exoplanet data...");
	load_exoplanet_list( dir.get_path("exoplanets_list.dat") );


	//---------------------------
	//  Load Small Objects data
	//---------------------------
	bilingual  bszSmallObjectText[SMALLOBJ_TYPE_NUM] = {
		{ "Loading asteroid data...", "ff[^ǂݍݒ..." },
		{ "Loading TNO data...", "TNOf[^ǂݍݒ..." }
	};
	const char szSmallObjFileName[SMALLOBJ_TYPE_NUM][20] = {
		"mp.dat",
		"TNO.dat"
	};
	for (int i=0; i<SMALLOBJ_TYPE_NUM; i++) {
		bilingual& bt = bszSmallObjectText[i];
		SetSplashText( bt.text_J, bt.text_E );
		if ((fp=dir.fopen( szSmallObjFileName[i], "rb")) == NULL)  return false;
		load_small_objects(fp, i);
		fclose(fp);
	}


	if ((fp=dir.fopen("small_objects_name.dat", "rt")) != NULL) {
		load_small_object_names(fp);
		fclose(fp);
	}
	




	//**********
	init_planets_orbital_elements();
	register_planets_orbit_curves();
	register_satellites_orbit_curves();
	register_small_objects_orbit_curves();
	register_scale_circle_curves();
	//**********



	//--------------------
	//  Load Galaxy data
	//--------------------
	
	//-- NBG catalogue
	SetSplashText("ߖT̓f[^ǂݍݒ...", "Loading nearby galaxy data...");
	res = load_nearby_galaxies(dir);

	//-- SDSS galaxies
	SetSplashText("̓f[^ǂݍݒ...", "Loading distant galaxy data...");
	res = load_distant_galaxies(dir);

	//-- SDSS QSOs
	SetSplashText("QSOf[^ǂݍݒ...", "Loading QSO data...");
	res = load_QSOs(dir);



	//------------------------------
	//  Load Globular Cluster data
	//------------------------------
	SetSplashText("󐯒cf[^ǂݍݒ...", "Loading globular cluster data...");
	res = load_globular_cluster_data(dir);


	//-------------------------
	//  Load Our Galaxy Model
	//-------------------------
	SetSplashText("͌nff[^ǂݍݒ...", "Loading our galaxy model...");
	load_our_galaxy_model(dir);

	//-------------------------------
	//  Load Globular Cluster Model
	//-------------------------------
	SetSplashText("󐯒cff[^ǂݍݒ...", "Loading globular cluster model...");
	load_GC_model(dir);


	//-----------------
	//  Load NGC data
	//-----------------
	SetSplashText("NGCf[^ǂݍݒ...", "Loading NGC data...");
	if ((fp=dir.fopen("ngc.dat", "rb")) == NULL)  return false;		// open the NGC catalogue
	res = read_NGC_data(fp);
	fclose(fp);


	if ((fp=dir.fopen("names.dat", "rb")) != NULL) {	// open the NGC common name catalogue
		set_NGC_name(fp);
		fclose(fp);
	}


	//-------------------------------
	//  Load Constellation Data 2
	//-------------------------------
	SetSplashText("f[^ǂݍݒ...", "Loading constellation data...");
	load_constellations(dir);


	//-----------------------------
	//  Load Constellation illust
	//-----------------------------
	SetSplashText("Gf[^ǂݍݒ...", "Loading constellation illustration...");
	load_constellation_illusts(dir);



	//-------------------
	//  Init Oort Cloud
	//-------------------
	SetSplashText("I[g̉_...", "Initializing Oort cloud...");
	init_Oort_cloud();

	//-------------------------
	//  Init Globular Cluster
	//-------------------------
	SetSplashText("󐯒c...", "Initializing globular cluster...");
	init_globular_cluster_points();

	//---------------
	//  Init M87 GC
	//---------------
	init_M87_GC();


	//----------------------
	// Planetary ephemeris
	//----------------------
	SetSplashText("fʒuf[^ǂݍݒ...", "Loading CF96 catalogue...");
	load_CF96( dir.get_path("cf96.dat") );


	//----------------------
	//  Earth's atmosphere
	//----------------------
	SetSplashText("nCf[^ǂݍݒ...", "Loading Earth's atmosphere data...");
	init_multiple_scattering( dir.get_path("emmap.dat") );

	//--------------------
	//  Earth topography
	//--------------------
	SetSplashText("n̒n`f[^ǂݍݒ...", "Loading topography of Earth...");
	load_earth_topograph(dir, "earth_topo.dat");


	//-------------------
	//  Mars topography
	//-------------------
	SetSplashText("ΐ̒n`f[^ǂݍݒ...", "Loading topography of Mars...");
	load_mars_topograph(dir, "mars_topo.dat");


	//--------------
	//  Spacecraft
	//--------------
	SetSplashText("T@f[^ǂݍݒ...", "Loading spacecraft models...");
	init_spacecraft();


	//================
	//  init objects
	//================
	init_objects();

	return res;
}










//
//
//
void
init_window_size(int x, int y, int w, int h, int mgn_w, int mgn_h)
{
	// XN[TCY
	disp_w = GetSystemMetrics( SM_CXSCREEN );
	disp_h = GetSystemMetrics( SM_CYSCREEN );


	// EBhETCY̕␳
	if (!bNetwork) {
		w += 2 * GetSystemMetrics(SM_CXSIZEFRAME);
		h += 2 * GetSystemMetrics(SM_CXSIZEFRAME) + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU);
	}

	// \̈̐ݒ
	int x1,y1, x2,y2;
	if (w<=0)  w=1;
	if (h<=0)  h=1;
	x1 = x;
	y1 = y;
	x2 = x + w - 1;
	y2 = y + h - 1;

	if (x1<0)  x1=0;
	if (y1<0)  y1=0;
	if (x2>=disp_w)  x2 = disp_w - 1;
	if (y2>=disp_h)  y2 = disp_h - 1;
	w = x2 - x1 + 1;
	h = y2 - y1 + 1;

	win_x1 = x1;
	win_y1 = y1;
	win_x2 = x2;
	win_y2 = y2;
	win_w  = w;
	win_h  = h;


	// }[W̐ݒ
	if (mgn_w < 0)  mgn_w = 0;
	if (mgn_h < 0)  mgn_h = 0;
	x1 = win_x1 - mgn_w;
	y1 = win_y1 - mgn_h;
	x2 = win_x2 + mgn_w;
	y2 = win_y2 + mgn_h;
	if (x1<0)  x1=0;
	if (y1<0)  y1=0;
	if (x2>=disp_w)  x2 = disp_w - 1;
	if (y2>=disp_h)  y2 = disp_h - 1;

	win_x0 = x1;
	win_y0 = y1;
	win_w0 = x2 - x1 + 1;
	win_h0 = y2 - y1 + 1;



	win_mgn_w1 = win_x1 - win_x0;
	win_mgn_h1 = win_y1 - win_y0;
	win_mgn_w2 = x2 - win_x2;
	win_mgn_h2 = y2 - win_y2;


	// OpenGL p̕\̈̐ݒ
	gl_x0 = win_x1 - win_x0;
	gl_y0 = win_y1 - win_y0;
	gl_w  = win_w;
	gl_h  = win_h;
}




void	change_target(int tgt_no);


void
init()
{
	//-----------------------
	//  EBhETCY̐ݒ
	//-----------------------
	init_window_size(_win_x1, _win_y1, _win_w, _win_h, _mgn_w, _mgn_h);

	//-- Disp switches
	init_disp_switches();

	//-- Load data
	load_data();

	//--- galaxy color
	init_galaxy_color();


	//--- joystick
	init_joystick();


	//-- Path --
	init_path();
	
	//-- Endroll --
	init_credit_roll_text();



	//--- ^[Qbg ---
	change_target(TGTNO_EARTH);

	
	//---  ---
	//-- ̖Wɐݒ肷--
	UTC lt = get_present_LocalTime(DT);
	double t = get_JD(lt.year, lt.month, lt.day, 20, 0, 0.0) - DT/24.0; 

	init_time_JD(t);

	//-- popup
	init_popup(tyProgram);
}




//----------
//  OpenGL
//----------
void	draw_spherical_grid();
void	draw_grid_digit(const float r, const float sz);



void
load_milkyway_texture()
{
	glBindTexture(GL_TEXTURE_2D, 0);
	if (texMilkyWay != 0) {
		DeleteTextureName(texMilkyWay);
	}

	switch (tyMilkyWay) {
		case MILKYWAY_VISIBLE:
			texMilkyWay = LoadTexture("milkyway.jpg", TexShrinkRate);
			break;
		case MILKYWAY_VISIBLE2:
            texMilkyWay = LoadTexture("milkyway2.jpg", TexShrinkRate);
			break;
		case MILKYWAY_IR:
			texMilkyWay = LoadTexture("milkyway_IR.jpg", TexShrinkRate);
			break;
		default:
			return;
	}
}




void
initGL()
{
	glEnable( GL_DEPTH_TEST );

	glClearColor( 0.0, 0.0, 0.0, 0.0 );
	glClearDepth( z_mid );
	
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glPixelStorei(GL_PACK_ALIGNMENT, 1);


	glHint(GL_POINT_SMOOTH_HINT, GL_DONT_CARE);
	glHint(GL_LINE_SMOOTH_HINT,  GL_NICEST);
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glReadBuffer(GL_BACK);
	glDrawBuffer(GL_BACK);




	//-- AEgCtHg쐬
	init_font();


	//----------
	//  Lights
	//----------
	glEnable(GL_LIGHT0);
	GLfloat ambient[]  = {0.0, 0.0, 0.0, 1.0 };
	GLfloat diffuse[]  = {1.0, 1.0, 1.0, 1.0 };
	GLfloat specular[] = {0.5, 0.5, 0.5, 1.0 };
	glLightfv( GL_LIGHT0, GL_AMBIENT, ambient );
	glLightfv( GL_LIGHT0, GL_DIFFUSE, diffuse );
	glLightfv( GL_LIGHT0, GL_SPECULAR, specular );
	glShadeModel(GL_SMOOTH);

	GLfloat ambient1[]  = {0.5, 0.5, 0.5, 1.0 };
	GLfloat diffuse1[]  = {0.5, 0.5, 0.5, 1.0 };
	GLfloat position1[] = {0.0, 0.0, 1.0, 0.0 };
	glLightfv( GL_LIGHT1, GL_AMBIENT,  ambient1 );
	glLightfv( GL_LIGHT1, GL_DIFFUSE,  diffuse1 );
	glLightfv( GL_LIGHT1, GL_POSITION, position1 );
	glDisable(GL_LIGHT1);
	GLfloat ambient2[]  = {0.55, 0.55, 0.55, 1.0 };
	GLfloat diffuse2[]  = {0.99, 0.99, 0.99, 1.0 };
	GLfloat position2[] = {0.0, 0.0, 0.0, 1.0 };
	glLightfv( GL_LIGHT2, GL_AMBIENT,  ambient2 );
	glLightfv( GL_LIGHT2, GL_DIFFUSE,  diffuse2 );
	glLightfv( GL_LIGHT2, GL_POSITION, position2 );
	glDisable(GL_LIGHT2);

	//-----------------
	//  Display lists
	//-----------------
	SetSplashText("fBXvCXg쐬...", "Making display lists...");
	//-- VObh̃fBXvCXg̍쐬
	dlClstSphere = glGenLists(1);
	glNewList(dlClstSphere, GL_COMPILE);
		draw_spherical_grid();
	glEndList();
	dlClstDigit = glGenLists(1);
	glNewList(dlClstDigit, GL_COMPILE);
		draw_grid_digit(1.0, 1.0/100.0f);
	glEndList();

	// 
	// aŃXP[OĎgp
	dlSquare = glGenLists(1);
	glNewList(dlSquare, GL_COMPILE);
		glBegin(GL_QUADS);
			glTexCoord2f(1,1);
			glVertex3f( 1, 1,0);
			glTexCoord2f(0,1);
			glVertex3f(-1, 1,0);
			glTexCoord2f(0,0);
			glVertex3f(-1,-1,0);
			glTexCoord2f(1,0);
			glVertex3f( 1,-1,0);
		glEnd();
	glEndList();


	// ̃fBXvCXg
	init_star_display_list();


	// ͂̃fBXvCXg
	init_galaxy_display_list();

	


	//-----------
	//  Texture
	//-----------
	directory  dir = get_directory(DIR_TEXTURES);
	SetTextureDir( dir );

	glDisable(GL_TEXTURE_2D);
	image  img;

	//-- Star
	SetSplashText("̃eNX`쐬...", "Creating textures of stars...");
	init_star_textures();

	//-- Milky way
	SetSplashText("V̐̃eNX`Ǎ...", "Loading texture of Milky Way...");
	texMilkyWay = 0;
	load_milkyway_texture();

	//-- galaxy
	SetSplashText("͂̃eNX`Ǎ...", "Loading textures of galaxies...");
	load_galaxies_textures();


	load_solar_system_textures();


	SetSplashText("", "Completed");
}






//----------------
//  Obh`
//----------------
void
draw_spherical_grid()
{
	const float a = 3.1415926535f / 180.0f;
	const float b = 3.1415926535f / 12.0f;

	glBegin(GL_LINES);

	//-- o --
	for (int i=0; i<24; i+=2) {
		float  phi, cs,sn;
		phi = b * float(i);
		cs = cos(phi);
		sn = sin(phi);

		for (int j=0; j<180; j+=2) {
			float th, rho, x,y,z;

			th  = a * float(j);
			z   = cos(th);
			rho = sin(th);
			x   = rho * cs;
			y   = rho * sn;
			glVertex3f(x,y,z);

			th  = a * float(j+2);
			z   = cos(th);
			rho = sin(th);
			x   = rho * cs;
			y   = rho * sn;
			glVertex3f(x,y,z);
		}
	}


	//-- ܐ --
	for (int i=0; i<180; i+=15) {
		float th, rho, z;
		th  = a * float(i);
		z   = cos(th);
		rho = sin(th);

		for (int j=0; j<360; j+=2) {
			float phi,x,y;

			phi = a * float(j);
			x   = rho * cos(phi);
			y   = rho * sin(phi);
			glVertex3f(x,y,z);

			phi = a * float(j+2);
			x   = rho * cos(phi);
			y   = rho * sin(phi);
			glVertex3f(x,y,z);
		}
	}

	glEnd();
}


//---------------------
//  Obh̐l`
//---------------------
void
draw_grid_digit(const float r, const float sz)
{
	const float  a = pi / 180.0f;
	const float  b = pi / 12.0f;


	// ox
	for (int i=0; i<24; i+=2) {
		float th_d,phi_d;
		th_d  = 0 + 0.3;
		phi_d = float(i)/12.0f*180 -0.3;
		
		glPushMatrix();
			glRotatef(phi_d-90,0,0,1);
			glRotatef(th_d,1,0,0);
			glTranslatef(0,r,0);
			glRotatef(90, 1,0,0);

			glScalef(sz,sz,sz);
			draw_textf("%d^h", i);
		glPopMatrix();
	}

	// ܓx
	for (int i=-90; i<=90; i+=15) {
		float th_d,phi_d;
		th_d  = float(i) + 0.3;
		phi_d = 0 -0.3;
		
		glPushMatrix();
			glRotatef(phi_d-90,0,0,1);
			glRotatef(th_d,1,0,0);
			glTranslatef(0,r,0);
			glRotatef(90, 1,0,0);

			glScalef(sz,sz,sz);
			draw_textf("%d", i);
		glPopMatrix();
	}

}


void
draw_textured_square(const float& sz)
{
	glPushMatrix();
		glScalef(sz,sz,sz);
		glCallList(dlSquare);
	glPopMatrix();
}


























//==========
//  Target
//==========
void	OnCommandDraw();


void
change_target(int tgt_no)
{
	tyTarget = tgt_no;
	update_target_pos();

	double  ini_scale = get_target_ini_scale(tyTarget);
	if (ini_scale > get_current_scale() ) {
        OnSetZoom( ini_scale );
	}
}









///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Draw

float
calc_alpha(const float r1, const float r2, const float r, const float fac)
{
	if (r<r1 || r>r2)  return 0;

    const float dr1= fac*0.02f;
	const float dr2= fac*0.3f;
	float alp=1;
	if (r<r1+dr1) { alp = fabs(r-r1)/dr1; }
	if (r>r2-dr2) { alp = fabs(r-r2)/dr2; }
	alp *= 0.9f;

	return alp;
}


// fEOp
float
calc_alpha2(const mtk_draw_struct& ds, const double& r, const float rs1, const float rs2)
{
	// _̋ r ɉēxݒ肷
	float af;
	float rs = r / ds.scale;

	if (rs >= rs1)  {
		af = 1;
		if (rs < rs2)  { float t = (rs2-rs)/(rs2-rs1); af = 1-t; }
	} else {
		af = 0;
	}

	return af;
}





//---------------------
//  ԌoEԈ܂̐`
//---------------------
void
draw_celestial_grid(const mtk_draw_struct& ds, bool bDigit)
{
	const float Rmax = (tyMode == MODE_PLANETARIUM)  ?  1.00005  :  get_Rmax();

	const float lw = 2.0 / (ds.rad_per_pixel / 0.001);
	glLineWidth(lw);

	glColor4fv(col_clst_grd.get_pointer());
	glPushMatrix();
		go_to_equ_coord();	// ԓWn
		draw_grid_digit(Rmax, Rmax/40.0f );
		glScalef(Rmax,Rmax,Rmax);
		glCallList(dlClstSphere);
	glPopMatrix();
}




//---------------------
//  oE܂̐`
//---------------------
void
draw_galactic_grid(const mtk_draw_struct& ds, bool bDigit)
{
	const float Rmax = (tyMode == MODE_PLANETARIUM)  ?  1.00005 :  get_Rmax();

	const float lw = 2.0 / (ds.rad_per_pixel / 0.001);
	glLineWidth(lw);
	glColor4fv(col_glx_grd.get_pointer());
	glPushMatrix();
		go_to_galactic_coord();	// ͍Wn
		draw_grid_digit(Rmax, Rmax/40.0f);
		glScalef(Rmax,Rmax,Rmax);
		glCallList(dlClstSphere);
	glPopMatrix();
}


//------------
//  `
//------------
void
draw_ecliptic(const mtk_draw_struct& ds)
{
	float x,y,th;


	const float lw = 2.0 / (ds.rad_per_pixel / 0.001);

	glEnable(GL_DEPTH_TEST);
	if (tyMode==MODE_PLANETARIUM) {
		glColor3f(1,1,0);
		glBegin(GL_LINE_LOOP);
			for (int i=0; i<360; i+=5) {
				th = i*pi/180;
				x = cos(th);
				y = sin(th);
				glVertex3f(x,y,0);
			}
		glEnd();
	} else {
		const vector3d camera_pos = ds.camera.get_pos();

		float r = 100.0 * _1AU_pc / ds.scale;
		if (r < 0.1) return;

		float af = 1.0f;
		if (r < 0.5) af = (r-0.1)/0.4;
		

		glPushAttrib(GL_ENABLE_BIT);
		glDisable(GL_CULL_FACE);
		glEnable(GL_BLEND);

		glPushMatrix();
			glTranslatef(-camera_pos.x, -camera_pos.y, -camera_pos.z);


			float sz = 100.0 * _1AU_pc;

			glColor4f(0.8,0.8,0,af);
			glLineWidth(2*lw);
			glBegin(GL_LINES);
				glVertex3f(0,0,0);
				glVertex3f(sz,0,0);
			glEnd();
			glLineWidth(lw);
			glBegin(GL_LINES);
				glVertex3f(0,0,0);
				glVertex3f(-sz,0,0);
				glVertex3f(0,sz,0);
				glVertex3f(0,-sz,0);
			glEnd();

			glColor4f(1,1,0,0.1*af);
			glBegin(GL_QUADS);
				glVertex3f(sz,sz,0);
				glVertex3f(-sz,sz,0);
				glVertex3f(-sz,-sz,0);
				glVertex3f(sz,-sz,0);
			glEnd();
		glPopMatrix();
		glPopAttrib();
	}
}






//--------------
//  V̐`
//--------------
void
draw_milkyway(const mtk_draw_struct& ds)
{
	if (tyMilkyWay == MILKYWAY_NONE)  return;


	float af, Rmax;
	af = 1.0f;
	if (tyMode == MODE_HIPPARCOS) {
		const float dist = ds.camera.get_pos().norm();
		const float dist1 = 2000;
		const float dist2 = 3000;
		if (dist > dist1) {
			float t = (dist - dist1)/(dist2 - dist1);
			af = 1-t;
		}

		if (af <= 0.0) return;
		Rmax = get_Rmax();
	} else {
		Rmax  = 1.0;
	}

	//-- ǂݍłȂ͓ǂݍ
	if (!bMilkyWayImageLoaded) {
		load_milkyway_texture();
		bMilkyWayImageLoaded = true;
	}

	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glDisable(GL_DEPTH_TEST);
	glBindTexture(GL_TEXTURE_2D, texMilkyWay);

	
	glColor4f(1,1,1,af);
	glPushMatrix();
		go_to_galactic_coord();
		glScalef(Rmax, Rmax, Rmax);
		glRotatef(180, 0,0,1);
		glFrontFace(GL_CW);
		gl_draw_sphere(10, true);
		glFrontFace(GL_CCW);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}











// J̉ƖĂ
void
set_side_light(const mtk_draw_struct& ds)
{
	vector3d eF, eU, eR;
	ds.camera_base.get_axes(eF, eU, eR);

			
	vector3d n = normalize(0.6*eR - eF);
	float lpos[4];
	lpos[0] = n.x;
	lpos[1] = n.y;
	lpos[2] = n.z;
	lpos[3] = 0.0f;
	glLightfv( GL_LIGHT0, GL_POSITION, lpos );
}




//=============
//  3D`[g
//=============

//--------------
//  zn̘f
//--------------
void
draw_3DChart_planets()
{
	const int planets_num = 8;

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor3f(1,1,1);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_NORMALIZE);
	float mat_d[] = {1,1,1,1}, mat_a[] = {0.5,0.5,0.5,1};
	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

	const float scl = screen_w * get_title_width_ratio();
	glScalef(scl, scl, scl);
	glTranslatef(0,0,-0.5);
	float sz = 0.1;
	glScalef(sz,sz,sz);



	float pos[4];
	pos[0] = -0.4;
	pos[1] = 0;
	pos[2] = 1;
	pos[3] = 0.0f;
	glLightfv( GL_LIGHT0, GL_POSITION, pos );


	// ^Cg
	const bilingual bszTitle = { "Planets of Solar System", "{zn|悤}{f|킭}" };
	
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glColor3f(0.8,0.8,0.8);
	glPushMatrix();
		glTranslatef(0,2.4,0);
		draw_bilingual_centering(bszTitle);
	glPopMatrix();



	float size0 = get_planet_real_Re(5);
	float dmin1 = 1.1, dmin2 = 1.5;
	float dl[planets_num+2];
	float dtot = 0;
	for (int i=0; i<planets_num; i++) {
		double Re = get_planet_real_Re(i) / size0;
		float _dl;
		if (hasPlanetRing(i)) {
			double R1, R2;
			get_planet_ring_radius(i, &R1, &R2);
			_dl = 2*R2*Re;
		} else {
			_dl = 2*Re;
		}
		float dmin = (i<=3) ? dmin1 : dmin2;
		dl[i] = (_dl < dmin) ? dmin : _dl;
		dtot += dl[i];
	}
	dl[planets_num+1]=0;


	
	glTranslatef(-0.5*dtot + 0.5*dl[0],0,0);
	for (int i=0; i<planets_num; ++i) {
		//
		glPushMatrix();
			glRotatef(-90, 1,0,0);
			set_planet_orientation(i);
			glEnable(GL_TEXTURE_2D);
			glEnable(GL_LIGHTING);
			float sz = get_planet_real_Re(i)/size0;
			glScalef(sz,sz,sz);
			draw_planet2(i);
		glPopMatrix();


		// O
		glPushMatrix();
			glTranslatef(0,-1.9,0.0);
			glColor3f(0.8,0.8,0.8);
			glScalef(0.4,0.4,0.4);
			glDisable(GL_TEXTURE_2D);
			glDisable(GL_LIGHTING);
			draw_bilingual_centering( get_planet_name(i) );
		glPopMatrix();

		glTranslatef(0.5*(dl[i]+dl[i+1]),0,0);
	}

	glDisable(GL_NORMALIZE);
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
}





//--------
//  TNOs
//--------
void
draw_3DChart_TNOs()
{
	const int dwarf_planets_num = 8;

	struct dp_info {
		int no;
		bilingual name;
	};

	const dp_info DP[dwarf_planets_num] = {
		{ 136199, { "Eris",		"GX" },  },
		{ 134340, { "Pluto",	"{|߂}" } },
		{ 136108, { "2003 EL61", "2003 EL61" } },
		{  90377, { "Sedna",	"Zhi" } },
		{ 136472, { "2005 FY9",	"2005 FY9" } },
		{  90482, { "Orcus",	"INX" } },
		{  50000, { "Quaoar",	"NIA[" } },
		{  20000, { "Varuna",	"@i" } }
	};


	const double R0 = get_planet_real_Re(8);
	double Rx, Ry, Rz;
	get_small_object_size( get_small_object_index(DP[4].no), Rx, Ry, Rz );
	const float dy = 1 - Rx / R0;


	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor3f(1,1,1);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_NORMALIZE);
	float mat_d[] = {1,1,1,1}, mat_a[] = {0.5,0.5,0.5,1};
	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

	const float scl = screen_w;
	glScalef(scl, scl, scl);

    glTranslatef(0,0,-0.56);



	float pos[4];
	pos[0] = -0.4;
	pos[1] = 0;
	pos[2] = 1;
	pos[3] = 0.0f;
	glLightfv( GL_LIGHT0, GL_POSITION, pos );







	glDisable(GL_BLEND);
	
	glScalef(0.2, 0.2, 0.2);


	//--  Title
	const bilingual bszTitle = { "Large Trans-Neptunian Objects", "{zn|悤}{O|}{V|Ă񂽂}" };
	
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glColor3f(0.8,0.8,0.8);
	glPushMatrix();
		glTranslatef(0,3.2,0);
		int len = (get_language()==LANG_ENG)  ?  strlen(bszTitle.text_E)  :  7*2;
		float sz = 15.0 / len;
		glScalef(sz,sz,sz);
		draw_bilingual_centering(bszTitle);
	glPopMatrix();




	//--
	glTranslatef(-3, 1, 0);
	for (int iy=0; iy<2; iy++) {
		glPushMatrix();

		for (int ix=0; ix<4; ix++) {
			int i = iy*4 + ix;

			double Rx, Ry, Rz;
			if (i==1) {
				Rx = Ry = Rz = R0;
			} else {
				get_small_object_size(get_small_object_index(DP[i].no), Rx, Ry, Rz);
			}

			glPushMatrix();
				glRotatef(-90, 1,0,0);
				glEnable(GL_LIGHTING);
				float szx = 0.9 * Rx / R0;
				float szy = 0.9 * Ry / R0;
				float szz = 0.9 * Rz / R0;
				glScalef(szx,szy,szz);
				
				//****
				if (i==1) {
					glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
					glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

					glEnable(GL_TEXTURE_2D);
					set_planet_orientation(8);
					draw_planet2(8);
				} else {

					glDisable(GL_TEXTURE_2D);

					draw_a_small_object0( get_small_object_index( DP[i].no ) );
				}
			glPopMatrix();

			// O
			glPushMatrix();
				glTranslatef(0,-1,0.0);
				if (iy>=1) {
					glTranslatef(0,dy,0.0);
				}

				glColor3f(0.8,0.8,0.8);
				glScalef(0.3,0.3,0.3);
				glDisable(GL_TEXTURE_2D);
				glDisable(GL_LIGHTING);

				glPushMatrix();
					draw_bilingual_centering( DP[i].name );
				glPopMatrix();

				glTranslatef(0,-1,0);
				glColor3f(0.5,0.7,0.8);
				char str[20];
				sprintf(str, "%d", DP[i].no);
				glScalef(0.7, 0.7, 0.7);
				draw_text_center( str );
			glPopMatrix();


			glTranslatef(2,0,0);
		}

		glPopMatrix();
		glTranslatef(0,-2-dy,0);
	}


	glDisable(GL_NORMALIZE);
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
}




//-----------------
//  ̐FƉx̐}
//-----------------
void
draw_3DChart_star_color()
{
	float mat_d[] = {1.2,1.2,1.2,1}, mat_a[] = {1,1,1,1};


	glDisable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glEnable(GL_LIGHT2);

	glDisable(GL_TEXTURE_2D);

	mat_a[0] = 0;
	mat_a[1] = 0;
	mat_a[2] = 0;
	mat_a[3] = 1.0;
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );


	const int N = 5;
	double  Temp[N] = { 45000, 29000, 9600, 5800, 3800 };
	const bilingual bszStar[N] = {
		{ " Orionis",	"II{|}{  |[}{|}" },
		{ "Spica",		"XsJ" },
		{ "Vega",		"xK" },
		{ "Sun",		"{z|悤}" },
		{ "Betelgeuse",	"xeMEX" }
	};
	const bilingual bszTitle = { "Color and Temperature of Stars", "{|ق}{F|}{x|}{֌W|񂯂}" };

	char str[256];


	glPushMatrix();
		const float scl = screen_w * get_title_width_ratio();
		glScalef(scl, scl, scl);
		glTranslatef(0,0,-0.5);

		float pos[4];
		pos[0] = 0;
		pos[1] = 0;
		pos[2] = -1;
		pos[3] = 0.0f;
		glLightfv( GL_LIGHT2, GL_POSITION, pos );

		float sz = 0.1;
		glScalef(sz, sz, sz);

		// ^Cg
		glDisable(GL_LIGHTING);
		glColor3f(0.8,0.8,0.8);
		glPushMatrix();
			glTranslatef(0,3.3,0);
			draw_bilingual_centering(bszTitle);
		glPopMatrix();



		glTranslatef(-N-1.2,0,0);

		float mlv = max_level( blackbody_color(5800) );
		for (int i=0; i<N; i++) {
			RGBf rgb = blackbody_color( Temp[i] );

			rgb = scale_by_max(rgb, true);

			RGBf rgbE = correct_RGB0(0.8f * rgb);
			RGBf rgbD = correct_RGB0(0.4f * rgb);

			mat_a[0] = rgbE.r;
			mat_a[1] = rgbE.g;
			mat_a[2] = rgbE.b;
			mat_a[3] = 1.0;
			glMaterialfv( GL_FRONT_AND_BACK , GL_EMISSION,   mat_a );

			mat_d[0] = rgbD.r;
			mat_d[1] = rgbD.g;
			mat_d[2] = rgbD.b;
			mat_d[3] = 1.0;
			glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );


			// ʂƖ𓖂Ă
			glPushMatrix();
				toward_eye_pos();
				float pos[4];
				pos[0] = 0;
				pos[1] = 0;
				pos[2] = -1;
				pos[3] = 0.0f;
				glLightfv( GL_LIGHT2, GL_POSITION, pos );
			glPopMatrix();


			glEnable(GL_LIGHTING);
			gl_draw_LOD_sphere();

			glDisable(GL_LIGHTING);
			glColor3f(0.8,0.8,0.8);

			// x
			glPushMatrix();
				glTranslatef(0,1.5,0);
				glScalef(0.5,0.5,0.5);
				if (get_language()==LANG_ENG)	{ sprintf(str, "%d K", int(Temp[i])); }
				else							{ sprintf(str, "%d{x|}", int(Temp[i])); }
				draw_text_center(str);
			glPopMatrix();

			// ̖O
			glPushMatrix();
				glTranslatef(0,-1.5,0);
				glScalef(0.4,0.4,0.4);
				draw_bilingual_centering(bszStar[i]);
			glPopMatrix();
			
			glTranslatef(3,0,0);
		}
	glPopMatrix();

	mat_a[0] = 0;
	mat_a[1] = 0;
	mat_a[2] = 0;
	mat_a[3] = 1.0;
	glMaterialfv( GL_FRONT_AND_BACK , GL_EMISSION,   mat_a );


	glEnable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT2);
	glEnable(GL_LIGHT0);
	glDisable(GL_NORMALIZE);
}




//----------------
//  \
//----------------
void
draw_subtitles()
{
	const int subtitles_lines = vSubtitles.size();
	if (subtitles_idx < 0 || subtitles_idx >= subtitles_lines)  return;


	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	// x
	float af = 1.0f;


	glPushMatrix();
		goto_center_screen();
		const float scl0 = screen_w / 180.0;
		glScalef(scl0,scl0,scl0);

		float wh = 110;

		glTranslatef(0,0,-20);
		glTranslatef(-wh,0,0);
		glTranslatef(0, -90, 0);

		float w0 = 2*wh;
		

		glColor4f(0.7,0.7,0.7,af);
		const float sz = 8;
		glScalef(sz,sz,sz);

		gltext&  txt = vSubtitles[subtitles_idx];
		txt.draw_center(w0/sz, get_font());
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}




//----------------
//  \
//----------------
void
draw_date(const mtk_draw_struct& ds)
{
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	// x
	float af = DateAlpha;

	if (tyMode == MODE_HIPPARCOS) {
		const float R1 = 2.0;
		const float R2 = 20.0;
		float r = ds.scale / _1ly_pc;
		if (r > R2) return;
		if (r > R1)  {
			af *= 1-(r-R1)/(R2-R1);
		}
	}


	glPushMatrix();
		goto_center_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);

		glTranslatef(0,0,-20);

		

		int col_idx = (GetRealtimeMode())  ?  MTK_COLOR_DATE_REALTIME_MODE  :  MTK_COLOR_DATE;
		const RGBf& col = get_color(col_idx);
		glColor4f(col.r, col.g, col.b, af);


		const float sz = 10;
		glScalef(sz,sz,sz);

		glTranslatef(0, g_date_pos_y, 0);
		if (bSubtitles || subtitles_idx != 0) {
			glTranslatef(0,+9,0);	// [ĥƂ͏㑤ɕ\
		} else {
			glTranslatef(0,-8,0);
		}


		const float f2 = 0.66 * gDateSize * (ds.ltf / 1.2f);
		glScalef(f2, f2, f2);

		UTC utc = JD_to_UTC(ds.JD + DT/24.0);
		char date[80];



		if (get_language() == LANG_ENG) {
			const char szMon[12][5] = {
				"Jan", "Feb", "Mar", "Apr", "May", "Jun",
				"Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
			if (GetRealtimeMode()) {
				int isec  = int(utc.sec);
				sprintf(date, "%3s %02d, %4d   %02d:%02d:%02d",
							szMon[utc.month-1], utc.day, utc.year, utc.hour, utc.min, isec);
			} else {
				sprintf(date, "%3s %02d, %4d   %02d:%02d",
							szMon[utc.month-1], utc.day, utc.year, utc.hour, utc.min);
			}
			draw_text_line(date, TEXT_CENTER, false);
		} else {
			sprintf(date, "");
			prepare_centering(date);

			glTranslatef(-5.2,0,0);

			char str[80];

			glTranslatef(2.7,0,0);
			sprintf(str, "%4d{N|˂}", utc.year);
			draw_text_line(str, TEXT_RIGHT, false);

			glTranslatef(2.0,0,0);
			sprintf(str, "%2d{|}", utc.month);
			draw_text_line(str, TEXT_RIGHT, false);

			glTranslatef(2.0,0,0);
			sprintf(str, "%2d{|ɂ}", utc.day);
			draw_text_line(str, TEXT_RIGHT, false);

			glTranslatef(3.7,0,0);
			sprintf(str, "%02d:%02d", utc.hour, utc.min);
			draw_text_line(str, TEXT_RIGHT, false);

			if (GetRealtimeMode()) {
				int isec  = int(utc.sec);
				sprintf(str, ":%02d", isec);
				draw_text(str);
			}
		}


	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}



//-----------
//  ݒ
//-----------
void
draw_setting_mode()
{
	if (chSettingModeDisp == SETTING_MODE_NONE)  return;

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	// x
	float af = 0.6f;


	glPushMatrix();
		goto_center_screen();

		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);
		glTranslatef(0,0,-20);

		glColor4f(0.9,0.8,0.6,af);
		const float sz = 10;
		glScalef(sz,sz,sz);

		if (bSubtitles || subtitles_idx != 0) {
			glTranslatef(0,+8,0);	// [ĥƂ͏㑤ɕ\
		} else {
			glTranslatef(0,-6.5,0);
		}

		const char szTimeStepE[][20] = { "10 sec.", "1 min.", "10 min.", "1 hour", "1 day", "1 week", "1 month", "1 year", "10 years", "100 years" };
		const char szTimeStepJ[][20] = { "POb", "P", "PO", "P", "P", "PT", "P", "PN", "PON", "POON" };
		char szEyeDist[100];
		const char *str;

		switch (chSettingModeDisp) {
			case SETTING_MODE_DATE:
				if (get_language() == LANG_ENG)	{ str = szTimeStepE[tyTimeStep]; }
				else							{ str = szTimeStepJ[tyTimeStep]; }
				break;
			case SETTING_MODE_EYE_DISTANCE:
				sprintf(szEyeDist, "%2.1f cm", get_eye_distance_2());
				str = szEyeDist;
				break;
			default:
				szEyeDist[0] = '\0';
				str = szEyeDist;
				break;
		}
		draw_text_line(str, TEXT_CENTER, false);

	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}




//---------------
//  FPS\
//---------------
void
draw_fps()
{
	char str[256];
	sprintf(str, "fps = %2.1f", FrmCounter.get_fps());

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glDisable(GL_BLEND);
	glColor3f(1,1,1);

	gl_enter_2D_mode();
		const float sz = 20;
		glScalef(sz,-sz,sz);
		glTranslatef(0.1,-1,0);
		draw_text(str);
	gl_leave_2D_mode();

	glEnable(GL_DEPTH_TEST);
}


//-----------------------------------
//  AvP[VE^Cg\
//-----------------------------------
void
draw_app_title()
{
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	const float alpha = 0.6f;
	glPushMatrix();
		goto_center_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);
		glTranslatef(0,0,-20);

		glColor4f(0.7,0.8,1,alpha);
		const float sz = 50;
		glScalef(sz,sz,sz);
		glTranslatef(0,1,0);

		draw_text_line(szAppName, TEXT_CENTER, false);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}

//-------------------------
//  o[W\
//-------------------------
void
draw_about()
{
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	const float alpha = 0.6f;
	glPushMatrix();
		goto_center_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);

		glColor4f(0.4,0.6,0.8,alpha);
		float sz = 20;
		glScalef(sz,sz,sz);

		char str[256];

		sprintf(str, "Version %s", szVersion);
		draw_text_line(str, TEXT_CENTER, true);

		const float sc = 0.6;
		glScalef(sc, sc, sc);


		sprintf(str, "%d Stars", get_stars_num());
		draw_text_line(str, TEXT_CENTER, true);


		sprintf(str, "%d Nearby Galaxies", get_number_of_nearby_galaxies() );
		draw_text_line(str, TEXT_CENTER, true);

		sprintf(str, "%d Distant Galaxies", get_number_of_distant_galaxies() );
		draw_text_line(str, TEXT_CENTER, false);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}


//-----------------------
//  fobO\
//-----------------------
void
draw_debug_info()
{
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	const float alpha = 0.6f;
	glPushMatrix();
		goto_center_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);

		glColor4f(0.4,0.6,0.8,alpha);
		float sz = 6;
		glScalef(sz,sz,sz);

		char str[256];

		glTranslatef(0,-4,0);

		sprintf(str, "L_ref = %.2e", get_L_ref());
		draw_text_line(str, TEXT_CENTER, true);

		sprintf(str, "Julian Date = %lf", get_time_JD() );
		draw_text_line(str, TEXT_CENTER, true);


		const float scale = get_current_scale();
		sprintf(str, "Scale = %.3le pc", scale);
		draw_text_line(str, TEXT_CENTER, true);

		sprintf(str, "Log Scale = %.3le  Log L_r_e_f = %.3le", log10(scale), get_log_L_ref());
		draw_text_line(str, TEXT_CENTER, true);

		sprintf(str, "Window size = (%d,%d)", win_w, win_h);
		draw_text_line(str, TEXT_CENTER, false);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}




//-------------------
//  _\
//-------------------
void
draw_view_info(const mtk_draw_struct& ds)
{
	const vector3d  camera_pos = ds.camera.get_pos();
	const vector3d  target_r   = ds.target_pos;

	

	double dist = norm( target_r - camera_pos );
	const float pc2m = _1pc_meter;

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	bool szIdx = (get_language()==LANG_ENG) ? 1 : 0;

	const float alpha = 0.6f;
	glPushMatrix();
		goto_center_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);

		glColor4f(0.4,0.6,0.8,alpha);
		float sz = 6;
		glScalef(sz,sz,sz);

		char str[256];

		glTranslatef(0,-8,0);

		const char szPos[2][30] = { "_̈ʒu", "Position of Viewpoint" };
		sprintf(str, "%s : (%.2le %.2le %.2le)", szPos[szIdx], pc2m*camera_pos.x, pc2m*camera_pos.y, pc2m*camera_pos.z);
		draw_text_line(str, TEXT_CENTER, true);


		const char szTgtPos[2][30] = { "^[Qbg̈ʒu", "Position of Target" };
		sprintf(str, "%s : (%.2le %.2le %.2le)", szTgtPos[szIdx], pc2m*target_r.x, pc2m*target_r.y, pc2m*target_r.z);
		draw_text_line(str, TEXT_CENTER, true);


		if (tyMode == MODE_HIPPARCOS) {
			const char szDist[2][30] = { "", "Distance" };
			const char szLy[2][30] = { "N",	"ly" };
			const char szAU[2][30] = { "VP", "AU" };
			if (dist*_1pc_ly > 1) {
				sprintf(str, "%s : %.1le m   (%.1le %s)", szDist[szIdx], pc2m*dist, dist*_1pc_ly, szLy[szIdx]);
			} else {
				sprintf(str, "%s : %.1le m   (%.1le %s)", szDist[szIdx], pc2m*dist, dist*_1pc_AU, szAU[szIdx]);
			}
		} else {
			const char szAngle[2][30] = { "p", "View Angle" };
			const char szDeg[2][30] = { "x", "deg" };

			sprintf(str, "%s : %.2lf %s", szAngle[szIdx], get_plnt_angle(), szDeg[szIdx]);
		}
		draw_text_line(str, TEXT_CENTER, true);



		if (tyMode==MODE_HIPPARCOS) {
			const quaterniond& ori = g_camera.get_ori();
			const char szOri[2][30] = { "p", "Orientation" };
			sprintf(str, "%s : (%.2le %.2le %.2le %.2le)", szOri[szIdx], ori.w, ori.v.x, ori.v.y, ori.v.z);
		} else {
			double azimuth = 180 - get_plnt_long();
			if (azimuth < 0.0) azimuth += 360;
			if (szIdx == 0) { sprintf(str, " : ʊp=%.1lfx  x=%.1lfx", azimuth, get_plnt_lati()); }
			else			{ sprintf(str, "View direction : Azimuth=%.1lfdeg  Altitude=%.1lfdeg", azimuth, get_plnt_lati()); }
		}
		draw_text_line(str, TEXT_CENTER, true);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}





//-------------------
//  ڑ\
//-------------------
void
draw_connection_wait()
{
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	glPushMatrix();
		goto_each_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);

		float sz = 12;
		glScalef(sz,sz,sz);

		char str[256];
		sprintf(str, "%s  ڑҋ@", szHostName);
		char eye_CLR = get_eye_CLR();
		if (eye_CLR == 'L')		{ glTranslatef(0, 1,0); glColor3f(1,0,0); }
		if (eye_CLR == 'R')		{ glTranslatef(0,-1,0); glColor3f(0,1,0); }


		draw_text_line(str, TEXT_CENTER, true);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}




//---------
//  wv
//---------
const int help_item_num = 15;
struct help_item {
	char key[20];
	char expl[100];
};

help_item HelpItem[help_item_num] = {
	{ "X",			"j[J" },
	{ "L[",		"̕ς" },
	{ "1 + L[","iFԃ[ĥ݁j" },
	{ "PAGE UP",	"Y[C" },
	{ "PAGE DOWN",	"Y[AEg" },
	{ "4",			"Ԃi߂" },
	{ "3",			"Ԃ߂" },
	{ "Z + 4",		"ԍ݂𒷂iő100Nj" },
	{ "Z + 3",		"ԍ݂Ziŏ10bj" },
	{ "A",			"x̕\E\" },
	{ "S",			"F֔яoEn֒" },
	{ "C",			"ʂLv`('capture.png')" },
	{ "W",			"Gh[A^Cg\" },
	{ "Q",			"|C^E[hɈڍs" },
	{ "L",			"i\̐؂ւ" }
};

void
draw_help()
{
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	const float alpha = 0.6f;
	glPushMatrix();
		goto_center_screen();
		const float scl = screen_w / 180.0;
		glScalef(scl,scl,scl);
		glTranslatef(0,0,-20);

		glColor4f(0,0.4, 1,alpha);
		const float sz = 7;
		glScalef(sz,sz,sz);
		glTranslatef(-12,7,0);

		for (int i=0; i<help_item_num; i++) {
			glPushMatrix();
				draw_text_line(HelpItem[i].key, TEXT_LEFT, false);
			glPopMatrix();
			glPushMatrix();
			glTranslatef(10,0,0);
				draw_text_line(HelpItem[i].expl, TEXT_LEFT, false);
			glPopMatrix();
			glTranslatef(0,-1,0);
		}

	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
}



//
void
prepare_draw(const mtk_draw_struct& ds)
{
	prepare_draw_stars(ds, 1.0);
}




//
void
draw_Hipparcos_near(mtk_draw_struct ds)
{
	ds.set_near_region();


	gl_set_frustum(ds.frs);
	glMatrixMode(GL_MODELVIEW);


	if (swGalaxy & GLXY_QSO)			{ draw_QSOs(ds); }
	draw_galaxies(ds);
	draw_our_galaxy_label(ds);

	if (swGalaxy & GLXY_GLOB_CLSTR)		{ draw_globular_clusters(ds); }
	if (tyTarget ==  TGTNO_M13)			{ draw_GC_model(ds); }
	if (swStar & STAR_DISP)				{ draw_stars_2(ds, bDrawLowRes, false); }

	if (swConstellation & CNST_LINE)	{ draw_constellation_lines(ds); }
	if (tySubMode!=SUBMODE_IMAGE && tySubMode!=SUBMODE_3DCHART)		{ draw_star_name_3D(ds); }


	draw_small_objects(ds);
	
	draw_spacecraft_path(ds);
	draw_spacecraft(ds);

	draw_objects(ds);
	draw_space_curves(ds);

	if (bEcliptic)					{ draw_ecliptic(ds); }

	if (swScaleLine & SCALE_SQUARE)		{ draw_scale_square(ds); }

	if (bPathInfo)					{ draw_path(); }
}


void
draw_Hipparcos_far(mtk_draw_struct ds)
{
	ds.set_far_region();
	gl_set_frustum(ds.frs);
	glMatrixMode(GL_MODELVIEW);

	draw_milkyway(ds);

	if (swStar & STAR_DISP)				{ draw_stars_2(ds, bDrawLowRes, true); }
	

	if (bCelestialGrid)					{ draw_celestial_grid(ds, true); }
	if (bGalacticGrid)					{ draw_galactic_grid(ds, true); }

	if (swConstellation & CNST_LINE)	{ draw_constellation_lines(ds); }
	if (swConstellation & CNST_BND)		{ draw_constellation_boundary(ds); }
	if (swConstellation & CNST_ILLUST)	{ draw_constellation_illust(ds); }
	if (swConstellation & CNST_NAME)	{ draw_constellation_name(ds); }
	

	draw_spacecraft_path(ds);

	if (swGalaxy & GLXY_QSO)			{ draw_QSOs(ds); }
	draw_galaxies(ds);

	draw_space_curves(ds);
	draw_objects(ds);
}


void
draw_Hipparcos(const mtk_draw_struct& ds)
{
	glPushMatrix();


	// ̃Zbg
	float lp[4];
	lp[0] = lp[1] = lp[2] = 0;	lp[3] = 1.0;
	glLightfv(GL_LIGHT0, GL_POSITION, lp);

	// XP[ƌ_̃Zbg
	double fac = ds.scale_factor;
	glScaled(fac, fac, fac);

	//--  prepare  --
	prepare_draw(ds);

	//--  draw far region   --
	draw_Hipparcos_far(ds);

	//--  draw near region  --
	glClear( GL_DEPTH_BUFFER_BIT );
	draw_Hipparcos_near(ds);


	glPopMatrix();
}



//----------------
//  j[̕\
//----------------
inline RGBf
calc_menu_bg_color(RGBf& col1, RGBf& col2, float h, float y)
{
	float f2 = fabs(y)/h;
	float f1 = 1 - f2;
	
	return f1 * col1 + f2 * col2;
}

inline void
set_menu_bg_color(RGBf& col1, RGBf& col2, float h, float y, float alp)
{
	RGBf col = calc_menu_bg_color(col1, col2, h, y);
	glColor4f(col.r, col.g, col.b, alp);
}

void
draw_menu_background(float w, float h, float R, float alp, int sel_idx, float mgn_y)
{
	const int csN = 10;
	static bool bFirst = true;
	static float cs[csN], sn[csN];
	if (bFirst) {
		bFirst = false;

		for (int i=0; i<csN; i++) {
			float th = 0.5*M_PI * float(i)/(csN-1);
			cs[i] = cos(th);
			sn[i] = sin(th);
		}
	}



	const float x1 = R;
	const float y1 = -R;
	const float x2 = w-R;
	const float y2 = -h+R;
	const float ys1 = -sel_idx + mgn_y;
	const float ys2 = ys1 - 1;



	//--------------
	//  Background
	//--------------


	//-- Quads --
	RGBf col1  = colMenuBgColor1;
	RGBf col2  = colMenuBgColor2;
	RGBf col11 = calc_menu_bg_color(col1, col2, h, y1);
	RGBf col21 = calc_menu_bg_color(col1, col2, h, y2);
	RGBf col1s = calc_menu_bg_color(col1, col2, h, ys1);
	RGBf col2s = calc_menu_bg_color(col1, col2, h, ys2);
	RGBf colhl1 = colMenuHlColor1;
	RGBf colhl2 = colMenuHlColor2;

	glBegin(GL_QUADS);
		// Top
		glColor4f(col1.r, col1.g, col1.b, alp);
		glVertex3f(x2, 0, 0);
		glVertex3f(x1, 0, 0);
		glColor4f(col11.r, col11.g, col11.b, alp);
		glVertex3f(x1,y1, 0);
		glVertex3f(x2,y1, 0);
		// Top2
		glColor4f(col11.r, col11.g, col11.b, alp);
		glVertex3f(w, y1, 0);
		glVertex3f(0, y1, 0);
		glColor4f(col1s.r, col1s.g, col1s.b, alp);
		glVertex3f(0, ys1, 0);
		glVertex3f(w, ys1, 0);

		// Highlight
		glColor4f(colhl1.r, colhl1.g, colhl1.b, alp);
		glVertex3f(w, ys1, 0);
		glVertex3f(0, ys1, 0);
		glColor4f(colhl2.r, colhl2.g, colhl2.b, alp);
		glVertex3f(0, ys2, 0);
		glVertex3f(w, ys2, 0);


		// Bottom2
		glColor4f(col2s.r, col2s.g, col2s.b, alp);
		glVertex3f(w, ys2, 0);
		glVertex3f(0, ys2, 0);
		glColor4f(col21.r, col21.g, col21.b, alp);
		glVertex3f(0, y2, 0);
		glVertex3f(w, y2, 0);
		// Bottom
		glColor4f(col21.r, col21.g, col21.b, alp);
		glVertex3f(x2, y2, 0);
		glVertex3f(x1, y2, 0);
		glColor4f(col21.r, col21.g, col21.b, alp);
		glVertex3f(x1, -h, 0);
		glVertex3f(x2, -h, 0);

	glEnd();
	

	//-- Corner --
	float xc, yc;
	
	xc = x1;	yc = y1;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = R*cs[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(-R*sn[i]+xc, y, 0);
		}
	glEnd();

	xc = x1;	yc = y2;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = -R*sn[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(-R*cs[i]+xc, y, 0);
		}
	glEnd();

	xc = x2;	yc = y2;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = -R*cs[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(R*sn[i]+xc, y, 0);
		}
	glEnd();

	xc = x2;	yc = y1;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = R*sn[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(R*cs[i]+xc, y, 0);
		}
	glEnd();




	
	//----------
	//  Border
	//----------
	const RGBf cbd = colMenuBdColor;
	glColor4f(cbd.r, cbd.g, cbd.b, alp); 
	glLineWidth(MenuBdWidth);
	
	glBegin(GL_LINE_STRIP);
		// LT
		xc = x1;
		yc = y1;
		for (int i=0; i<csN; i++) {
			glVertex3f(-R*sn[i]+xc, R*cs[i]+yc, 0);
		}
		// LB
		xc = x1;
		yc = y2;
		for (int i=0; i<csN; i++) {
			glVertex3f(-R*cs[i]+xc, -R*sn[i]+yc, 0);
		}
		// RB
		xc = x2;
		yc = y2;
		for (int i=0; i<csN; i++) {
			glVertex3f(R*sn[i]+xc, -R*cs[i]+yc, 0);
		}
		// RT
		xc = x2;
		yc = y1;
		for (int i=0; i<csN; i++) {
			glVertex3f(R*cs[i]+xc, R*sn[i]+yc, 0);
		}
		glVertex3f(x1,0,0);
	glEnd();

}


void
draw_menu_triangle(float sz)
{
	float l = sz;

	float y0 = 0.5;
	float y1 = y0 - 0.5*l;
	float y2 = y0 + 0.5*l;
	float x1 = 0.78*l;
	float d  = 0.1*l;


	glBegin(GL_TRIANGLE_FAN);
		glVertex3f(x1-2*d, y0,   0);
		glVertex3f(  -d, y1+d, 0);
		glVertex3f(   0, y1,   0);
		glVertex3f(  x1, y0,   0);
		glVertex3f(   0, y2,   0);
		glVertex3f(  -d, y2-d,   0);
	glEnd();
}


void
draw_menu_diamond(float sz)
{
	float l = sz;

	float x0 = 0.5;
	float y0 = 0.5;
	float x1 = x0 - 0.5*l;
	float x2 = x0 + 0.5*l;
	float y1 = y0 - 0.5*l;
	float y2 = y0 + 0.5*l;


	glBegin(GL_TRIANGLE_FAN);
		glVertex3f(x0, y2, 0);
		glVertex3f(x1, y0, 0);
		glVertex3f(x0, y1, 0);
		glVertex3f(x2, y0, 0);
	glEnd();
}



void
draw_each_menu(menu* pMenu, float x0, float y0, float z0, menu_color& mnc, const float alp1, const float alp2, const float scl)
{
	const char lang = get_language();
	const float szT = 1.1f;

	const float dz = 0.1;
	menu&  mnu = *pMenu;
	glTranslatef(x0,-y0,z0);

	//--- ̈TCY̌vZ
	bool bCheck = false;
	float w, h;
	
	const char* title = (lang == LANG_ENG)  ?  mnu.get_titleE() : mnu.get_titleJ();
	get_text_size(title, w,h);	// ^Cg
	
	h *= szT;
	float hT = h;

	h += 0.5;
	for (int i=0; i<pMenu->size(); ++i) {
		char ty = mnu[i]->get_type();
		if (ty == MENU_TY_CHECK)  bCheck=true;

		const char* name = (lang == LANG_ENG)  ?  mnu[i]->get_name_E() : mnu[i]->get_name_J();

		float dw, dh;
		if (ty == MENU_TY_CHILD) {
			char str[256];
			sprintf(str, "%s", name);
			get_text_size(str, dw, dh);
			dw += 0.5 + 0.6;
		} else {
			get_text_size(name, dw, dh);
		}
		
		if (w < dw)  w = dw;
		h += dh;
	}

	float xx=0;
	if (bCheck) xx=1;

	//--- wi̕`
	const float mgn_x = 0.4;
	const float mgn_y = 0.4;
	float x2,y2;
	x2 = w + xx + 2*mgn_x;
	y2 = h + 2*mgn_y;


	//-- Backgroud
	const float _mgny = -mgn_y-hT-0.5;
	draw_menu_background(x2, y2, MenuCornerR, alp2, mnu.get_current_pos(), _mgny);


	glLineWidth(1);

	glTranslatef(mgn_x, -mgn_y-hT, 0);


	//--- j[^Cg̕\
	glColor4f(colMenuTitle.r, colMenuTitle.g, colMenuTitle.b, alp1);
	glPushMatrix();
		glScalef(szT, szT, szT);
		draw_text(title);
	glPopMatrix();
	glTranslatef(0,-1.5,0);
	glTranslatef(0, 0.15,0);	//*** 



	//--- `FbN̕\
	glColor4f(colMenuSelect.r, colMenuSelect.g, colMenuSelect.b, alp1);
	if (bCheck) {
		glPushMatrix();
		for (int i=0; i<pMenu->size(); ++i) {
			if (mnu[i]->get_type() == MENU_TY_CHECK) {
				if (((menu_item_check*)mnu[i])->get_check()) {
					glPushMatrix();
						glTranslatef(0.0, -0.15 + MenuTriangleDy, 0);
						draw_menu_diamond(0.6);
					glPopMatrix();
				}
			}
			glTranslatef(0,-1,0);
		}
		glPopMatrix();
		glTranslatef(xx,0,0);
	}


	//--- j[̕`
	for (int i=0; i<pMenu->size(); ++i) {
		glPushMatrix();
		if (mnu.get_current_pos() == i)	{
			glColor4f(colMenuSelect.r, colMenuSelect.g, colMenuSelect.b, alp1);
			glTranslatef(0,0,dz);
		} else {
			glColor4f(colMenuText.r, colMenuText.g, colMenuText.b, alp1);
		}

		char ty = (*pMenu)[i]->get_type();
		const char* text = (lang == LANG_ENG)  ?  (*pMenu)[i]->get_name_E()  :  (*pMenu)[i]->get_name_J();
		if (ty == MENU_TY_CHILD)	{
			draw_textf("%s", text);
			glTranslatef(0.5, -0.15 + MenuTriangleDy, 0);

			if (mnu.get_current_pos() == i)	{
				glColor4f(0.7*colMenuSelect.r, 0.7*colMenuSelect.g, 0.7*colMenuSelect.b, alp1);
			} else {
				glColor4f(0.7*colMenuText.r, 0.7*colMenuText.g, 0.7*colMenuText.b, alp1);
			}
			draw_menu_triangle(0.6);
		} else {
			draw_textf("%s",   text);
		}

		glPopMatrix();
		glTranslatef(0,-1,0);
	}
}



void
set_menu_pos0(const float angle)
{
	const double* Mbc;
	Mbc = get_local_camera_matrix_GL();

	glLoadIdentity();
	glMultMatrixd(Mbc);

	
	double M[16];
	quaternion_to_matrix_GL_tr( get_base_camera_ori(), M );
	glMultMatrixd(M);
	

	glRotatef(-menu_angle + angle  ,0,1,0);
	glTranslatef(0,0,-1.2*screen_z);
}






void
set_menu_pos(const float angle)
{
	set_menu_pos0(angle);
	glTranslatef(-0.5*screen_w,0.5*screen_w,0);
}


void
draw_menu(menu_selection& ms, float x0, float y0, float z0)
{
	set_menu_checks();

	float scl = 0.055 * screen_w;
	float step = 0.8;  // 0.4
	float step_z = 0.5;

	scl *= MenuTextSize;//****

	glPushMatrix();
		set_menu_pos( get_menu_pos_angle() );

		glRotatef( get_menu_rotate_angle(), 0,1,0);

		glDisable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);

		glScalef(scl,scl,scl);
		for (int i=0; i<ms.size(); ++i) {
			float alp1, alp2, dz;
			const float fac = GetMenuFadeFactor();
			float scl;

			if (i==ms.size()-1) {
				// top window ̏ꍇ
				alp1 = 1.0f * fac;
				alp2 = MenuBgAlpha * fac;
				dz = -(1-fac);
				scl = fac;
			} else {
				float alp1a, alp1b;
				if (i==ms.size()-2) {
					alp1a = 1.0f;
				} else {
					alp1a = MenuBehindAlpha * (1 - float(ms.size()-3 -i)/MenuFadingRate);
				}
				alp1b = MenuBehindAlpha * (1 - float(ms.size()-2 -i)/MenuFadingRate);
				alp1 = alp1a * (1-fac) + alp1b * fac;
				alp2 = MenuBgAlpha * alp1;
				dz = 0;
				scl = 1;
			}

			glPushMatrix();
				menu_color& mnc = (i==ms.size()-1) ? mnu_col : mnu_col_bk;
				draw_each_menu(ms[i], x0 + (i)*step, y0 + (i)*step, z0 + (i+dz)*step_z, mnc, alp1, alp2, scl);
			glPopMatrix();
		}
	
		glEnable(GL_DEPTH_TEST);
	glPopMatrix();
}





void
set_pointer_pos()
{
	const double* Mbc;
	Mbc = get_local_camera_matrix_GL();

	glLoadIdentity();
	glTranslatef(-eye_offset_x, 0, 0);
	glMultMatrixd(Mbc);
	glRotatef(-pointer_angle_x,0,1,0);
	glRotatef(pointer_angle_y,1,0,0);
	glTranslatef(0,0,-pointer_z);
}



void
draw_pointer0()
{
	glPushMatrix();
		glScalef(5,5,5);
		glColor3f(1,1,1);
		glLineWidth(1.0);
		glBegin(GL_LINE_LOOP);
			glVertex3f(-1,-1,0);
			glVertex3f(1,-1,0);
			glVertex3f(1,1,0);
			glVertex3f(-1,1,0);
		glEnd();
	glPopMatrix();
}


void
draw_pointer()
{
	glPushMatrix();
		set_pointer_pos();
		draw_pointer0();
	glPopMatrix();
}



//---------
//  Image
//---------

void
draw_image()
{
	media_file_info&  imgf = IMGF[current_image_index];
	const char type = imgf.type;

	const float scl = screen_w/180.0;
	float sz = 0.5 * screen_w;



	glPushMatrix();
		glEnable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);


		// 摜\
		glColor4f(1,1,1,1);
		switch (type) {
			case MEDIATYPE_POPUP_IMAGE:
				{
					goto_center_screen();
					glTranslatef(0,screen_w/2,0);

					glScalef(scl, scl, scl);
					float d = sz;
					glTranslatef(0,-d,0);
					glScalef(0.85,0.85,0.85);
					glScalef(sz,sz,sz);
					ImageStill.draw(gl_w, gl_h);
				}
				break;
			case MEDIATYPE_IMAGE:
			default:
				set_menu_pos0(0.0);
				glPushMatrix();
					glScalef(scl, scl, scl);
					glTranslatef(0,-13,0);
					//glScalef(0.9,0.9,0.9);
					glScalef(sz,sz,sz);
					ImageStill.draw(gl_w*get_title_width_ratio(), gl_h);
				glPopMatrix();
				break;
		}
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_DEPTH_TEST);

		// ^Cg\
		if (type == MEDIATYPE_IMAGE) {
			glScalef(scl, scl, scl);
			glTranslatef(0, 90, 0.1);
			glScalef(17,17,17);
			glColor3f(0.7,0.7,0.7);
			draw_text_center( imgf.disp_title );
		}
	glPopMatrix();
}




//--------------
//  3D `[g
//--------------
void
draw_3DChart()
{
	glPushMatrix();
		set_menu_pos0(0.0);

		switch (no_3DChart) {
			case _3DCHART_PLANETS:			draw_3DChart_planets();			break;
			case _3DCHART_DWARF_PLANETS:	draw_3DChart_TNOs();			break;
			case _3DCHART_STAR_COLOR:		draw_3DChart_star_color();		break;
			default:														break;
		}
	glPopMatrix();
}





//--------------
//  Draw Scene
//--------------
void
draw_scene(mtk_draw_struct ds)
{
	char mode = tyMode;


	glDepthFunc(GL_LEQUAL);

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	


	//-- Object frame
	double M[16];
	const double* Mbc;
	Mbc = get_local_camera_matrix_GL();
	glMultMatrixd(Mbc);

	quaternion_to_matrix_GL_tr( get_base_camera_ori(), M);
	glMultMatrixd(M);

	quaternion_to_matrix_GL_tr(ds.camera_base.get_ori(), M);
	glMultMatrixd(M);


	//-- Draw
	ds.set_near_region();
	set_latest_draw_struct(ds);

	gl_set_frustum(ds.frs);
	glMatrixMode(GL_MODELVIEW);

	switch (mode) {
		case MODE_HIPPARCOS:	draw_Hipparcos(ds);			break;
		case MODE_PLANETARIUM:	draw_planetarium(ds);		break;
		default:											break;
	}


	ds.set_near_region();
	gl_set_frustum(ds.frs);
	glMatrixMode(GL_MODELVIEW);

	if (bFPS)			{ draw_fps(); }
	if (bDate)			{ draw_date(ds); }
	if (bAppTitle)		{ draw_app_title(); }
	if (bAbout)			{ draw_about(); }
	if (bDebug)			{ draw_debug_info(); }
	if (bViewInfo)		{ draw_view_info(ds); }
	if (bPathInfo)		{ draw_path_info(); }
	if (!bControler && bNetwork && !bConnect)	{ draw_connection_wait(); }
	if (bKeyHelp)		{ draw_help(); }
}



void
draw_scene_all(const mtk_draw_struct& ds)
{
	//-- Clear
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	//-- Single-eye mode
	if (bSingleEye && get_eye_CLR() != 'R')  return;


	draw_scene(ds);

	switch (tySubMode) {
		case SUBMODE_SETTING:	draw_setting_mode();				break;
		case SUBMODE_TITLE:		draw_title_page();					break;
		case SUBMODE_POINTER:	draw_pointer();						break;
		case SUBMODE_IMAGE:		draw_image();						break;
		case SUBMODE_3DCHART:	draw_3DChart();						break;
		default:													break;
	}


	if (bSubtitles)		{ draw_subtitles(); }

	if (tySubMode == SUBMODE_MENU && bMenuVisible) {
		draw_menu(mnuSelect, 0.5,0.5, 0);
	}


	// 
	const float alp = GetScreenAlpha();
	if ( alp < 1 ) {
		draw_black_layer( ds.frs, alp );
	}
}



void		RecordMovie();


//---------------
//  Draw Normal
//---------------
void
draw_normal(const mtk_draw_struct& ds)
{
	draw_scene_all(ds);
}


//-----------------
//  Draw Anaglyph
//-----------------
void
draw_anaglyph(const mtk_draw_struct& ds)
{
	float eye_x = get_eye_offset_x();

	set_eye_distance_2(5.0, 'L');
	
    draw_scene_all(ds);
	make_anaglyph_left();

	set_eye_distance_2(5.0, 'R');
    draw_scene_all(ds);
	make_anaglyph_right();

	set_eye_offset_x(eye_x);
}


//-----------------------
//  Draw Color-Anaglyph
//-----------------------
void
draw_color_anaglyph(const mtk_draw_struct& ds)
{
	float eye_x = get_eye_offset_x();

	set_eye_distance_2(5.0, 'L');
	glColorMask(GL_TRUE, GL_FALSE, GL_FALSE, GL_FALSE);
	draw_scene_all(ds);

	set_eye_distance_2(5.0, 'R');
	glColorMask(GL_FALSE, GL_TRUE, GL_TRUE, GL_FALSE);
    draw_scene_all(ds);

	set_eye_offset_x(eye_x);

    glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_FALSE);
}




//--------
//  Draw
//--------
vector2d	get_landing_pos();



mtk_draw_struct
calc_draw_struct(int w, int h)
{
	//-------------------
	//  `p\̂̐
	//-------------------
	if (tyMode == MODE_HIPPARCOS) {
		g_camera.set_scale_factor(get_scale_factor());
		g_camera.set_pos_by_target_pos(get_current_target_pos(), ini_obj_z / g_camera.get_scale_factor() );
	} else {
		double sclfac = get_clst_R() / (1 * _1km_pc);
		g_camera.set_scale_factor(sclfac);
		g_camera.set_pos( get_current_target_pos() );
		g_camera.set_ori( get_planetarium_ori(get_current_target().id2, landing_lon, landing_lat, get_plnt_long(), get_plnt_lati()) );
	}


	mtk_draw_struct  ds;
	ds.set(g_camera, get_time_JD(), w, h, FontSize);

	return  ds;
}

void
draw()
{
	//-- Set font mode
	EnableRuby((get_language()==LANG_HIRA));



	if (bRecordMovie) {
		RecordMovie();
		return;
	}

	if (bPlayFrame) {
		PlayFrame();
		return;
	}



	//--- ̃Abvf[g
	update_time();
		

	//---  `p\̂̐  ---
	mtk_draw_struct  ds = calc_draw_struct(gl_w, gl_h);



	//--------------
	//  V[`
	//--------------
	switch (tyStereo) {
        case STEREO_ANAGLYPH:		draw_anaglyph(ds);				break;
		case STEREO_COLOR_ANAGLYPH:	draw_color_anaglyph(ds);		break;
		case STEREO_NONE:
		default:					draw_normal(ds);				break;
	}
}







////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Window


//=================
//  Event handler
//=================
static bool bTimer = false;
static volatile bool bKillTimer = false;


void OnTimer();
void OnKillTimer();



static MMRESULT timer_ID = NULL;
void CALLBACK
TimeProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	OnTimer();
};

void CALLBACK
KillTimerProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	OnKillTimer();
};




void
OnCreate(HWND hWnd)
{
	g_hWnd = hWnd;

	//-- init OpenGL
	HDC  hDC = GetDC(hWnd);

	bool res;
	res = initGL_Window(ogl, hDC);
	if (!res) {
		MessageBoxf(hWnd, "OpenGL", MB_OK, "Failed to initialize OpenGL");
	}


	ogl.MakeCurrent(hDC);
		initGL();
	ogl.MakeCurrent(NULL);
	ReleaseDC(hWnd, hDC);


	//-- init DirectInput
	joystick_SetCooperativeLevel(hWnd);

	//-- set timer for input
	if (bControler || !bNetwork) {
		timeBeginPeriod(1);
		
		timer_ID = timeSetEvent( TIMER_INTERVAL, 0, TimeProc, 0, TIME_PERIODIC | TIME_CALLBACK_FUNCTION);

		bTimer = true;
	}
}


void
OnDestroy()
{
	if (bTimer) {
		timeKillEvent( timer_ID );

		bKillTimer = false;
		MMRESULT res = timeSetEvent( 100, 0, KillTimerProc, 0, TIME_ONESHOT | TIME_CALLBACK_FUNCTION);

		timeEndPeriod(1);
	}
}







void
draw_movie_margen(HDC hDC)
{
	// wiNA
	HBRUSH  hBrush, hBrushOld;
	HPEN  hPenOld;
	
	hBrush = (HBRUSH)GetStockObject( BLACK_BRUSH );
	hBrushOld = (HBRUSH)SelectObject(hDC, hBrush );
	hPenOld = (HPEN)SelectObject(hDC, GetStockObject(NULL_PEN));

		//
		const int x0 = gl_x0;
		const int y0 = gl_y0;

		// [r[TCY擾
		int mvx, mvy, mvw, mvh;
		mvx = dsmv.get_x();
		mvy = dsmv.get_y();
		mvw = dsmv.get_w();
		mvh = dsmv.get_h();
		
		int x1,y1,x2,y2, X1,Y1,X2,Y2;
		x1 = mvx;
		y1 = mvy;
		x2 = x1 + mvw;
		y2 = y1 + mvh;
		X1 = 0;
		Y1 = 0;
		X2 = win_w0;
		Y2 = win_h0;

		
		// Left
		int w, h;
		w = x1-X1;
		h = Y2-Y1;
		if (w>0)	Rectangle(hDC, X1,Y1, x1+1, Y2+1);

		// Right
		w = X2-x2;
		h = Y2-Y1;
		if (w>0)	Rectangle(hDC, x2,Y1, X2+1, Y2+1);

		// Top
		w = x2-x1;
		h = y1-Y1;
		if (h>0)	Rectangle(hDC, x1,Y1, x2+1, y1+1);

		// Bottom
		w = x2-x1;
		h = Y2-y2;
		if (h>0)	Rectangle(hDC, x1,y2, x2+1, Y2+1);
		
		

	SelectObject(hDC, hBrushOld);
	SelectObject(hDC, hPenOld );
	DeleteObject(hBrush);
}









void
OnActivate(WPARAM wParam) 
{
	if (LOWORD(wParam) != WA_INACTIVE)	{ bActive = true;  }
	else								{ bActive = false; }
	joystick_Acquire(bActive);	
}







//-------------
//  Animation
//-------------
void
OnAnimType(char type)
{
	animation_type = type;
	if (bControler)  { send_data_char(DATA_CHAR_ANIM_TYPE, type); }
}

void
OnAnimationCounter0(int counter0)
{
	animation_counter0 = counter0;
	if (bControler)  { send_data_int(DATA_INT_ANIM_COUNTER0, animation_counter0); }
}


void
set_animation(char anim_type, int counter, int interval)
{
	OnAnimType(anim_type);
	OnAnimationCounter0(counter);
	animation_counter	= counter;
	animation_interval	= interval;
}


float
get_animation_frac()
{
	if (animation_counter0 == 0)  return 0;
	return  1.0 - float(animation_counter)/float(animation_counter0);
}




void
OnAnimation(int counter)
{
	static bool bIncPlayFrame = false;

	if (bIncPlayFrame) {
		play_frame++;
		bIncPlayFrame = false;
	}

	animation_counter = counter;

	int counter_max = pathif[play_frame].interval;
	play_frame_sub = counter_max - counter -1;

	if (counter == 0)  {
		if (animation_type == ANIM_TY_PLAY) {
			if (play_frame+1 >= path_frames-1)	{ animation_type = ANIM_TY_NONE; bPlayFrame = false; }
			else								{ bIncPlayFrame=true; animation_counter = pathif[play_frame+1].interval - 1; }
		} else {
            animation_type = ANIM_TY_NONE;
		}
	}

	if (bControler)  { send_data_int(DATA_INT_ANIM_COUNTER, animation_counter); }

	OnCommandDraw();
}



void
process_animation()
{
	// Aj[V̏
	static int count=0;
	if (bControler || !bNetwork) {
		if (animation_counter > 0) {
			count++;
			if (count >= animation_interval) {
				OnAnimation(animation_counter-1);
				count = 0;
			}
		}
	}
}


void
OnTimer()
{
	static bool first = true;
	
	if (first) {
		first = false;
		HRESULT hr = CoInitialize(NULL);
	}

	// 
	Input();

	// Aj[V
	process_animation();
}



void
OnKillTimer()
{
	CoUninitialize();
	bKillTimer = true;
}







//============
//  Commands
//============
void
OnOpen()
{
	OnCommandDraw();
}

void
OnSaveImage()
{
	static char filename[MAX_PATH];
	int no;
	filename[0] = '\0';

	const bilingual szFilter = {
		"JPEG (*.jpg)\0*.jpg\0PNG (*.png)\0*.png\0Bitmap File (*.bmp)\0*.bmp\0",
		"JPEG (*.jpg)\0*.jpg\0PNG (*.png)\0*.png\0rbg}bv t@C (*.bmp)\0*.bmp\0",
	};
	const bilingual szDlgTitle = {
		"Save Image As...",
		"摜t@Cɕۑ"
	};

	if (get_language()==LANG_ENG) {
		no = GetFileName(NULL, filename, szFilter.text_E, szDlgTitle.text_E, true);
	} else {
		no = GetFileName(NULL, filename, szFilter.text_J, szDlgTitle.text_J, true);
	}
	if (no <= 0)  return;

	HDC  hDC = GetDC(g_hWnd);
	ogl.MakeCurrent(hDC);
		image  img_tmp( 0,0, 3 );
		gl_capture_viewport(img_tmp);
	ogl.MakeCurrent(NULL);
	ReleaseDC(g_hWnd, hDC);

	switch (no) {
		case 1:	img_tmp.saveJPEG(filename);	break;
		case 2:	img_tmp.savePNG(filename);	break;
		case 3:	img_tmp.saveBMP(filename);	break;
		default:							break;
	}
}


void
OnSaveImageHighRes()
{
	if ( !isPBufferEnable() )   return;

	if (get_language()==LANG_ENG) {
		DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG_SAVE_IMAGE_E, g_hWnd, (DLGPROC)SaveImageHighResDialogBox);
	} else {
		DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG_SAVE_IMAGE_J, g_hWnd, (DLGPROC)SaveImageHighResDialogBox);
	}

	if (get_save_image_high_res_filename()[0] != '\0') {
		SetCursor( LoadCursor(NULL, IDC_WAIT) );
		HDC  hDC = GetDC(g_hWnd);
		ogl.MakeCurrent(hDC);
			save_image_high_resolution();
		ogl.MakeCurrent(NULL);
		ReleaseDC(g_hWnd, hDC);
		SetCursor( LoadCursor(NULL, IDC_ARROW) );
	}
}


void
OnResetView()
{
	OnCommandDraw();
}


//****************
void
OnUpdateViewCtrl()
{
	adjust_target_position();

	if (bControler) {
		view_info  vwif;
		vwif.qm  = g_camera.get_ori();

		send_frame(vwif);
	}
}

//--- nW̏ꍇ
void
OnUpdateViewCtrl2()
{
	if (bControler) {
		view_info2  vwif2;
		vwif2.lon = get_plnt_long();
		vwif2.lat = get_plnt_lati();
		send_frame2(vwif2);
	}
}



//-----------
// E
//-----------
vector2d
get_landing_pos()
{
	vector3d  nv = g_camera.get_pos() - get_target_center_pos();

	const mtk_target&  tgt = get_current_target();
	vector2d lon_lat;
	lon_lat = get_planet_lon_lat_ec(tgt.id2, nv);

	return  lon_lat;
}


void
landing(const vector2d& landing_pos)
{
	const mtk_target&  tgt = get_current_target();

	// n_̌vZ
	landing_lon = landing_pos.x;
	landing_lat = landing_pos.y;

	tyMode = MODE_PLANETARIUM;


	adjust_target_position();



	if (tgt.cls == TGTCLS_PLANET) {
		set_plnt_lati(5);

		set_plnt_long( get_dirc_from_3D_ori(tgt.id2, g_camera.get_ori()) );	// ̏𐳖ʂ
		set_planetarium_angle(plnt_angle_ini);
	} else {
	}



	//****
	double t = get_time_JD();
	update_objects_position_and_orientation(t, true);
	update_space_curves(t);



	if (bControler) {
		OnUpdateViewCtrl();
		OnUpdateViewCtrl2();
	}
}



void
OnLandingMode(char mode)
{
	set_landing_mode(mode);
	if (bControler)  { send_data_char(DATA_CHAR_LANDING_MODE, mode); }
}



//--- 
void
OnLanding()
{
	if (!bNetwork || bControler) {
		const mtk_target&  tgt = get_current_target();


		// ł̂́Afq̂
		if (tgt.cls != TGTCLS_PLANET)  return;


		// łقǐڋ߂Ă邩̔if̂݁j
		if (tgt.cls == TGTCLS_PLANET) {
			const double Re   = get_planet_Re(tgt.id2) * 1000;			// ^[Qbg̔a
			const double L    = _1pc_meter * norm( get_current_target_pos() - g_camera.get_pos() );	// ^[Qbg܂ł̋
			const float thR = tan(20.0f /180.0 *M_PI);												// ł鎞̋̎a
			if (Re/L < thR)		return;
		}
	}

	if (bControler)	{ 
		send_command(COMMAND_LANDING);
	}
	landing( get_landing_pos() );
}


void
OnLandingInit()
{
	OnInitTime();	//

	if (bControler)	{ send_command(COMMAND_LANDING_INIT); }
	change_target( TGTNO_EARTH );
	landing( vector2d(landing_lon0, landing_lat0) );
}



//--- 
void
OnTakeoff()
{
	if (bControler)	{ send_command(COMMAND_TAKEOFF); }

	tyMode = MODE_HIPPARCOS;


	const mtk_target&  tgt = get_current_target();
	if (tgt.cls == TGTCLS_PLANET) {
		int idx = tgt.id2;

		// Ă𐳖ʂɂ
		quaterniond  ori = get_ori_from_planetarium_dirc(idx, landing_lon, landing_lat, get_plnt_long());

		g_camera.set_ori( ori );

		const float height_rate = 0.05;
		set_scale( height_rate * get_planet_Re(idx) * _1km_pc );
	} else {
	}


	adjust_target_position();


	//****
	double t = get_time_JD();
	update_objects_position_and_orientation(t, true);
	update_space_curves(t);
	//****



	swConstellation = 0;
	bEcliptic = false;

	if (bControler) {
		OnUpdateViewCtrl();
		OnUpdateViewCtrl2();
	}
}





//-----------
//  Program
//-----------
void	OnInitModes();

void
OnProgram(char program_no)
{
	tyProgram = program_no;
	init_root_menu();
	menu_root.set_current_pos(menu_root.size()-1);

	if (bControler) {
		send_data_char(DATA_CHAR_PROGRAM, tyProgram);
	}
	if (bControler || !bNetwork) {
		OnInitModes();
	}
}



//-----------
// Switches
//-----------
void
OnTarget(char tgt)
{
	if (bControler)  { send_data_char(DATA_CHAR_TARGET, tgt); }
	change_target(tgt);
}

void
OnChangeTargetPos(const vector3f& pos)
{
	set_target_pos(pos);
	if (bControler)  { send_data_vector3f(DATA_VECTOR3F_TARGET_POS, get_current_target_pos()); }

	tyTarget = TGTNO_NONE;
}

void
OnTargetMoveControler()
{
	if (tyTarget != TGTNO_NONE) {
		double  ini_scale = get_target_ini_scale(tyTarget);
		OnSetZoom( ini_scale );
	}
}


void
OnPresentTime()
{
	if (bControler || !bNetwork) {
        OnChangeTime(get_present_JD());	// ݂̎
	}
}


void
OnRealTimeMode(bool bFlg)
{
	if (bControler)  { send_data_char(DATA_CHAR_REALTIME_MODE, bFlg); }
	SetRealtimeMode(bFlg);
}



void
OnResetViewangle()
{
	if (tyMode != MODE_PLANETARIUM) return;
	OnPlanetariumAngle(45.0);
}



void
OnStereo(char ty)
{
	tyStereo = ty;
	if (bControler)  { send_data_char(DATA_CHAR_STEREO, tyStereo); }
}


void
OnStar(char sw)
{
	char mask = STAR_NAME | STAR_NAME_SELECT | STAR_BAYER | STAR_FRAMSTEED | STAR_HIP;
	bool bMakeName = (swStar & mask) ^ (sw & mask);

	swStar = sw;
	if (bControler)  { send_data_char(DATA_CHAR_STAR, swStar); }

	if (bMakeName) {
		make_star_name_text_2(swStar, swConstellation);
	}
}

void
OnStarSet(char mask, bool bFlg)
{
	char sw;
	if (bFlg)	{ sw = swStar |  mask; }
	else		{ sw = swStar & ~mask; }
	OnStar(sw);
}


void
OnStarMark(char idx)
{
	tyStarMark = idx;
	if (bControler)  { send_data_char(DATA_CHAR_STAR_MARK, idx); }
}



void
OnConstellation(char sw)
{
	bool bMakeName = (swConstellation & CNST_BND) ^ (sw & CNST_BND);

	swConstellation = sw;
	if (bControler)  { send_data_char(DATA_CHAR_CONSTELLATION, swConstellation); }
	
	if (bMakeName) {
		make_star_name_text_2(swStar, swConstellation);
	}
}

void
OnCnstSet(char mask, bool bFlg)
{
	char sw;
	if (bFlg)	{ sw = swConstellation |  mask; }
	else		{ sw = swConstellation & ~mask; }
	OnConstellation(sw);
}




void
OnDispSwitch(char idx, char sw)
{
	if (bControler)  { send_data_switch(DATA_SWITCH_DISP, idx, sw); }
	set_disp_switch(idx, sw);
}


void
OnDispSwitchSetBit(char idx, char mask, bool bFlg)
{
	char sw = get_disp_switch(idx);
	if (bFlg)	{ sw |= mask; }
	else		{ sw &= ~mask; }

	OnDispSwitch(idx, sw);
}

void
OnDispSwitchToggle(char idx, char mask)
{
	char sw = get_disp_switch(idx) ^ mask;

	OnDispSwitch(idx, sw);
}

void
OnEclipse(char sw)
{
	swEclipse = sw;
	if (bControler)  { send_data_char(DATA_CHAR_ECLIPSE, swEclipse); }
}

void
OnEclipseSet(char mask, bool bFlg)
{
	char sw;
	if (bFlg)	{ sw = swEclipse |  mask; }
	else		{ sw = swEclipse & ~mask; }
	OnEclipse(sw);
}


void
OnPlanetAtmosphere(char val)
{
	AtmosphereMode = val;
	if (bControler)  { send_data_char(DATA_CHAR_ATMOSPHERE_MODE, val); }
}




void
OnOortCloud(bool bFlg)
{
	bOortCloud = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_OORT_CLOUD, bFlg); }
}


void
OnSpacecraftPath(char idx, bool bFlg)
{
	if (bControler) { 
		char buf[2];
		buf[0] = idx;
		buf[1] = char( bFlg );
		send_data_custom(DATA_CUSTOM_SPACECRAFT_PATH, buf, 2*sizeof(char));
	}

	set_spacecraft_path_mode(idx, bFlg);
}



void
OnBaseCameraOri(quaterniond _ori)
{
	static quaterniond ori = _ori;
	set_base_camera(ori);
	if (bControler) {
		send_data_custom(DATA_CUSTOM_BASE_ORI, (const char*)&ori, sizeof(quaterniond));
	}
}



void
OnGalaxy(char sw)
{
	swGalaxy = sw;
	if (bControler)  { send_data_char(DATA_CHAR_GALAXY, swGalaxy); }
}

void
OnGalaxySet(char mask, bool bFlg)
{
	char sw;
	if (bFlg)	{ sw = swGalaxy |  mask; }
	else		{ sw = swGalaxy & ~mask; }
	OnGalaxy(sw);
}


void
OnMarkVirgoCluster(bool bFlg)
{
	bVirgoCluster = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_VIRGO_CLUSTER, bFlg); }
}



void
OnMilkyWay(char _tyMilkyWay)
{
	if (tyMilkyWay==_tyMilkyWay)  return;

	tyMilkyWay = _tyMilkyWay;
	if (bControler)  { send_data_char(DATA_CHAR_MILKYWAY, tyMilkyWay); }

	bMilkyWayImageLoaded = false;
}


void
OnDate(bool bFlg)
{
	bDate = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_DATE, bFlg); }
}

void
OnTimeSetting()
{
	CreateSetTimeDialog();
}


void
OnTimeStep(char ty)
{
	tyTimeStep = ty;
	if (bControler)  { send_data_char(DATA_CHAR_TIMESTEP, tyTimeStep); }
}

void
OnChangeEyeDistance(float dist)
{
	set_eye_distance_2(dist, get_eye_CLR());
	
	if (bControler)	{ send_data_float(DATA_FLOAT_EYE_DISTANCE, dist); };
}



void
OnPresetScale(char ty)
{
	const double preset_scale[] = {
		1e7   * _1km_pc,
		        _1AU_pc,
		10    * _1AU_pc,
		100   * _1AU_pc,
		1000  * _1AU_pc,
		10000 * _1AU_pc,
		1     * _1ly_pc,
		10    * _1ly_pc,
		100   * _1ly_pc,
		1000  * _1ly_pc,  // 1kly
		10000 * _1ly_pc,
		1e5   * _1ly_pc,
		1e6   * _1ly_pc,  // 1Mly
		1e7   * _1ly_pc,
		1e8   * _1ly_pc,
		1e9   * _1ly_pc,  // 1Gly
		1e10  * _1ly_pc
	};

	const double fac = 10.0;

	OnSetZoom( fac * preset_scale[ty] );
}




void
OnLang(char language)
{
	if (bControler)  { send_data_char(DATA_CHAR_LANG, language); }

	set_language(language);
	make_star_name_text_2(swStar, swConstellation);
	if (!bNetwork) {
		set_menu_bar(g_hWnd);
	}
}

void
OnZoomMode(char val)
{
	if (bControler)  { send_data_char(DATA_CHAR_ZOOM_MODE, val); }
	set_zoom_mode(val);

	double  ini_scale = get_target_ini_scale(tyTarget);
	if (ini_scale > get_current_scale() ) {
		OnSetZoom( ini_scale );
	}
}

void
OnTopoZoomMode(char val)
{
	if (bControler)  { send_data_char(DATA_CHAR_TOPO_ZOOM_MODE, val); }
	set_topo_zoom_mode(val);
}


void
OnCelestialGrid(bool bFlg)
{
	bCelestialGrid = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_CLST_GLD, bFlg); }
}

void
OnEcliptic(bool bFlg)
{
	bEcliptic = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_ECLIPTIC, bFlg); }
}

void
OnHorizonCoord(bool bFlg)
{
	bHorizonCoord = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_HORIZON_COORD, bFlg); }
}

void
OnGalacticGrid(bool bFlg)
{
	bGalacticGrid = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_GLX_GLD, bFlg); }
}

void
OnDistScale(char sw)
{
	swScaleLine = sw;
	if (bControler)  { send_data_char(DATA_CHAR_DIST_SCALE, sw); }
}


void
OnDistScaleSet(char mask, bool bFlg)
{
	char sw;
	if (bFlg)	{ sw = swScaleLine |  mask; }
	else		{ sw = swScaleLine & ~mask; }
	OnDistScale(sw);
}



void
OnNGC(bool bFlg)
{
	bNGC = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_NGC, bFlg); }
}

void
OnSideLight(bool bFlg)
{
	bSideLight = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_SIDE_LIGHT, bFlg); }
}

void
OnSurfacePointer(bool bFlg)
{
	bSurfacePointer = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_SURFACE_POINTER, bFlg); }
}

void
OnTest(bool bFlg)
{
	bTest = bFlg;

	char type = bFlg ? ANIM_TY_ZOOMIN_IMAGE : ANIM_TY_ZOOMOUT_IMAGE;
	set_animation(type, 50, 1);
	if (bControler)  { send_data_char(DATA_CHAR_TEST, bFlg); }
}



//----------------
//  Pointer Mode
//----------------
void
OnPointerPos(const float* pos)
{
	pointer_angle_x = pos[0];
	pointer_angle_y = pos[1];
	pointer_z		= pos[2];
	if (bControler) { send_data_custom(DATA_CUSTOM_POINTER_POS, (const char*)pos, 3*sizeof(float)); }
}

void
OnPointerMode(char bFlg)
{
	tySubMode = (bFlg) ? SUBMODE_POINTER : SUBMODE_NORMAL;
	if (bFlg) {
		float pos[3];
		pos[0] = 0;
		pos[1] = 0;
		pos[2] = screen_z;
		OnPointerPos(pos);
	}

	if (bControler) { send_data_char(DATA_CHAR_SUBMODE_POINTER, bFlg); }
}


//------------
//  3D chart
//------------
void
OnOpen3DChart(char val)
{
	tySubMode = SUBMODE_3DCHART;
	no_3DChart = val;
	if (bControler) { send_data_char(DATA_CHAR_3DCHART, val); }
}

void
OnClose3DChart()
{
	tySubMode = SUBMODE_MENU;
	if (bControler) { send_command(COMMAND_3DCHART_CLOSE); }
}



//===============
//  Media Files
//===============
char media_file_path[20][MAX_PATH];




//---------
//  Title
//---------
void
OnMovieTitle(const char* menu_title, const char* disp_title)
{
	media_file_info  mfi;
	mfi.type = MEDIATYPE_MOVIE;
	strcpy(mfi.menu_title, menu_title);
	strcpy(mfi.disp_title, disp_title);
	MVF.push_back(mfi);
}

void
OnImageTitle(const char* menu_title, const char* disp_title, bool bPopUp)
{
	media_file_info  mfi;
	mfi.type = (bPopUp)  ?  MEDIATYPE_POPUP_IMAGE  :  MEDIATYPE_IMAGE;
	strcpy(mfi.menu_title, menu_title);
	strcpy(mfi.disp_title, disp_title);
	IMGF.push_back(mfi);
}

void
OnAudioTitle(const char* menu_title, const char* disp_title)
{
	media_file_info  mfi;
	mfi.type = MEDIATYPE_AUDIO;
	strcpy(mfi.menu_title, menu_title);
	strcpy(mfi.disp_title, disp_title);
	AUDF.push_back(mfi);
}




//---------
//  Image
//---------
char tyLastSubMode;

void
OnImageOpenControler(int idx)
{
	bool bSubtitleMode2 = (bSubtitles || (subtitles_idx!=0));

	if ( !IMGF.load_pathfile(idx, media_file_path, bSubtitleMode2) )  return;
	send_image_filename(idx, media_file_path);
	OnImageOpen(idx, media_file_path[svr_num]);
}

void
OnImageOpen(const char idx, const char* filename)
{
	//*****************
	tyLastSubMode = tySubMode;
	//*****************

	tySubMode = SUBMODE_IMAGE;
	current_image_index = idx;

	ImageStill.set_image(filename);
}

void
OnImageClose()
{
	if (bControler)	{ send_command(COMMAND_IMAGE_CLOSE); }
	tySubMode = tyLastSubMode;
}



//---------
//  PopUp
//---------
void
OnPopup(int pidx)
{
	popup_info&  pi = PopUp[pidx];

	switch (pi.type) {
		case POPUP_IMAGE:
				OnImageOpenControler(pi.idx);
				break;
		default:
			break;
	}
	PopUp[pidx].bFlg = false;	// N͂P̂
}


//--------------
//  ScreenFade
//--------------
void
OnScreenAlpha(float fac)
{
	if (bControler) { send_data_float(DATA_FLOAT_SCREEN_ALPHA, fac); }
	SetScreenAlpha(fac);
}




//---------
//  Movie
//---------


void
OnMovieOpenControler(const char idx)
{
	bool bSubtitleMode2 = (bSubtitles || (subtitles_idx!=0));

	if ( !MVF.load_pathfile(idx, media_file_path, bSubtitleMode2) )  return;
	send_movie_filename(idx, media_file_path);
	OnMovieOpen(media_file_path[svr_num]);
}


void
OnAudioOpenControler(const char idx)
{
	bool bSubtitleMode2 = (bSubtitles || (subtitles_idx!=0));


	if ( !AUDF.load_pathfile(idx, media_file_path, bSubtitleMode2) )  return;
	send_movie_filename(idx, media_file_path);
	OnMovieOpen(media_file_path[svr_num]);
}



void
OnMovieOpen(const char* filename)
{
	bMovieMode = true;
	
	SetMovieStart(true);
	SetMovieFadeAlpha(0.0);

	if (bControler || !bNetwork) {
		dsmv.open(filename, g_hWnd, win_mgn_w1, win_mgn_h1, win_w, win_h, WM_GRAPHNOTIFY, bWindowlessVMR);
	} else {
		dsmv.open(filename, g_hWnd, win_mgn_w1, win_mgn_h1, win_w, win_h, NULL, bWindowlessVMR);
	}

	

	bMoviePlaying = false;

	while (bNetwork && bDrawing) { Sleep(1); }

	Sleep(100);


	// wiNA
	if (dsmv.is_movie()) {
		HDC hDC = GetDC(g_hWnd);
		draw_movie_margen(hDC);

		ReleaseDC(g_hWnd, hDC);
	}
}


void
OnMovieFade(float fac)
{
	if (bControler) { send_data_float(DATA_FLOAT_MOVIE_FADE_ALPHA, fac); }
	SetMovieFadeAlpha(fac);
}


void
OnMovieSetPosition(LONGLONG pos)
{
	if (bControler)	{ send_data_LONGLONG(DATA_LONGLONG_MOVIE_POS, pos); }
	dsmv.set_position(pos);
	bMoviePlaying = false;
}


void
OnMoviePlay()
{
	if (bControler)	{ send_command(COMMAND_MOVIE_PLAY); }
	SetMovieStart(true);
	dsmv.play();
	bMoviePlaying = true;
}

void
OnMoviePauseControler()
{
	dsmv.pause();
	if (bControler) {
		LONGLONG  pos = dsmv.get_position();
		send_data_LONGLONG(DATA_LONGLONG_MOVIE_POS, pos);
	}
	
	bMoviePlaying = false;
}

void
OnMovieHome()
{
	if (bControler)	{ send_command(COMMAND_MOVIE_HOME); }
	dsmv.home();
	bMoviePlaying = false;
}

void
OnMovieEnd()
{
	if (bControler)	{ send_command(COMMAND_MOVIE_END); }
	dsmv.end();
	bMoviePlaying = false;
}



//**********************************************
void
OnMovieClose()
{
	if (bControler)	{
		if (!send_command(COMMAND_MOVIE_CLOSE)) {
		}
	}
	SetMovieFadeAlpha(1.0);

	dsmv.close();
	bMoviePlaying = false;
	bMovieMode = false;

	OnScreenAlpha(0);
}
//**********************************************


void
OnDirectShowEvent()
{
	long  evCode, prm1, prm2;

	while ( dsmv.get_event(evCode, prm1, prm2) )  {
		if (evCode==EC_COMPLETE) {
			bMoviePlaying = false;
		}
	}
}






//--------
//  Path
//--------
void
OnPlayFrame(bool bFlg)
{
	if (!start_play_frame(bFlg))  return;

	if (bControler)  { send_data_char(DATA_CHAR_PLAY, bFlg); }
}


void
OnTitle(bool bFlg)
{
	bAppTitle = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_TITLE, bFlg); }
}

void
OnCheckAbout(bool bFlg)
{
	bAbout = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_ABOUT, bFlg); }
}

void
OnDebug(bool bFlg)
{
	bDebug = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_DEBUG, bFlg); }
}

void
OnViewInfo(bool bFlg)
{
	bViewInfo = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_VIEW_INFO, bFlg); }
}

void
OnSingleEye(bool bFlg)
{
	bSingleEye = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_SINGLE_EYE, bFlg); }
}

void
OnKeyHelp(bool bFlg)
{
	bKeyHelp = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_KEY_HELP, bFlg); }
}


void
OnSubtitles(bool bFlg)
{
	bSubtitles = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_SUBTITLES, bFlg); }
}


void
OnPathInfo(bool bFlg)
{
	bPathInfo = bFlg;
	if (bControler)  { send_data_char(DATA_CHAR_PATH_INFO, bFlg); }
}





//
void
OnSetLRef(float val)
{
	set_L_ref(val);
	if (bControler)  { send_data_float(DATA_FLOAT_MAG, get_L_ref()); }

}

void
OnLRef(float dL)
{
	OnSetLRef(get_L_ref()*dL);
}


void
OnSetFontSize(float val)
{
	FontSize = val;
	if (bControler)  { send_data_float(DATA_FLOAT_FONT_SIZE, FontSize); }
}


void
OnFontSize(const char idx)
{
	if (idx>=0 && idx<=4) {
		OnSetFontSize( vFontSize[idx] );
	}
}




void
OnSetZoom(double val)
{
	g_scale_last = get_current_scale();

	set_scale(val);

	double scl = get_current_scale();

	//
	adjust_target_position();


	if (bControler)  { send_data_double(DATA_DOUBLE_ZOOM_FACTOR, scl); }
}

void
OnZoom(double fac)
{
	OnSetZoom(get_current_scale() * fac);
}

void
OnPlanetariumAngle(float val)
{
	set_planetarium_angle(val);
	if (bControler)  { send_data_float(DATA_FLOAT_PLNT_ANGLE, val); }
}

void
OnChangeTime(const double& t)
{
	if (bControler) { send_data_double(DATA_DOUBLE_JD, t ); }
	change_time_JD(t);
}


void
OnPreset(int idx)
{

	switch (idx) {
		case PRESET_SOLARSYSTEM_COMPLETE_VIEW:
			if (tyMode != MODE_HIPPARCOS)  break;
			g_camera.set_ori( quaterniond(-3.49e-1, -9.35e-1, -5.34e-2, 2.31e-2) );
			OnUpdateViewCtrl();
			OnSetZoom( 2.04e-3 );
			OnTarget( TGTNO_EARTH );
			break;
		case PRESET_SPACECRAFT_PATH:
			if (tyMode != MODE_HIPPARCOS)  break;
			OnChangeTime( get_JD(1972, 3,3, 0,0,0.0) );
			OnTimeStep( TIMESTEP_MONTH );
			g_camera.set_ori( quaterniond(-4.23e-1, -8.24e-1, 3.34e-1, -1.73e-1) ); 
			OnUpdateViewCtrl();
			OnSetZoom( 1.90e-4 );
			OnTarget( TGTNO_SUN );
			OnZoomMode(1);
			for (int i=0; i<5; i++) {
				OnSpacecraftPath(i, true);
			}

			break;
		default:
			break;
	}
}





void
OnInitOrientation()
{
	// vl^E[hœ̋悤ɂ
	float lon = plnt_long_ini;
	
	set_plnt_long(lon);
	set_plnt_lati(plnt_lati_ini);
}

void
OnInitTime()
{
	//-- ̖Wɐݒ肷--
	UTC lt = get_present_LocalTime(DT);
	OnChangeTime( get_JD(lt.year, lt.month, lt.day, 20, 0, 0.0) - DT/24.0 ); 
}





void
OnInitModes()
{
	OnLandingInit();
	OnInitOrientation();
	OnUpdateViewCtrl();
	OnUpdateViewCtrl2();
	OnTargetMoveControler();
	
	OnPlanetariumAngle(45.0);

	OnSetLRef( L_ref_ini );
	OnDate(false);
	OnEcliptic(false);
	OnCelestialGrid(false);
	OnInitTime();
	OnTimeStep( TIMESTEP_10MIN );


	OnDispSwitch( DISPSW_PLANET,		DISPM_DISP | DISPM_ORBIT | DISPM_CLOUD);
	OnDispSwitch( DISPSW_SATELLITE,		DISPM_DISP | DISPM_NAME  | DISPM_ORBIT | DISPM_SELECT );
	OnDispSwitch( DISPSW_MINOR_PLANET,	DISPM_DISP | DISPM_NAME  | DISPM_ORBIT | DISPM_SELECT );
	OnDispSwitch( DISPSW_TNO,			DISPM_DISP | DISPM_NAME  | DISPM_ORBIT | DISPM_SELECT );

	OnPlanetAtmosphere( ATMOSPHERE_MULTIPLE );
	OnStar(STAR_DISP | STAR_NAME_SELECT);
	OnConstellation(0);
	OnGalaxy(GLXY_OUR_GALAXY | GLXY_GLOB_CLSTR | GLXY_NEARBY_GALAXY | GLXY_DISTANT_GALAXY | GLXY_QSO);
	OnStarMark(STARMARK_NONE);
	OnMarkVirgoCluster(false);

	OnZoomMode(0);
	OnOortCloud(true);
	OnMilkyWay(MILKYWAY_VISIBLE);
	OnDistScale(SCALE_CIRCLE);
	for (int i=0; i<5; i++) {
		OnSpacecraftPath(i, false);
	}

	OnChangeSubtitlesIndex(0);
	OnSubtitles(false);

	bFlg3 = false;	//***
	const char lang = get_language();
	switch (tyProgram) {
		case 0:		//--- F̑K͍\i_CWFXgŁj
			if (lang!=LANG_ENG)  OnLang(LANG_KNJ);
			OnZoomMode(1);
			break;
		case 1:		//--- F̑K͍\iWjAŁj
			if (lang!=LANG_ENG)  OnLang(LANG_HIRA);
			OnZoomMode(2);
			OnOortCloud(false);
			OnGalaxySet(GLXY_DISTANT_GALAXY, false);
			OnGalaxySet(GLXY_QSO, false);
			break;
		case 2:		//--- V̐̔閧
			if (lang!=LANG_ENG)  OnLang(LANG_KNJ);
			OnZoomMode(1);
			OnOortCloud(false);
			break;
		case 3:		//--- znIs
			bFlg3 = true;
			break;
		case 4:		//--- znz
			if (lang!=LANG_ENG)  OnLang(LANG_KNJ);
			OnZoomMode(1);
			OnTimeStep( TIMESTEP_DAY );
			break;
		default:
			break;
	}
	init_popup(tyProgram);

	OnCommandDraw();
}



void
OnNameToggle()
{
	if (tyMode == MODE_PLANETARIUM) {
		
		bool flg = (!bDate || !(swStar & STAR_NAME) || !test_disp_switch(DISPSW_PLANET, DISPM_NAME)
			|| !(swConstellation & (CNST_NAME | CNST_LINE)))  ?  true  :  false;

		OnEcliptic(flg);
		OnDate(flg);

		OnDispSwitchSetBit(DISPSW_PLANET,		DISPM_NAME, flg);
		OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_NAME, flg);
		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_NAME, flg);
		OnDispSwitchSetBit(DISPSW_TNO,			DISPM_NAME, flg);

		OnStarSet(STAR_NAME, flg);
		OnCnstSet(CNST_NAME | CNST_LINE, flg);
	} else {
		bool flg = (!bDate || !(swStar & STAR_NAME) || !test_disp_switch(DISPSW_PLANET, DISPM_NAME))  ?  true  :  false;
		OnDate(flg);

		OnDispSwitchSetBit(DISPSW_PLANET,		DISPM_NAME, flg);
		OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_NAME, flg);
		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_NAME, flg);
		OnDispSwitchSetBit(DISPSW_TNO,			DISPM_NAME, flg);


		OnStarSet(STAR_NAME, flg);
		
		OnDistScaleSet(SCALE_CIRCLE, flg);
	}

	//
	OnCommandDraw();
}



//----------
//  Signal
//----------
static bool g_Signal;

void
ClearSignal() {
	g_Signal = false;
}

bool
GetSignal()
{
	return g_Signal;
}

void
WaitForSignal()
{
	while( !GetSignal() ) { Sleep(100); };
}

void
OnCommandSignal()
{
	g_Signal = true;
	if (bControler) { send_command(COMMAND_SIGNAL); }
}



//----------------
// Menu commands
//----------------
void
OnExitAll()
{
	if (bControler)	{ send_command(COMMAND_EXIT_ALL); }

	SendMessage(g_hWnd, WM_CLOSE, 0, 0);
}


void
OnCaptureImage()
{
	bool flg = false;

	if (bControler)	{ send_command(COMMAND_CAPTURE_IMAGE); }

	
	image  img_tmp(0,0,3);

	HDC  hDC = GetDC(g_hWnd);
	ogl.MakeCurrent(hDC);

	gl_capture_viewport(img_tmp);
	flg = true;

	ogl.MakeCurrent(NULL);

	if (flg) {
		img_tmp.savePNG("capture.png");
	}

	ReleaseDC(g_hWnd, hDC);
}

void
OnMakeStereogram()
{
	float eye_offset_x_org = eye_offset_x;
	image  img_tmp(0,0,3);

	HDC  hDC = GetDC(g_hWnd);

	ogl.MakeCurrent(hDC);
		eye_offset_x = -get_eye_distance()/2;
		draw();
		gl_capture_viewport(img_tmp);
		img_tmp.savePNG("stereo_L.png");

		eye_offset_x =  get_eye_distance()/2;
		draw();
		gl_capture_viewport(img_tmp);
		img_tmp.savePNG("stereo_R.png");
	ogl.MakeCurrent(NULL);

	ReleaseDC(g_hWnd, hDC);

	eye_offset_x = eye_offset_x_org;
}





//-------------------
//  (Subtitles)
//-------------------
void
OnChangeSubtitlesIndex(int idx)
{
	subtitles_idx = idx;

	if (bControler)  { send_data_int(DATA_INT_SUBTITLES_INDEX, subtitles_idx); }
}



//--------------
//  Title Mode
//--------------
void
OnTitlePageMode(bool bFlg)
{
	tySubMode = (bFlg) ? SUBMODE_TITLE : SUBMODE_NORMAL;
	if (bControler)  { send_data_char(DATA_CHAR_TITLE_MODE, bFlg); }
}


void
OnTitlePage(char val)
{
	set_title_page_no(val);
	if (bControler)  { send_data_char(DATA_CHAR_TITLE_PAGE, val); }
}

void
set_title_page_ctrl(int idx)
{
	if (tySubMode != SUBMODE_TITLE)  return;
	if (bSubtitles)	{ OnSubtitles(false); }

	switch (idx) {
		case TITLEPAGE_CREDITS:
			OnDate(false);
			OnDispSwitchSetBit( DISPSW_PLANET, DISPM_NAME, false );
			OnStarSet(STAR_NAME | STAR_BAYER | STAR_FRAMSTEED | STAR_HIP, false);
			OnCnstSet(CNST_NAME, false);
			set_animation(ANIM_TY_CREDIT_SCROLL, (1000.0/TIMER_INTERVAL) * get_credit_roll_duration(), 1);
			break;
		case TITLEPAGE_ATTENTION:
			OnInitModes();
			break;
		case TITLEPAGE_TITLE:
			set_animation(ANIM_TY_TITLE, (1000.0/TIMER_INTERVAL) * get_title_duration(), 1);
			break;
		case TITLEPAGE_THEME:
			set_animation(ANIM_TY_THEME, 30, 1);
			break;
		default:
			OnTitlePageMode(false);
			return;
	}
	OnTitlePage(idx);
	OnCommandDraw();
}




void
OnEnterTitleMode()
{
	OnTitlePageMode(true);
	set_title_page_ctrl(0);
}

void
OnNextTitlePage()
{
	set_title_page_ctrl( get_title_page_no()+1 );
}



//----------------
//  Setting mode
//----------------
void
OnEnterSettingMode()
{
	if (bControler)	{ send_command(COMMAND_SETTING_ENTER); }
	tySubMode = SUBMODE_SETTING;
	chSettingModeDisp = SETTING_MODE_NONE;
}

void
OnLeaveSettingMode()
{
	if (bControler)	{ send_command(COMMAND_SETTING_LEAVE); }
	tySubMode = SUBMODE_NORMAL;
	chSettingModeDisp = SETTING_MODE_NONE;
}

void
OnSettingModeDisp(char val)
{
	if (bControler)  { send_data_char(DATA_CHAR_SETTING_DISP, val); }
	chSettingModeDisp = val;
}




//--------
//  Menu
//--------
void	OnMenuFade(float fac);

void
OnEnterMenu()
{
	if (bControler)	{ send_command(COMMAND_MENU_ENTER); }

	//
	tySubMode = SUBMODE_MENU;
	mnuSelect.clear();
	mnuSelect.push_back(&menu_root);
	menu_root.set_current_pos(0);

	OnMenuFade(0);
	float v = 1 / GetMenuFadeDuration();
	SetMenuFadeVelocity(v);
}

void
OnLeaveMenu()
{
	tySubMode = SUBMODE_NORMAL;
	mnuSelect.clear();
}

void
OnCloseMenu()
{
	if (bControler)	{ send_command(COMMAND_MENU_CLOSE); }

	if (mnuSelect.size() == 1)	{ OnLeaveMenu();  }
	else						{ mnuSelect.pop_back(); }
}


void
OnMenuPos(int pos)
{
	if (bControler)	{ send_data_char(DATA_CHAR_MENU_POS, pos); }

	menu&  mnu = *mnuSelect.back();
	mnu.set_current_pos(pos);
}

void
OnMenuAngle(float angle)
{
	menu_angle = angle;
	if (menu_angle < 0)   menu_angle += 360;
	if (menu_angle > 360) menu_angle -= 360;

	if (bControler)	{ send_data_float(DATA_FLOAT_MENU_ANGLE, menu_angle); }
}

void
OnMenuFade(float fac)
{
	if (bControler) { send_data_float(DATA_FLOAT_MENU_FADE_FACTOR, fac); }
	SetMenuFadeFactor(fac);
}


void
OnExecMenu()
{
	menu&  mnu = *mnuSelect.back();
	int pos = mnu.get_current_pos();
	switch (mnu[pos]->get_type()) {
		case MENU_TY_CHILD:
			{
				menu*  pMnuChild = ((menu_item_child*)mnu[pos])->get_child_menu();
				mnuSelect.push_back( pMnuChild );
				pMnuChild->set_current_pos_auto();

				OnMenuFade(0);
				float v = 1 / GetMenuFadeDuration();
				SetMenuFadeVelocity(v);

				if (bControler)	{ send_command(COMMAND_MENU_EXEC); }
			}
			break;
		case MENU_TY_COMMAND:
			{
				menu_item_command&  mtc = *(menu_item_command*)(mnu[pos]);
				int ID = mtc.get_ID();
				const int idx = mtc.get_idx();

				switch (ID) {
					case MENU_COMMAND_CLOSE:				OnCloseMenu();						return;
					case MENU_COMMAND_EXIT_ALL:				OnExitAll();						return;

					case MENU_COMMAND_MOVIE_OPEN:			OnMovieOpenControler(idx);			return;
					case MENU_COMMAND_IMAGE_OPEN:			OnImageOpenControler(idx);			return;
					case MENU_COMMAND_AUDIO_OPEN:			OnAudioOpenControler(idx);			return;
					case MENU_COMMAND_3DCHART:				OnOpen3DChart(idx);					return;

					case MENU_COMMAND_LANDING_INIT:			OnLandingInit();					return;

					case MENU_COMMAND_STAR_BRIGHTEN:		OnLRef( pow(10, -0.4*0.5) );		return;
					case MENU_COMMAND_STAR_DARKEN:			OnLRef( pow(10, +0.4*0.5) );		return;
					case MENU_COMMAND_STAR_DEFAULT_BRIGHTNESS:	OnSetLRef( 1.0f );				return;
					case MENU_COMMAND_PRESENT_TIME:			OnPresentTime();					return;
					case MENU_COMMAND_TARGET_MOVE:			OnTargetMoveControler();			return;
					case MENU_COMMAND_RESET_VIEWANGLE:		OnResetViewangle();					return;
					case MENU_COMMAND_PRESET:				OnPreset(idx);						return;
					case MENU_COMMAND_PLAY_PATH:			OnPlayFrame(true);					return;
					case MENU_COMMAND_SAVE_PATH:			OnSavePath();						return;
					case MENU_COMMAND_LOAD_PATH:			OnLoadPath();						return;
					case MENU_COMMAND_CLEAR_PATH:			OnClearPath();						return;
					
					case MENU_COMMAND_GOTO:
						{
							int no = get_goto_command_target_no(idx);


							switch (no) {
								case TGTNO_EARTH:	OnInitTime();				break;
								default:										break;
							}

							OnTarget(no);
							
							switch (no) {
								case TGTNO_CASSINI:	OnTargetMoveControler();	break;
								default:										break;
							}
						}
						return;
					
					case MENU_COMMAND_DRAW_MILKYWAY:		OnMilkyWay(MILKYWAY_VISIBLE);				return;
					case MENU_COMMAND_DRAW_MILKYWAY2:		OnMilkyWay(MILKYWAY_VISIBLE2);				return;
					default:	return;
				}
				break;
			}
		case MENU_TY_CHECK:
			{
				menu_item_check&  mtck = *(menu_item_check*)(mnu[pos]);
				bool bChk = !mtck.get_check();
				mtck.set_check( bChk );

				const int ID = mtck.get_ID();
				const int idx = mtck.get_idx();

				switch (ID) {
					case MENU_CHECK_TARGET:			if (tyMode==MODE_HIPPARCOS)		OnTarget(idx);	return;

					case MENU_CHECK_CNST_NAME:			OnCnstSet(CNST_NAME,	bChk);		return;
					case MENU_CHECK_CNST_LINE:			OnCnstSet(CNST_LINE,	bChk);		return;
					case MENU_CHECK_CNST_ILLUST:		OnCnstSet(CNST_ILLUST,	bChk);		return;
					case MENU_CHECK_CNST_BND:			OnCnstSet(CNST_BND,		bChk);		return;

					case MENU_CHECK_STAR:				OnStarSet(STAR_DISP,		bChk);	return;
					case MENU_CHECK_STAR_NAME:			OnStarSet(STAR_NAME,		bChk);	return;
					case MENU_CHECK_STAR_NAME_SELECT:	OnStarSet(STAR_NAME_SELECT,	bChk);	return;
					case MENU_CHECK_STAR_BAYER:			OnStarSet(STAR_BAYER,		bChk);	return;
					case MENU_CHECK_STAR_FRAMSTEED:		OnStarSet(STAR_FRAMSTEED,	bChk);	return;
					case MENU_CHECK_STAR_HIP:			OnStarSet(STAR_HIP,			bChk);	return;

					case MENU_CHECK_STAR_MARK:			OnStarMark( idx );					return;

				
					//--  Planet
					case MENU_CHECK_PLANETS:			OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_DISP,			bChk);	return;
					case MENU_CHECK_PLANET_NAME:		OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_NAME, 		bChk);	return;
					case MENU_CHECK_PLANET_ORBIT:		OnDispSwitchSetBit(DISPSW_PLANET, 	DISPM_ORBIT, 		bChk);	return;
					case MENU_CHECK_PLANET_AXIS:		OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_AXIS,			bChk);	return;
					case MENU_CHECK_PLANET_CLOUD:		OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_CLOUD,		bChk);	return;
					case MENU_CHECK_PLANET_CITY_LIGHTS:	OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_CITY_LIGHTS,	bChk);	return;

					//--  Satellite
					case MENU_CHECK_SATELLITE_DISP:		OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_DISP,			bChk);	return;
					case MENU_CHECK_SATELLITE_NAME:		OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_NAME,			bChk);	return;
					case MENU_CHECK_SATELLITE_ORBIT:	OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_ORBIT,		bChk);	return;
					case MENU_CHECK_SATELLITE_SELECT:	OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_SELECT,		bChk);	return;

					//--  Minor Planet
					case MENU_CHECK_MINOR_PLANET_DISP:		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_DISP,		bChk);	return;
					case MENU_CHECK_MINOR_PLANET_NAME:		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_NAME,		bChk);	return;
					case MENU_CHECK_MINOR_PLANET_ORBIT:		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_ORBIT,	bChk);	return;
					case MENU_CHECK_MINOR_PLANET_SELECT:	OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_SELECT,	bChk);	return;

					//--  TNOs
					case MENU_CHECK_TNO_DISP:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_DISP,		bChk);	return;
					case MENU_CHECK_TNO_NAME:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_NAME,		bChk);	return;
					case MENU_CHECK_TNO_ORBIT:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_ORBIT,	bChk);	return;
					case MENU_CHECK_TNO_SELECT:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_SELECT,	bChk);	return;
					case MENU_CHECK_TNO_OORT_CLOUD:	OnOortCloud(bChk);										return;
						
					case MENU_CHECK_PLANET_ATMOSPHERE:	OnPlanetAtmosphere(idx);		return;
					case MENU_CHECK_PLANET_ZOOM:		OnZoomMode(idx);				return;
					case MENU_CHECK_TOPO_ZOOM:			OnTopoZoomMode(idx);			return;
					case MENU_CHECK_LANDING_MODE:		OnLandingMode(idx);				return;

					case MENU_CHECK_ECLIPSE_DISP:		OnEclipseSet(ECLIPSE_DISP,		bChk);	return;
					case MENU_CHECK_ECLIPSE_BORDER:		OnEclipseSet(ECLIPSE_BORDER,	bChk);	return;

					case MENU_CHECK_SPACECRAFT_PATH:	OnSpacecraftPath(idx, bChk);	return;

					case MENU_CHECK_OUR_GALAXY:			OnGalaxySet(GLXY_OUR_GALAXY, bChk);		return;
					case MENU_CHECK_GLOBULAR_CLUSTER:	OnGalaxySet(GLXY_GLOB_CLSTR, bChk);		return;
					case MENU_CHECK_GALAXY_NEAR:		OnGalaxySet(GLXY_NEARBY_GALAXY, bChk);	return;
					case MENU_CHECK_GALAXY_SDSS:		OnGalaxySet(GLXY_DISTANT_GALAXY, bChk);		return;
					case MENU_CHECK_GALAXY_QSO:			OnGalaxySet(GLXY_QSO, bChk);			return;
					case MENU_CHECK_GALAXY_VIRGO:		OnMarkVirgoCluster(bChk);				return;

					case MENU_CHECK_MILKYWAY:		OnMilkyWay(idx);					return;

					case MENU_CHECK_NGC:			OnNGC(bChk);						return;

					case MENU_CHECK_CLST_GRD:		OnCelestialGrid(bChk);				return;
					case MENU_CHECK_ECLIPTIC:		OnEcliptic(bChk);					return;
					case MENU_CHECK_HORIZON_COORD:	OnHorizonCoord(bChk);				return;
					case MENU_CHECK_GLX_GRD:		OnGalacticGrid(bChk);				return;

					case MENU_CHECK_DIST_SCALE:		OnDistScaleSet(SCALE_CIRCLE, bChk);	return;
					case MENU_CHECK_SCALE_SQUARE:	OnDistScaleSet(SCALE_SQUARE, bChk);	return;

					case MENU_CHECK_SIDE_LIGHT:		OnSideLight(bChk);					return;
					case MENU_CHECK_SURFACE_POINTER:OnSurfacePointer(bChk);				return;

					case MENU_CHECK_DATE:			OnDate(bChk);						return;
					case MENU_CHECK_TIME:			OnTimeStep(idx);					return;
					case MENU_CHECK_REALTIME_MODE:	OnRealTimeMode(bChk);				return;

					case MENU_CHECK_LANG:			OnLang(idx);						return;

					case MENU_CHECK_TEST:			OnTest(bChk);						return;

					case MENU_CHECK_PROGRAM: 		OnProgram(idx);						return;

					case MENU_CHECK_FONT_SIZE: 		OnFontSize(idx);					return;

					case MENU_CHECK_FULLSCREEN:		OnFullScreen(bChk);					return;
					case MENU_CHECK_SUBTITLES:		OnSubtitles(bChk);					return;
					case MENU_CHECK_TITLE:			OnTitle(bChk);						return;
					case MENU_CHECK_ABOUT:			OnCheckAbout(bChk);					return;
					case MENU_CHECK_DEBUG:			OnDebug(bChk);						return;
					case MENU_CHECK_VIEW_INFO:		OnViewInfo(bChk);					return;
					case MENU_CHECK_SINGLE_EYE:		OnSingleEye(bChk);					return;
					
					case MENU_CHECK_PATH_INFO:		OnPathInfo(bChk);					return;

					default:															return;
				}
				break;
			}
			break;
		default:
			return;
	}
}




void
OnAbout()
{
	DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG_ABOUT, g_hWnd, (DLGPROC)About);
}









//---------
//  Popup
//---------
void
init_popup(const char nProgram)
{
	bool bFlg;
	
	switch (nProgram) {
		case 0:
		case 2:
		default:
			bFlg = false;
			break;
		case 1:
			bFlg = true;
			break;
	}

	for (int i=0; i<popup_num; i++) {
		PopUp[i].bFlg = bFlg;		// |bvAbv̗L
	}
}

int
check_popup()
{
	const double scale = get_current_scale();
	for (int i=0; i<popup_num; i++) {
		popup_info&  pi = PopUp[i];
		if (!pi.bFlg)  continue;
		bool bFlg1 = (g_scale_last < pi.scale);
		bool bFlg2 = (scale < pi.scale);
		if (bFlg1 != bFlg2) {	// |bvAbv̋N
			return i;
		}
	}

	return -1;
}



//-- fɋ߂Ẩ]p̃XP[
float
get_rotation_factor()
{
	const float Rt = get_target_radius() * get_scale_factor();
	const float Rc = ini_obj_z;
	if (Rt > Rc) {
		return 0.3f * Rc/Rt;
	}
	return 1.0f;
}


//--- Y[CEY[AEg̏
void
process_zoom(const float& zm)
{
	bMotion = true;

	if (tyMode == MODE_HIPPARCOS) {
		float zma = 1.0 + fabs(zm);
		if (zm > 0)		{ OnZoom(1.0/zma);     }
		else			{ OnZoom(zma); }
		int pidx = check_popup();
		if (pidx >= 0) {
			OnPopup(pidx);
		}
	} else {
		float a = 1.0 + fabs(zm);
		float ang;

		if (zm > 0)		{ ang = get_plnt_angle()/a; }
		else			{ ang = get_plnt_angle()*a; }

		if (ang >= plnt_angle_min && ang <= plnt_angle_max) {
			OnPlanetariumAngle(ang);
		}
	}
}



//=========
//  Input
//=========
bool
InputNormal(button_state* btn, axis_state* axi)
{
	bool flg = false;


	//--  Play {^: j[[h
	if (btn[BTN_PLAY].value && btn[BTN_PLAY].bToggle)		{ OnEnterTitleMode();		return true; }

	//--  Select{^: |C^[h
	if (btn[BTN_SELECT].value && btn[BTN_SELECT].bToggle)	{ OnPointerMode(true); return true; }

	//--  {^: j[
	if (btn[BTN_CIR].value && btn[BTN_CIR].bToggle)	{
		OnEnterMenu();		return true;							// j[J
	}

	//--  ~{^
	if (btn[BTN_CRS].value)	{
		OnEnterSettingMode();
		return  true;
	}
	
	//--  {^:iAj
	if (btn[BTN_TRI].value && btn[BTN_TRI].bToggle)	{
		switch (tyMode) {
			case MODE_PLANETARIUM:	OnTakeoff();	break;
			case MODE_HIPPARCOS:	OnLanding();	break;
			default:								break;
		}

		return true;
	}

	//--  {^:  OÃIEIt
	if (btn[BTN_SQR].value && btn[BTN_SQR].bToggle)			{ OnNameToggle();			return true; }

	/*
	//--  R3{^:  ^[Qbgt߂Ɉړ
	if (btn[BTN_R3].value && btn[BTN_R3].bToggle) {
		OnTargetMoveControler();
		return  true;
	}
	*/


	const float Rate = get_move_speed();	// ړʂɂt@N^


	//-- Axes
	float x, y, z, rt, zm, zz;
	x = y = z = rt = zm = zz = 0;
	if (btn[BTN_L2].value)	{
		rt  = axi[0].get_normalized_value();
		z   = axi[2].get_normalized_value();
	} else if (btn[BTN_R2].value) {
		zz  = -axi[3].get_normalized_value();
	
		x   = axi[0].get_normalized_value();
		y   = axi[1].get_normalized_value();
	} else {
		x   = axi[0].get_normalized_value();
		y   = axi[1].get_normalized_value();
		zm  = -axi[2].get_normalized_value();		// オɂȂ悤ɂ
	}

	if      (sbZoomMinus.GetState() == SCRBTN_PUSH) { zm= 1; }
	else if (sbZoomPlus.GetState()  == SCRBTN_PUSH) { zm=-1; }

	if (tyMode==MODE_PLANETARIUM) { z=-z; }



	const mtk_target&  tgt = get_current_target();


	float lvr_Flon = 0;
	float lvr_Flat = 0;


	if (tyMode == MODE_HIPPARCOS) {
		float Fx, Fy, Fs, Fzm;

		//--  Rotation  --
		float fxy = Rate * 5;

		//*****  fɋ߂ÂƂ͉]p  *****
		fxy *= get_rotation_factor();

		Fx  = -0.5*fxy*x;
		Fy  =  0.5*fxy*y;
		Fs  =  0.5 * Rate * 5 * rt;
		Fzm =  10 * Rate * zm;
		SetInputForce3D(Fx, Fy, Fs, Fzm);
	} else {
		const float fac = 100 * 2 * Rate * z_far2 / get_plnt_R();
		float  Flon, Flat, Fpzm;

		Flon = -fac * x;
		Flat = -fac * y;
		Fpzm = 10 * Rate * zm;
		SetInputForcePlanetarium(Flon, Flat, Fpzm);
	}


	//-- ς
	double dJD = 0;
	if (btn[BTN_L1].value || sbTimeMinus.GetState()==SCRBTN_PUSH)	{ dJD = -1; }
	if (btn[BTN_R1].value || sbTimePlus.GetState() ==SCRBTN_PUSH)	{ dJD =  1; }
	if (dJD!=0) {
		flg = true;
		bMotion = true;	//*****************
		
		UTC utc = JD_to_UTC( get_time_JD() );
		switch (tyTimeStep) {
			case TIMESTEP_10SEC:	utc.sec		+= 10*dJD;	break;
			case TIMESTEP_MIN:		utc.min		+= dJD;		break;
			case TIMESTEP_10MIN:	utc.min		+= 10*dJD;	break;
			case TIMESTEP_HOUR:		utc.hour	+= dJD;		break;
			case TIMESTEP_DAY:		utc.day		+= dJD;		break;
			case TIMESTEP_WEEK:		utc.day		+= 7*dJD;	break;
			case TIMESTEP_MONTH:	utc.month	+= dJD;		break;
			case TIMESTEP_YEAR:		utc.year	+= dJD;		break;
			case TIMESTEP_10YEAR:	utc.year	+= 10*dJD;	break;
			case TIMESTEP_100YEAR:	utc.year	+= 100*dJD;	break;
			default:										break;
		}
		OnRealTimeMode(false);
		OnChangeTime( UTC_to_JD(utc) );
	}

	return flg;
}



bool
InputSetting(button_state* btn, axis_state* axi)
{
	// ~{^𗣂Ɛݒ胂[hI
	if (!btn[BTN_CRS].value)	{
		OnLeaveSettingMode();
		return  true;
	}

	//-- ς
	char dTS = 0;
	if (btn[BTN_L1].value && btn[BTN_L1].bToggle)	{ dTS = -1; }
	if (btn[BTN_R1].value && btn[BTN_R1].bToggle)	{ dTS =  1; }
	if (dTS != 0) {
		if (chSettingModeDisp != SETTING_MODE_DATE) {
			OnSettingModeDisp(SETTING_MODE_DATE);
		}

		char TS = tyTimeStep + dTS;
		if (TS < 0)					{ TS = 0; }
		if (TS > TIMESTEP_100YEAR)	{ TS = TIMESTEP_100YEAR; }
		if (TS != tyTimeStep) {
			OnTimeStep(TS);
		}

		return  true;
	}


	//-- ς
	const float dd = 0.1;
	const float d_default = 6.4f;
	const float d_old = get_eye_distance_2();
	float d = d_old;
	if (btn[BTN_L2].value && btn[BTN_L2].bToggle)	{ d -= dd; }
	if (btn[BTN_R2].value && btn[BTN_R2].bToggle)	{ d += dd; }
	if (btn[BTN_L2].value && btn[BTN_R2].value)		{ d = d_default; }
	if (fabs(d-d_old) > 1e-5) {
		if (chSettingModeDisp != SETTING_MODE_EYE_DISTANCE) {
			OnSettingModeDisp(SETTING_MODE_EYE_DISTANCE);
		}

		OnChangeEyeDistance(d);
		return  true;
	}



	//-- ĩgO
	if (btn[BTN_SQR].value && btn[BTN_SQR].bToggle) {
		OnDispSwitchToggle(DISPSW_PLANET, DISPM_CITY_LIGHTS);
		return  true;
	}


	//-- g嗦ς
	int  x   = axi[0].value;
	if (x != 0) {
		char mode = get_zoom_mode();
		if (x > 0 && axi[0].bToggle) { 
			mode--;
			if (mode >= 0)	{ OnZoomMode(mode); return true; }
		}
		if (x < 0 && axi[0].bToggle) { 
			mode++;
			if (mode <= 3)	{ OnZoomMode(mode); return true; }
		}
	}

	return false;
}




bool
InputMenu(button_state* btn, axis_state* axi)
{
	menu&  mnu = *mnuSelect.back();


	//-- Process input
	if (btn[BTN_CIR].value && btn[BTN_CIR].bToggle)							{ OnExecMenu();		return true; }
	if (btn[BTN_CRS].value && btn[BTN_CRS].bToggle)							{ OnCloseMenu();	return true; }
	

	//-- Axes
	bool flg = false;
	int pos = mnu.get_current_pos();

	// グ
	if ((axi[1].value<0 && axi[1].bToggle) || (btn[BTN_UP].value && btn[BTN_UP].bToggle)) {
		pos--;
		if (pos < 0) pos=mnu.size()-1;
		OnMenuPos(pos);
		flg=true; 
		bMotion = true;	//*****************
	}

	// 
	if ((axi[1].value>0 && axi[1].bToggle) || (btn[BTN_DOWN].value && btn[BTN_DOWN].bToggle)) {
		pos++;
		if (pos>=mnu.size())  pos=0;
		OnMenuPos(pos);
		flg=true;
		bMotion = true;	//*****************
	}


	//-- Axes
	float x;
	x = 0;
	x   = axi[3].get_normalized_value();
	if (x != 0) {
		OnMenuAngle(menu_angle + 0.5*x);
		flg = true;
		bMotion = true;	//*****************
	}



	return flg;
}


bool
InputPointer(button_state* btn, axis_state* axi)
{
	// Select{^: |C^[h̏I
	if (btn[BTN_SELECT].value && btn[BTN_SELECT].bToggle)		{ OnPointerMode(false); return true; }
	if (btn[BTN_CRS].value && btn[BTN_CRS].bToggle)				{ OnPointerMode(false);	return true; }



	//-- Axes
	float x, y, z;
	x   = axi[0].get_normalized_value();
	y   = axi[1].get_normalized_value();
	z   = axi[2].get_normalized_value();
	bool flg = false;

	if (x != 0) {
		pointer_angle_x +=  0.7*x;
		flg = true;
	}
	if (y != 0)  {
		pointer_angle_y += -0.7*y;
		flg = true;
	}
	if (z != 0)  {
		pointer_z -= 10*z;
		if (pointer_z < 1.5*z_near) pointer_z = 1.5*z_near;
		flg = true;
	}

	static	float pos[3];
	if (flg) {
		pos[0] = pointer_angle_x;
		pos[1] = pointer_angle_y;
		pos[2] = pointer_z;
		OnPointerPos(pos);
	}


	return flg;
}



bool
InputTitle(button_state* btn, axis_state* axi)
{
	// {^
	if (btn[BTN_CIR].value && btn[BTN_CIR].bToggle)	{
		OnNextTitlePage();	return true;		// ^Cgy[Wi߂
	}

	// ~{^i^Cgy[W̃LZj
	if (btn[BTN_CRS].value && btn[BTN_CRS].bToggle)	{
		OnTitlePageMode(false);	return true;
	}

	return false;
}




bool
InputImage(button_state* btn, axis_state* axi)
{
	if (btn[BTN_CIR].value && btn[BTN_CIR].bToggle)		{ OnImageClose();	return true; }
	if (btn[BTN_CRS].value && btn[BTN_CRS].bToggle)		{ OnImageClose();	return true; }
	

	bool flg = false;

	
	//-- Axes
	float x;
	x = 0;
	x   = axi[3].get_normalized_value();
	if (x!=0 && IMGF[current_image_index].type!=MEDIATYPE_POPUP_IMAGE) {
		OnMenuAngle(menu_angle + 2*x);
		flg = true;
		bMotion = true;	//*****************
	}
	

	return flg;
}



bool
Input3DChart(button_state* btn, axis_state* axi)
{
	if (btn[BTN_CIR].value && btn[BTN_CIR].bToggle)		{ OnClose3DChart();	return true; }
	if (btn[BTN_CRS].value && btn[BTN_CRS].bToggle)		{ OnClose3DChart();	return true; }
	

	bool flg = false;

	
	//-- Axes
	float x;
	x = 0;
	x   = axi[3].get_normalized_value();
	if (x != 0) {
		OnMenuAngle(menu_angle + 2*x);
		flg = true;
		bMotion = true;	//*****************
	}
	

	return flg;
}


void
InputMovie(button_state* btn, axis_state* axi)
{
	// Cross button
	if (btn[BTN_CRS].value && btn[BTN_CRS].bToggle)	{
		OnMovieClose();
		OnCommandDraw();
		return;
	}


	// Circle button
	if (btn[BTN_CIR].value && btn[BTN_CIR].bToggle)	{
		if (bMoviePlaying)		{ OnMoviePauseControler(); }
		else					{ OnMoviePlay(); }
	}




	if (!bMoviePlaying) {
		// L2/R2 button
		if (btn[BTN_L2].value)	{ OnMovieHome(); }
		if (btn[BTN_R2].value)	{ OnMovieEnd(); }


		// Movie position
		LONGLONG  pos, end_pos, dpos;
		pos		= dsmv.get_position();
		end_pos = dsmv.get_end_position();
		dpos = 0;


		// L1/R1 button
		bool bL1, bR1;
		bL1 = btn[BTN_L1].value && btn[BTN_L1].bToggle;
		bR1 = btn[BTN_R1].value && btn[BTN_R1].bToggle;
		if (bL1 || bR1) {
			LONGLONG	dpos0 = end_pos / 10;
			if (bL1)	dpos = -dpos0;
			if (bR1)	dpos =  dpos0;
		}

		// axis
		if (axi[3].value != 0 && axi[3].bToggle) {
			dpos	= end_pos / 50;
			if (axi[3].value < 0)  dpos=-dpos;
		}

		if (dpos!=0) {
			pos+=dpos;
			if (pos<0)			{ pos=0; }
			if (pos>end_pos)	{ pos=end_pos; }
			OnMovieSetPosition(pos);
		}
	}
}






void
Input()
{
	//
	bPrevMotion = bMotion;
	bMotion = false;
	ResetInputForces();

	if (!bActive)  return;

	// WCXeBbN̏Ԃ擾
	update_joystick_state();
	button_state*	btn = get_joystick_button_state();
	axis_state*		axi = get_joystick_axis_state();


	if      (bMovieMode)	{
		InputMovie(btn, axi);
		bool flg = ProcessMovement();
		if (flg) {
			OnCommandDraw();
		}

		return;
	}

	bool flg = false;
	switch (tySubMode) {
		case SUBMODE_MENU:		flg = InputMenu(btn, axi);		break;
		case SUBMODE_TITLE:		flg = InputTitle(btn, axi);		break;
		case SUBMODE_POINTER:	flg = InputPointer(btn, axi);	break;
		case SUBMODE_IMAGE:		flg = InputImage(btn, axi);		break;
		case SUBMODE_3DCHART:	flg = Input3DChart(btn, axi);	break;
		case SUBMODE_SETTING:	flg = InputSetting(btn, axi);	break;
		case SUBMODE_NORMAL:
		default:				flg = InputNormal(btn, axi);	break;
	}


	bool  flg2;
	flg2 = ProcessMovement();


	//-- Update Window
	if (flg || flg2 || (bPrevMotion && !bMotion)) { 
		OnCommandDraw();
	}
}





//----------------
//  Update state
//----------------
void
OnCommandNone()
{
}



void
OnUpdateView(view_info* pVwif)
{
	vector3d& r = pVwif->frm.r;
	g_camera.set_ori( pVwif->qm );

	adjust_target_position();
}

void
OnUpdateView2(view_info2* pVwif2)
{
	set_plnt_long( pVwif2->lon );
	set_plnt_lati( pVwif2->lat );
}



void
OnTCPCommand(char cmd)
{
	switch (cmd) {
		case COMMAND_SIGNAL:		OnCommandSignal();		break;
		case COMMAND_DRAW_LOWRES:	OnCommandDraw_LowRes();	break;
		case COMMAND_DRAW_HIGHRES:	OnCommandDraw_HighRes();break;
		case COMMAND_SETTING_ENTER:	OnEnterSettingMode();	break;
		case COMMAND_SETTING_LEAVE:	OnLeaveSettingMode();	break;
		case COMMAND_MENU_ENTER:	OnEnterMenu();			break;
		case COMMAND_MENU_CLOSE:	OnCloseMenu();			break;
		case COMMAND_MENU_EXEC:		OnExecMenu();			break;
		case COMMAND_EXIT_ALL:		OnExitAll();			break;
		case COMMAND_MOVIE_CLOSE:	OnMovieClose();			break;
		case COMMAND_MOVIE_PLAY:	OnMoviePlay();			break;
		case COMMAND_MOVIE_HOME:	OnMovieHome();			break;
		case COMMAND_MOVIE_END:		OnMovieEnd();			break;
		case COMMAND_IMAGE_CLOSE:	OnImageClose();			break;
		case COMMAND_3DCHART_CLOSE:	OnClose3DChart();		break;
		case COMMAND_CAPTURE_IMAGE:	OnCaptureImage();		break;
		case COMMAND_TAKEOFF:		OnTakeoff();			break;
		case COMMAND_LANDING:		OnLanding();			break;
		case COMMAND_LANDING_INIT:	OnLandingInit();		break;
		default:											break;
	}
}



void
OnDataChar(char type, char val)
{
	switch (type) {
		case DATA_CHAR_STEREO:		OnStereo(val);						break;
		case DATA_CHAR_SETTING_DISP:OnSettingModeDisp(val);				break;
		case DATA_CHAR_PROGRAM:		OnProgram(val);						break;
		case DATA_CHAR_TARGET:		OnTarget(val);						break;

		case DATA_CHAR_ECLIPSE:			OnEclipse(val);					break;
		case DATA_CHAR_STAR:			OnStar(val);					break;
		case DATA_CHAR_STAR_MARK:		OnStarMark(val);				break;	//****
		case DATA_CHAR_CONSTELLATION:	OnConstellation(val);			break;	
		case DATA_CHAR_GALAXY:			OnGalaxy(val);					break;
		
		case DATA_CHAR_ATMOSPHERE_MODE:	OnPlanetAtmosphere(val);		break;
		case DATA_CHAR_ZOOM_MODE:		OnZoomMode(val);				break;
		case DATA_CHAR_TOPO_ZOOM_MODE:	OnTopoZoomMode(val);			break;
		case DATA_CHAR_LANDING_MODE:	OnLandingMode(val);				break;
		
		case DATA_CHAR_OORT_CLOUD:		OnOortCloud(val);				break;
		
		case DATA_CHAR_VIRGO_CLUSTER:		OnMarkVirgoCluster(val);	break;

		case DATA_CHAR_MILKYWAY:	OnMilkyWay(val);					break;

		case DATA_CHAR_CLST_GLD:	OnCelestialGrid(val);				break;
		case DATA_CHAR_ECLIPTIC:	OnEcliptic(val);					break;
		case DATA_CHAR_HORIZON_COORD:	OnHorizonCoord(val);			break;
		case DATA_CHAR_GLX_GLD:		OnGalacticGrid(val);				break;
		case DATA_CHAR_DIST_SCALE:	OnDistScale(val);					break;
		
		case DATA_CHAR_NGC:			OnNGC(val);							break;

		case DATA_CHAR_SIDE_LIGHT:	OnSideLight(val);					break;
		case DATA_CHAR_SURFACE_POINTER:	OnSurfacePointer(val);			break;

		case DATA_CHAR_DATE:			OnDate(val);					break;
		case DATA_CHAR_TIMESTEP:		OnTimeStep(val);				break;
		case DATA_CHAR_REALTIME_MODE:	OnRealTimeMode(val);			break;

		case DATA_CHAR_LANG:		OnLang(val);						break;

		case DATA_CHAR_TEST:		OnTest(val);						break;

		case DATA_CHAR_SUBMODE_POINTER:	OnPointerMode(val);				break;
		case DATA_CHAR_3DCHART:		OnOpen3DChart(val);					break;

		case DATA_CHAR_SUBTITLES:	OnSubtitles(val);					break;
		case DATA_CHAR_TITLE:		OnTitle(val);						break;
		case DATA_CHAR_ABOUT:		OnCheckAbout(val);					break;
		case DATA_CHAR_DEBUG:		OnDebug(val);						break;
		case DATA_CHAR_KEY_HELP:	OnKeyHelp(val);						break;
		case DATA_CHAR_SINGLE_EYE:	OnSingleEye(val);					break;

		case DATA_CHAR_PATH_INFO:	OnPathInfo(val);					break;

		case DATA_CHAR_ANIM_TYPE:	OnAnimType(val);					break;
		
		case DATA_CHAR_TITLE_MODE:	OnTitlePageMode(val);				break;
		case DATA_CHAR_TITLE_PAGE:	OnTitlePage(val);					break;

		case DATA_CHAR_MENU_POS:	OnMenuPos(val);						break;
		default:														break;
	}
}


void
OnDataSwitch(char type, char idx, char val)
{
	switch (type) {
		case DATA_SWITCH_DISP:		OnDispSwitch(idx, val);		break;

		default:												break;
	}
}


void
OnDataInt(int_packet *pintp)
{
	switch (pintp->type) {
		case DATA_INT_ANIM_COUNTER0:	OnAnimationCounter0(pintp->val);	break;
		case DATA_INT_ANIM_COUNTER:		OnAnimation(pintp->val);			break;
		case DATA_INT_SUBTITLES_INDEX:	OnChangeSubtitlesIndex(pintp->val);	break;
		default:															break;
	}
}


void
OnDataFloat(float_packet *pflp)
{
	switch (pflp->type) {
		case DATA_FLOAT_MAG:				OnSetLRef(pflp->val);			break;
		case DATA_FLOAT_PLNT_ANGLE:			OnPlanetariumAngle(pflp->val);	break;
		case DATA_FLOAT_MENU_ANGLE:			OnMenuAngle(pflp->val);			break;
		case DATA_FLOAT_MENU_FADE_FACTOR:	OnMenuFade(pflp->val);			break;
		case DATA_FLOAT_MOVIE_FADE_ALPHA:	OnMovieFade(pflp->val);			break;
		case DATA_FLOAT_SCREEN_ALPHA:		OnScreenAlpha(pflp->val);		break;
		case DATA_FLOAT_FONT_SIZE:			OnSetFontSize(pflp->val);		break;
		case DATA_FLOAT_EYE_DISTANCE:		OnChangeEyeDistance(pflp->val);	break;
		default:														break;
	}
}


void
OnDataDouble(double_packet *pdblp)
{
	switch (pdblp->type) {
		case DATA_DOUBLE_ZOOM_FACTOR:	OnSetZoom(pdblp->val);		break;
		case DATA_DOUBLE_JD:			OnChangeTime(pdblp->val);	break;
		default:													break;
	}
}


void
OnDataVector3f(vector3f_packet *pv3fp)
{
	switch (pv3fp->type) {
		case DATA_VECTOR3F_TARGET_POS:	OnChangeTargetPos(pv3fp->val);		break;
		default:															break;
	}
}


void
OnDataLONGLONG(LONGLONG_packet *pllp)
{
	switch (pllp->type) {
		case DATA_LONGLONG_MOVIE_POS:	OnMovieSetPosition(pllp->val);		break;
		default:															break;
	}
}

void
OnDataCustom(char* pBuf)
{
	const char  idx   = pBuf[0];
	const char* pData = pBuf+1;

	switch (idx) {
		case DATA_CUSTOM_POINTER_POS:		OnPointerPos((const float*)(pData));			break;
		case DATA_CUSTOM_SPACECRAFT_PATH:	OnSpacecraftPath(pData[0], bool(pData[1]));		break;
		case DATA_CUSTOM_BASE_ORI:			OnBaseCameraOri(*(quaterniond*)(pData));		break;
		default:																			break;
	}
}



void
OnTarget2(int tgt_no)
{
	if (tyMode != MODE_HIPPARCOS) return;

	OnTarget(tgt_no);
}











//----------------
//  L[͂̏
//----------------
int
OnKeyDown(HWND hWnd, WPARAM wParam)
{
	// [r[쐬[hp
	if (bEnableMovieMake) {
		switch (wParam) {
			case 'M':			InitRecordingMovie();						return 0;
			case VK_NUMPAD6:	OnChangeCurrentFrame(current_frame + 1);	return 0;
			case VK_NUMPAD4:	OnChangeCurrentFrame(current_frame - 1);	return 0;
			case VK_NUMPAD5:	OnLoadFrame();								return 0;
			case VK_NUMPAD1:	OnChangeFrameInterval(-1);					return 0;
			case VK_NUMPAD3:	OnChangeFrameInterval( 1);					return 0;
			case VK_NUMPAD2:	OnChangePathType();							return 0;
			case VK_NUMPAD0:	OnSetFrame();								return 0;
			case VK_NUMPAD7:	OnInsertFrame();							return 0;
			case VK_NUMPAD9:	OnDeleteFrame();							return 0;
			default:														break;
		}
	}

	switch (wParam) {
		case 'C':	OnCaptureImage();									return 0;

		case 'L':
			{
				OnDispSwitchToggle( DISPSW_PLANET, DISPM_CITY_LIGHTS );
				OnCommandDraw();
			}
			return  0;



		case 'F':
			bFPS = !bFPS;
			OnCommandDraw();
			return 0;


		case VK_F1:
			OnKeyHelp(!bKeyHelp);
			OnCommandDraw();
			return 0;

		case VK_ESCAPE:
			if (bFullScreen) {
				OnFullScreen(false);
			} else {
				const char lang = get_language();
				if (lang == LANG_ENG) {
					if (MessageBoxf(hWnd, "Exit", MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2, "Are you sure you want to quit %s?", szAppName) == IDYES) {
						SendMessage(hWnd, WM_CLOSE, 0, 0);
					}
				} else {
					if (MessageBoxf(hWnd, "I̊mF", MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2, "%s IĂ낵łH", szAppName) == IDYES) {
						SendMessage(hWnd, WM_CLOSE, 0, 0);
					}
				}
			}
			return 0;
		default:														break;
	}

	return 1;
}





//----------------
//  ̓ǂݍ
//----------------
void
load_subtitles()
{
	vSubtitles.clear();

	FILE* fp;
	if ((fp=fopen("subtitles.txt", "rt")) == NULL)  return;

	while (true) {
		// 1ǂ
		string str;
		char ch;

		while (true) {
			char ch2;
			
			ch = getc(fp);
			if (ch==EOF)  break;

			if (_ismbblead(ch)) {
				ch2 = getc(fp);
				if (ch2 == EOF)  {
					ch = EOF;
					break;
				}
				str.push_back(ch);
				str.push_back(ch2);
				continue;
			}

			if (ch=='\\') {
				ch2 = getc(fp);
				if (ch2 == '@')  break;
				str.push_back(ch);
				str.push_back(ch2);
				continue;
			}

			str.push_back(ch);
		}

		if (str.size() > 0) {
			vSubtitles.push_back( gltext(str.c_str()) );
			str.clear();
		}

		if (ch == EOF)  break;
	}

	fclose(fp);
}




//-------------------
//  QdÑ`FbN
//-------------------
bool
check_multiple_launch()
{
	// ~[ebNX쐬
	HANDLE hMutex;
	hMutex = CreateMutex(NULL, TRUE, "MitakaMutexObject");

	// 쐬Ɏsꍇ
	if (!hMutex)	return false;

	// łɋNĂꍇ
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
		// EBhEOɎĂ
		HWND  hWnd0;
		if((hWnd0 = FindWindow(szAppName,NULL)) != NULL) {
		    ShowWindow(hWnd0,SW_RESTORE);  //EChEANeBuɂ
		    SetForegroundWindow(hWnd0);    //EChEɃtH[JXڂ
		}

		return false;
	}

	return true;
}





//===========
//  WinMain
//===========
int WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR lpCmdLine, int iCmdShow )
{
	init_cpu_info();
 

	//---------------------
	//  Rs[^̎擾
	//---------------------
	char computer_name[MAX_COMPUTERNAME_LENGTH +1];
	DWORD len =	MAX_COMPUTERNAME_LENGTH +1;

	GetComputerName(computer_name, &len);


	//-----------------------
	//  ݒt@C̓ǂݍ
	//-----------------------
	init_directory();
	load_ini_file(computer_name);



	//--------------
	//  dNh~
	//--------------
	if (!bMultipleLaunch) {
		if ( !check_multiple_launch() )  return FALSE;
	}



	//----------------
	//  ̑̏
	//----------------
	//  ^Cg쐬
	sprintf(szTitle, "%s  Ver.%s", szAppName, szVersion);
	//  J[\ݒ
	hCursorArrow = LoadCursor(NULL , IDC_ARROW);



	//========
	//  Main
	//========
	if (bNetwork)	{ Main_NetworkMode(hInstance, iCmdShow); }
	else			{ Main_WindowMode( hInstance, iCmdShow); }



	//------------
	//  Clean-up
	//------------

	//-- [̉
	free_memory_for_galaxy();
	free_multiple_scattering_work();


	//-- j[̔j
	destroy_menu_bar();



	if (bControler || !bNetwork) {
		// DirectShow
		dsmv.close();
		CoUninitialize();
	}



	// XN[Z[o[Iilbg[N[h̏ꍇj
	if (bNetwork)	SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, TRUE,  NULL, SPIF_SENDCHANGE);	// I


	//--  CoUninitialize I܂ő҂  --
	if (bTimer) {
		while (!bKillTimer) {
			Sleep(5);
		}
	}



	return 0;
}
